//not only header:
//some common utility funcs are defined
//include this file once after the other header

//recommendable: enable warnings w8070 w8072 w8075

const double doublemax = std::numeric_limits < double >::max()/1000.0;
const double double_epsilon = std::numeric_limits < double >::epsilon();
//const double double_eps1000 = std::numeric_limits < double >::epsilon()*1000.0;
const double deps = std::numeric_limits < double >::epsilon()*100.0;
//const float float_epsilon = std::numeric_limits < float >::epsilon();
//const float float_eps10 = std::numeric_limits < float >::epsilon()*10.0;
const float feps = std::numeric_limits < float >::epsilon()*10.0;
const int intmax = std::numeric_limits < int >::max();
const int intmin = std::numeric_limits < int >::min();
const int noindex=-128;

inline double littlegr(const double &x) {return x==0?deps:x+fabs(deps*x);}
inline float littlegr(const float &x) {return x==0?feps:x+fabs(feps*x);}
inline double littlesm(const double &x) {return x==0?-deps:x-fabs(deps*x);}
inline float littlesm(const float &x) {return x==0?-feps:x-fabs(feps*x);}

typedef AnsiString AS;
const AS NullString = "";
const AS aspace = " ";
AS FS(long double x, int precision=-1234)
{if (precision<=0) {precision=7; if (x!=0&&fabs(x)<deps) return x<0?"-0":"+0";}
	return FloatToStrF(x,ffGeneral, precision, precision);}//also for int ok
AS ES(const long double &x, const int &precision=77)//ES: "ExactString
{return FloatToStrF(x,ffGeneral, precision, precision);}

AS FSS(const long double &x, const int &precision=7)//with trailing spaces, that lengh constant
{AS s=FloatToStrF(x,ffGeneral, precision, precision);
	int minlen=precision+2;
	if (x>=0) s=" "+s; while (s.Length()<minlen) s+=" "; return s;}
AS FSR(const long double &x, const int &precision=7)//with leading spaces, that lengh constant
{AS s=FloatToStrF(x,ffGeneral, precision, precision);
	int minlen=precision+2;
	if (x>=0) s=" "+s; while (s.Length()<minlen) s=" "+s; return s;}

typedef unsigned int size_type;

class w_exception:public exception {
	AS str;
	public:
	w_exception(const AS& message):str(message){};
	const char* what() const throw(){return str.c_str(); }
};

void meld(const AS& s) {ShowMessage(s);}
void dummy(){};

bool throw_instead_pip=false;
void pip(const AS& s){Beep();
	if (throw_instead_pip) throw w_exception(s);
	else ShowMessage(s);}

void pipex(AS s){pip(s); exit(0);}
void nimsg() {pip("Not yet implemented");}//NotImplementedMsg

typedef enum{wl_min, wl_beep, wl_usual, wl_all, wl_rem, wl_up} Warnlevel;
//wl_rem: also remarks
AS change_warnlevel_string=
"Here you can change the warnlevel:\n  "
+AS(wl_min)+": Only errors and essential warnings\n  "
+AS(wl_beep)+": Additionally beeps on all warnings\n  "
+AS(wl_usual)+": Additionally usual warnings\n  "
+AS(wl_all)+": All warnings\n  "
+AS(wl_rem)+": All warnings and remarks\nare displayed.\n\n"
"To change the warnlevel wl to a new integer i";
#ifdef wdebug
Warnlevel warnlevel=wl_usual;//wl_all;
#else
	Warnlevel warnlevel=wl_usual;
#endif

void warn(Warnlevel wl, const AS& s)
	//wl=0 is the same as pip
{
	if (warnlevel>=wl) pip(s); else
		if (warnlevel>=wl_beep) Beep();
}
//-------
const AS NoTextChangeKeys = "\t\r";//for KeyPressed
const AS intRegularInput = "1234567890+-\t\b";
const AS noname="noname";
//------config

struct MMI
{
	int i; //value
	int min;
	int max;
	AS description;
	bool ucfg;//"default_config_enalbed:
	//true, if changed during read of config, e.g. from wqpcfg.aa1
};

typedef map < AS, MMI > Kmap; //Keymap
typedef Kmap::iterator Kmapi;
typedef Kmap::const_iterator const_Kmapi;
typedef pair < AS, MMI > Kpair;
//-----end config
//---- begin str

#if 0
AS StrAfterLast(const AS& s, const AS& delimiters)
	//return AS after last of one of chars in delimiters
	//return full string, if there is no match
{
	int ld = s.LastDelimiter(delimiters);
	return s.SubString(ld + 1, s.Length() - ld);
}
#endif

AS LowStrAfterLast(const AS& s, const AS& delimiters)
	//return AS after last of one of chars in delimiters
	//return full string, if there is no match
{
	int ld = s.LastDelimiter(delimiters);
	return s.SubString(ld + 1, s.Length() - ld).LowerCase();
}

AS LowStrBeforeLast(const AS& s, const AS& delimiters)
	//return AS before last of one of chars in delimiters
	//return full string, if there is no match
{
	int ld = s.LastDelimiter(delimiters);
	if (ld)
		return s.SubString(1,ld - 1).LowerCase();
	else
		return s.LowerCase();
}

AS fn_end(const AS &fnfull) {return LowStrAfterLast(fnfull, ".");}
AS fn_start(const AS &fnfull) {return LowStrBeforeLast(fnfull, ".");}

//---- end str
//begin integer IO ------------------
//delimiter between integers is ","

//bool value not ok for TryStrToInt, therefore
bool TryStrToInt(const AnsiString S, bool &Value)
{	pip("TryStrToInt was called with bool.\n"
	"Use TryStrToBool!");
	return TryStrToBool(S,Value);}

bool TryStrTo2Int(const AS& s, int& a, int& b)
{
	int p = s.Pos(",");
	int len = s.Length();
	AS sa = s.SubString(1, p - 1);
	AS sb = s.SubString(p + 1, len - p);
	return TryStrToInt(sa, a) && TryStrToInt(sb, b);
}

bool TryStrTo3Int(const AS& s, int& a, int& b, int& c)
{
	int p1 = s.Pos(",");
	AS sa = s.SubString(1, p1 - 1);
	
	int len_stmp = s.Length() - p1;
	AS stmp = s.SubString(p1 + 1, len_stmp);
	
	int p2 = stmp.Pos(",");
	AS sb = stmp.SubString(1, p2 - 1);
	AS sc = stmp.SubString(p2 + 1, len_stmp - p2);
	
	return TryStrToInt(sa, a) &&
	TryStrToInt(sb, b) && TryStrToInt(sc, c);
}


bool YesToQuestion(const AS& text)
{
	int tnr = MessageDlg (text,
	mtConfirmation, TMsgDlgButtons () << mbYes << mbNo, 0);
	return (tnr == mrYes);
}

bool Input_abc_3(int& a, int& b, int &c,
const AS& headline, const AS& text,
const AS& edittext = NullString)
{
	bool ok, syntax_ok;
	do
	{
		AS s = edittext;
		ok = InputQuery (headline, text +
		"\nenter the three integers   a,b,c", s);
		syntax_ok = TryStrTo3Int(s, a, b, c);
		if (ok && !syntax_ok)
			Beep();
	}
	while (ok && !syntax_ok);
	return ok;
}

bool Input_ab_2(int& a, int& b,
const AS& headline, const AS& text,
const AS& edittext = NullString)

{
	bool ok, syntax_ok;
	do
	{
		AS s = edittext;
		ok = InputQuery (headline, text +
		"\nenter the two integers   a,b", s);
		syntax_ok = TryStrTo2Int(s, a, b);
		if (ok && !syntax_ok)
			Beep();
	}
	while (ok && !syntax_ok);
	return ok;
}

bool Input_a_1(int& a,
const AS& headline, const AS& text,
const AS& edittext = NullString)

{
	bool ok, syntax_ok;
	do
	{
		AS s = edittext;
		ok = InputQuery (headline, text +
		"\nenter integer a", s);
		syntax_ok = TryStrToInt(s, a);
		if (ok && !syntax_ok)
			Beep();
	}
	while (ok && !syntax_ok);
	return ok;
}

AS FullDescriptionFromMappedKeyVal(const MMI& mmi)
	//return description with min max info
{
	if (mmi.min == intmin)
	{
		if (mmi.max == intmax)
			return mmi.description;
		else // max relevant
		return mmi.description + " [i<=" + AS(mmi.max) + "]";
	}
	else //min relevant
	if (mmi.max == intmax)
		return mmi.description + " [" + AS(mmi.min) + "<=i]";
	else//min and max relevant
	return mmi.description + " [" + AS(mmi.min)
		+ "<=i<=" + AS(mmi.max) + "]";
}


bool Input_i_of_mmi_1(MMI& mmi_org,
const AS& headline, const AS& text = NullString,
const AS& edittext = NullString)
//input mmi.i between mmi.min and mmi.max; mmi.description is ignored
{
	MMI mmi=mmi_org;//don't change description
	mmi.description=NullString;
	bool ok, valid_input, do_again;
	do
	{
		AS s = edittext==NullString?AS(mmi.i):edittext;
		ok = InputQuery (headline, text +
		"\nenter integer i "
		+FullDescriptionFromMappedKeyVal(mmi), s);
		valid_input = TryStrToInt(s, mmi.i);
		if (valid_input)
		{
			if (mmi.i<mmi.min)
			{
				valid_input = false;
				mmi.i=mmi.min;
			}
			else
				if (mmi.i>mmi.max)
				{
					valid_input = false;
					mmi.i=mmi.max;
				}
		}
		do_again = (ok && !valid_input);
		if (do_again) Beep();
	}
	while (do_again);
	if (ok)
		mmi_org.i=mmi.i;
	return ok;
}

//end integer IO ------------------

void ChangeWarnLevel()
{
	MMI mmi;
	mmi.i = warnlevel;
	mmi.min=wl_min;
	mmi.max=wl_up-1;
	if (Input_i_of_mmi_1(mmi, "Change warnlevel wl",
	change_warnlevel_string
	+"To change the warnlevel wl to a new integer i"))
	warnlevel=mmi.i;
}

AS CutTillSpaceOrEnd_1(AS& s)
	//comfortable, but slow; don't use it in long loops
{
	s = s.Trim();
	int spacepos = s.Pos(aspace);
	if (!spacepos)//if cut till end
	{
		AS s1 = s;
		s = NullString;
		return s1;
	}
	AS s_before_cut = s.SubString(1, spacepos);
	s.Delete(1, spacepos);
	s = s.TrimLeft(); //TrimRight already done by Trim
	return s_before_cut.TrimRight(); //TrimLeft already done by Trim
}

//----------
template < typename T >
bool equal(T& x, T& y) {return memcmp(&x,&y,sizeof(x))==0;}

//------ begin image util
void ClearImage(TImage* Gimage, bool cblack)
{
	TColor PenOld = Gimage->Canvas->Pen->Color;
	if (cblack)
	{
		Gimage->Canvas->Brush->Color = clBlack;
		Gimage->Canvas->Pen->Color = clBlack;
	}
	else
	{
		Gimage->Canvas->Brush->Color = clWhite;
		Gimage->Canvas->Pen->Color = clWhite;
	}
	Gimage->Canvas->Rectangle
	(0, 0, Gimage->ClientWidth, Gimage->ClientHeight);
	Gimage->Canvas->Pen->Color = PenOld;
}

void resize_bitmap_image(TImage *img, int width, int height)
{
	//resize of image underlying bimap necessary:
	img->Picture->Bitmap->Width = width;
	img->Picture->Bitmap->Height = height;
	
	img->Width = width; //resize image
	img->Height = height;
}

//------- worldpar up to 22.3.2005 not used in wqp
const int iup2d=2;//[0]=x, [1]=y
typedef double double2d[iup2d];
typedef int int2d[iup2d];

class worldpar
{
	TCanvas *canvas;
	double2d min;
	double2d pix_per_1;//in case of y pixel per delta_index=1
	//if pix_per_1[1] negative, pixo[1] should be max (bottom)
	int2d pixo;//pixel_offset (for this graph)
	
	int xpix(double &x);
	int ypix(double &y);
	
	public:
	worldpar(TCanvas *cv,int2d pixoq, double2d minq, double2d pix_per_1q);
	void line(double &x0, double &y0, double &x1, double &y1);
	void drawtext(double &x0, double &y0, const AS &s);
	void brushrectangle(double &x0, double &y0_org, double &x1, double &y1_org);
	void rect(double &x0, double &y0, double &x1, double &y1,
	TColor &color, TBrushStyle &style);
};

worldpar::worldpar(TCanvas *cv,int2d pixoq, double2d minq, double2d pix_per_1q)
{canvas=cv;
	for (int i=0; i<iup2d;++i)
	{pixo[i]=pixoq[i];
		min[i]=minq[i];pix_per_1[i]=pix_per_1q[i];}
}

int worldpar::xpix(double &x)
{return pixo[0]+(x-min[0])*pix_per_1[0];}
int worldpar::ypix(double &y)
{return pixo[1]+(y-min[1])*pix_per_1[1];}

void worldpar::line(double &x0, double &y0, double &x1, double &y1)
{
	canvas->MoveTo(xpix(x0), ypix(y0));
	canvas->LineTo(xpix(x1), ypix(y1));
}

void worldpar::brushrectangle(double &x0, double &y0, double &x1, double &y1)
	//diagonal of horizontal rectangle is line form x0,y0 to x1,y1
{canvas->FillRect(TRect(xpix(x0), ypix(y0), xpix(x1), ypix(y1)));//sort not necessary
}

void worldpar::rect(double &x0, double &y0, double &x1, double &y1,
TColor &color, TBrushStyle &style)
{
	TBrushStyle styleold=canvas->Brush->Style;
	TColor colorold=canvas->Brush->Color;
	canvas->Brush->Style=style;
	canvas->Brush->Color=color;
	brushrectangle(x0,y0,x1,y1);
	canvas->Brush->Style=styleold;
	canvas->Brush->Color=colorold;
}

void worldpar::drawtext(double &x0, double &y0, const AS &s) {canvas->TextOut(xpix(x0), ypix(y0), s);}

//----------------
//useful for concise gridlabels in case of few internal decimal places:
void RoundUp1Decimalp_1(double& x, const double dx)
{
	if (fabs(dx) > 0.4)
		x = ceil(x);
	else
		if (fabs(dx) > 0.04)
			x = ceil(10.0*x)/10.0;
	// else UpRoundToOneDigit_1(x);
}
void RoundDown1Decimalp_1(double& x, const double dx)
{
	if (fabs(dx) > 0.4)
		x = floor(x);
	else
		if (fabs(dx) > 0.04)
			x = floor(10.0*x)/10.0;
	// else DownRoundToOneDigit_1(x);
}
//-------------------
//------ end image util

void SignalOpenErr(AS &fn)
{pip("Error opening\n"+GetCurrentDir()+"\\"+fn);}

//----- begin CompilationDate
//MmmStr def. must be before(!) def. of CompilationDateClass:
const AS MmmStr[13]={"Nix","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

class CompilationDateClass
{
	int y,m,d;
	AS sdate;
	int MmmToInt(const AS &s);
	
	public:
	CompilationDateClass();
	int Year(){return y;}
	int Month(){return m;}
	int Day(){return d;};
	AS Date(){return sdate;};
};
CompilationDateClass Compilation;

int CompilationDateClass::MmmToInt(const AS &s)
	//convert english Month with 3 char to int
{
	for (int i=1; i<=12;++i)
		if (s==MmmStr[i]) return i;
	pip("Invalid Mmm");
	return 999;
}

CompilationDateClass::CompilationDateClass()
{
	sdate=__DATE__;//Compilation date, not date of this file
	y=StrToInt(sdate.SubString(sdate.Length()-3,4));
	m=StrToInt(MmmToInt(sdate.SubString(1,3)));
	AS sd=sdate;
	sd.Delete(1,sd.Pos(" "));
	if (sd.Pos(" ")==1) sd.Delete(1,1);//if day 1..9 of month
	sd.Delete(sd.Pos(" "),999999);//delete trailing string
	d=StrToInt(sd);
}
//----- end CompilationDate

