//wqpu1: main unit of wqp
//---------------------------------------------------------------------------

//#include <sharemem.hpp>
#include <map>
#include <fstream>

//following because of <<AnsiString
#define VCL_IOSTREAM
#include <system.hpp>

//#include <vcl.h>
//#include <complex>
#include <math>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

//Wheader Beginn
#define wdebug
#define cotyp_as_default //define vor wqpnu
#include "wqpnu.h"
#include "wqpu1.h"
#include "wqpus1.h"
#pragma hdrstop
#include "wutil1.h"
TF1 *F1;
#include "wutilbc.h"


const int MaxDimCount = 32; //fr ein skalares Feld
//mit txyz wrde MaxDimCount=4 reichen
const int nlike = 0; // Dimension nlike is reserved for time = integer
const int llike = MaxDimCount - 1; // Dimension llike is reserved for lattice number
//z.B. if Lk.coo[llike] == 0: Ex
//     if Lk.coo[llike] == 1: Ey
//     if Lk.coo[llike] == 2: Ez
//     if Lk.coo[llike] == 3: Bx...

const cotyp NullQuantity = 0;

//to Algadd
const int SlAlgadd_Row_of_p = 1; //multiply quantity with p bevore add
const int SlAlgadd_Row_ldest = 2;
const int SlAlgadd_Row_l = 3;
//add only to those with coo[llike] == SlAlgadd.ae[aanr][].ldest

const int SlAlgaddRowIndexOffset = SlAlgadd_Row_l;
const int SlAlgadd_RowCount = MaxDimCount + SlAlgaddRowIndexOffset;
const int Algadd_EntryCount = 256;
const int Algadd_TableCount = 16; //ca 25KB je entry

struct Lk //Lattice-coordinates as array of MaxDimCount integers
{
	int coo[MaxDimCount];
	bool between(const Lk& lkmin, const Lk& lkmax) const;
};
//for int
const int lcoomax = std::numeric_limits < int >::max();
const int lcoomin = std::numeric_limits < int >::min();

Lk lkzero; //coo[i]=0
Lk lkmin, lkmax; //only .coo[nlike] varies, rest is initialized by
void InitLkMaxMinZero_3(Lk &lkmax, Lk &lkmin, Lk &lkzero);

//vgl. zB. Stou 497
class Lk1LessLk2{
	public:
	bool::operator() (const Lk& l1, const Lk& l2) const;
};

bool Lk1LessLk2::operator() (const Lk& l1, const Lk& l2) const
{
	int i = 0;
	while (i < MaxDimCount - 1 && l1.coo[i] == l2.coo[i])
	{++i; }
	return l1.coo[i] < l2.coo[i];
}

typedef map < Lk, cotyp, Lk1LessLk2 > Lmap;
typedef Lmap::const_iterator const_Lmapi;
typedef Lmap::iterator Lmapi;
typedef pair < Lk, cotyp > Lpair;

typedef unsigned int size_type;
const double LpairSize = double(sizeof(Lpair));

//for debugging Lpair:
struct  Lpaird
{
	Lk first; //key
	cotyp second;  //quantity
	
	Lpaird() {};
	Lpaird(const Lmapi it): first(it->first), second(it->second) {};
	Lpaird& operator = (const Lmapi it)  //conversion to *it
	{   first = it->first;
		second = it->second;
		return *this;
	}
	Lpaird& operator = (const Lpair lp)
	{   first = lp.first;
		second = lp.second;
		return *this;
	}
};

/*
jede belegte Koordinate wird durch lpair reprsentiert, welches
aus coo und quantity besteht
coo: diskrete Koordinate,
z.B. z.B. Feldstaerke 3.1 an txyz=9786 wuerde repraesentiert durch:
lk.q=3.1;
lk.coo[nlike]=9
lk.coo[1]=7
lk.coo[2]=8
lk.coo[3]=6
*/

typedef enum {zeroall, testq, init_n0_with_1, init_n0_with_1_1}
Options_InitLglSldimSlq;

class Lgl //Lattice-family: LatticeGlobal
{
	void SetLpair (const Lpair& lpair_akt);
	void SetLpairQuantityAtLkoffsetPlusSlOffset
	(const cotyp& vl, const int& col, const int& row);
	
	void GetLpairQuantity_1 (Lpair& lpair_akt) const;
	cotyp LpairQuantityAtLkoffsetPlusSlOffset
	(const int& col, const int& row) const;
	
	public:
	int xdim;    //Index der in Sl1-x-Richtung tabellierten Dimension von Lgl
	int ydim;    //Index der in Sl1-y-Richtung tabellierten Dimension von Lgl
	Lk lkoffset; //ist index, der in Bildschirmtabelle 0 Position hat
	Lmap lmap; //lattice global
	bool OnShowLattices;
	
	void Set_xdim (int x_dim);
	void Set_ydim (int y_dim);
	void UpdateLglifCorrectSldimCell_1 (TStringGrid *Sldim);
	void UpdateLglifCorrectSlqCell_1 (TStringGrid *Slq);
	void UpdateSldimSlqFromLgl () const;
	void UpdateSlqFromLgl_1 (TStringGrid *Slq) const;
	void UpdateSlqCellFromLgl_1 (TStringGrid *Slq) const;
	size_type LmapSize()  const {return lmap.size(); }
	//    Lgl():xdim(1), ydim(0){}; //Zeit=y als Default;
	void InitLglSldimSlq (Options_InitLglSldimSlq option);
	void Invert ();
	void CalcCrossProduct(int k1offset, int k2offset, int k3offset);
	void InitAreaRoundZeroWithPm1();
};


//----------- config:

typedef enum {no_lattice_point, lattice_point_read, lp_above_nelast} LP_State;
const int this_nelast_means_read_config_only = intmin;
//----
class cpar: public cphclass
{
	const AS entry_lattice; //lattice point
	const AS entry_xdim_ydim;
	const AS entry_ix1g_ix2g_iy1g2_iy2g2;
	
	const AS entry_lkoffset;
	const AS entry_sums1_range1min;
	const AS entry_sums1_range2min;
	const AS entry_sums1_range1max;
	const AS entry_sums1_range2max;
	const AS entry_g2at;
	const AS entry_aa_imm_selected_p;
	public:
	cpar();
	const AS entry_ls_ps_dim;
	const AS entry_algadd;
	void IkUk_and_CphInit();
	AS ProcessFileInputLine_2
	(int& lsiz_of_infile, LP_State& lp_state, int nelast, const AS& s_org);
	void UpdateGraph1CBfromConfig();
	void InitPrgPar(bool set_default_lk_offset);
	void InitPrgParAndSlconfig(bool set_default_lk_offset = true);
	void UpdateConfigFromGraph2RB();
	void UpdateConfigFromGraph1CB();
	void DothisAfterCfgUpdate();
	void SaveAllToFile(const AS& fn) const;
	void SaveDataToFile(const AS& fn, bool save_also_lattices) const;
};
//------
struct AlgaddEntry{
	cotyp p;
	int ldest;
	Lk lkadd;
};

const int MinMaxCount = 2; //index 0=min, index 1=max:
const int immin = 0;
const int immax = 1;

typedef enum {aad_NoDel, aad_DelAllButLast,
	aad_DelAllButLastAndSums1,
	aad_TrackingMode,
	//like aad_DelAllButLastAndSums1, additionally automatically smallest
	//if  more mem than "Algadd_TM_DelSmallestAfterKB" allocated
	aad_AlgaddDelmodesize
}
AlgaddDelmode;

struct AlgaddVar{
	AlgaddEntry ae_empty; //only once initialized
	AlgaddEntry ae[Algadd_TableCount][Algadd_EntryCount];
	
	int aanr; // actual index of ae
	int needed_seconds_of_last_algadd, stepcount_of_last_algadd;
	int imm_selected_entries[MinMaxCount];
	
	AlgaddVar();
	void InitAllEntries();
	void InitEntriesOfTable(int ia);
	void CopyTable2to1(int idest, int isrc);
	void UpdateSlAlgaddCellFromAlgaddVar_1 (TStringGrid *SlAlgadd) const;
	void IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (TStringGrid *SlAlgadd) const;
	void UpdateSlAlgaddFromAlgaddVar_1 (TStringGrid *SlAlgadd) const;
	void ToStream(ofstream &out) const;
	void CorrectSlAlgaddCellOrUpdateAlgaddVar();
	int UsedEntryCount_After_Compression(int aanrloc);
	int UsedEntryCount(int aanrloc);
	void CompressEntry(int aanrloc);
	void CompressAllEntries();
	void SetAlgCaptions();
	void AddLpairToLmap_1
	(Lmap &lm, Lmapi it_org, int used_entry_count, int aanr_current) const;
	void PerformAlgadd(int aanr_current, AlgaddDelmode aadelmode,
	const AS& s_explanation=NullString, int stepcount=-1);
};
//----
//Sums:
const int Slsums_isumq = 0; //"Sum(   q   )",
const int Slsums_isumq_div = 1; //"Sum(   q   ) / cnt",
const int Slsums_isumqq = 2; //"Sum( | q |^2 )",
const int Slsums_isumqq_div = 3; //"Sum( | q |^2 ) / cnt"
const int Slsums_results_per_sum = 4;
const int Slsums_rows_per_sum = Slsums_results_per_sum + 1; //because of nct 1 more

const static AS ssumfixed[Slsums_rows_per_sum] =
{
	"cnt",
	"Sum  q  ",
	"Sum  q   / cnt",
	"Sum| q |^2",
	"Sum| q |^2/cnt"
};

//Sums1
typedef enum {nodiv, div_by_cnt, div_r12} Graph1Divmode;
const int Sums1_SumCount = 2;

const int Sums1_BlockCount = Sums1_SumCount + 2;
// Sum itself +1 for Sums1_SumCount Divisions +1 for Div_total

const int Sums1_Cols_with_Sum = Sums1_SumCount + 1; //+1 for total sum

typedef struct
{
	cotyp cnt[Sums1_Cols_with_Sum][Sums1_BlockCount]; //not int because cnt1/cnt2...
	cotyp sum[Sums1_Cols_with_Sum][Sums1_BlockCount][Slsums_results_per_sum];
	bool sum_calculated[Sums1_Cols_with_Sum][Sums1_BlockCount][Slsums_results_per_sum];
} CountAndSums1;

//for more than 1 sums1 def:
const int Sums1_TableCount = 32;//8;//16
typedef struct
{
	Lk  range[Sums1_SumCount][MinMaxCount];
	int icoo_along_x_in_g[Sums1_SumCount];
	int icoo_along_y_in_g2[Sums1_SumCount];
} Sums1Table;

class Slds1_Par
{
	CountAndSums1 cs1, cs1_zero;
	static void InitStatics();
	
	public:
	static Sums1Table tazero;
	Slds1_Par(){InitStatics();}
	int ita;//Index of actual table
	Sums1Table ta[Sums1_TableCount];
	
	void InitSums1();
	void InitSums1Table(int italoc);
	
	//bool CalcSums1ParFromLmap(Lmap& lm);
	//void UpdateSlds1_from_Sums();
	void UpdateSlds1_from_range();
	void UpdateSlds1Cell_from_range();
	void UpdateSlsums1_from_cs1();
	bool CalcSums1FromLgl();
	void UpdateRange_if_CorrectSlds1Cell();
	void CorrectSlds1CellOrUpdateRange();
	void if_CBR_SetRangeTo(const Lk& lk, int imm);
	void if_CBR_CopyRangeMinToMax();
	void if_CBR_CopyRangeMaxToMin();
	AS s_xygraph (int ixy) const;
};
//definition of statics necessary:
Sums1Table Slds1_Par::tazero;

//------ sums2

const int Slsums2_n_count = 5; //because of total,0,1,nlast-1,nlast

typedef struct
{
	int cnt[Slsums2_n_count];
	cotyp sum[Slsums2_n_count][Slsums_results_per_sum];
} CountSums2_to_l;

typedef map < int, CountSums2_to_l > S2map; //lattice-index=m.first=lattice-index of Sums for it
typedef S2map::iterator S2mapi;
typedef pair < int, CountSums2_to_l > S2pair;

class Slsums2_Par
{
	CountSums2_to_l empty_cs2;
	int n_of_sum[Slsums2_n_count];
	S2map s2map;
	
	public:
	void DefaultInit();
	Slsums2_Par() {DefaultInit(); };
	
	bool CalcSums2ParFromLmap(Lmap& lm);
	void FillSlsums2();
};

//----Graph:
const int ixy_minborder=1;
const int igc_qre = 0; //sums of real part per index
const int igc_qim = 1; //dto imag. part
const int igc_qq = 2; //dto |q|^2
const int igc_qa = 3; //dto |q|
const int igc_cntAt = 4; //fitting-count = count_local: count per index, <=1
const int igc_count = 5; //one more than last of above

const int G1Chainsize = 5000; //more than horizontal screen resolution

//----Graph1:
struct G1Chain//sums with raw data of Graph1
{
	int cnt; //count  over complete range
	double y[igc_count][G1Chainsize];
	double ymm[igc_count][MinMaxCount]; //[immin]=Min,[immax]=Max
	bool draw[igc_count]; //true, if accomp. Graph1 to draw or drawed
	TColor color[igc_count];
};

class G1Par
{
	G1Chain gc[Sums1_SumCount];
	int hpixcount;
	int vpixcount;
	int icoominmax[MinMaxCount];
	bool gpvalid;
	
	public:
	bool oplot_if_2_curves;
	G1Par():hpixcount(0), vpixcount(0), oplot_if_2_curves(false){};
	void InitColors();
	void InitMinMax_Zero_gc_til_hpixcount();
	void UpdateGcDrawFromCB();
	void Calc_gc_from_lgl();
	void DrawGimage1FromGc();
	void Draw_oplot_of_2_valid_curves(const double& y0, const double& y1);
	void UpdateAndShowGraph1(bool calc_gc_new);
};

//------ Graph2:
const int label_g2_count = 21;
const int fclimits_per_label = 48;
const int fclimit_count = (label_g2_count - 1)*fclimits_per_label + 1;

const int max_hpixcount = 3000; //more than horizontal screen resolution
const int max_vpixcount = 2000; //more than vertical screen resolution

typedef enum { g2_colors_equally_distributed, g2_colors_linear}
G2ColorDistribution;
typedef enum {g2_bw, g2_red_to_white,
	g2_green_to_white, g2_blue_red_to_white} G2ColorMode;

const int clg2_max = 255; //color_graph2_max; if r=g=b=clg2_max ->white
const int nyabs_max = 99;//max number of plots in g2a

class G2Par
{
	int cnt; //count  over complete range
	//8 Byte per double, fast and accurate, but use 4 Byte float:
	//float q[max_hpixcount][max_vpixcount];//would need only half mem
	// and/or dynamic vector[] in case of too less memory
	
	double q[max_hpixcount][max_vpixcount];
	double vmm[MinMaxCount];
	int ixcoominmax[MinMaxCount];
	int iycoominmax[MinMaxCount];
	int hpixcount;
	int vpixcount;
	int igc_akt, isu_akt;
	bool gpvalid;
	void SetIgcaktIsuaktFromRadioButtons();
	
	//for g2a:
	double xpix_per_icoo, ypix_per_icoo;
	
	//coloring:
	double fclimit[fclimit_count]; //colorindex valid, if (q-vmin)/vdiff between limits
	const double delta_fc_per_fclimit;
	int i_label_g2;
	
	//for fast coloring:
	int clg2_start; //fclg2_start*clg2_max
	int clg2_max_minus_start;
	G2ColorMode g2_color_mode;
	
	public:
	void Zero_i_label_g2(){i_label_g2 = 0; };
	void Set_linear_fclimit(const double& vmin, const double& vmax);
	void Set_equally_distributed_fclimit();
	
	void SetNextLabelColorAndCaption_1(TLabel* label);
	TColor color_from_fcl_table(const double& v_before);
	TColor clg2_from_01(const double& fc);
	void SetLabelColor_1(TLabel* label, const double fcl);
	
	G2Par():hpixcount(0), vpixcount(0),
	delta_fc_per_fclimit(1.0/double(fclimit_count - 1)){};
	void SetColorLabelsAndG2cld();
	void InitMinMax_RB_Zero_box_til_hvpixcount();
	void Calc_v_from_lgl();
	void DrawGimage2FromQuantities();
	void PlotMultiple1DGraphsOnGimage2();
};

//for transfer to g2a
typedef enum {plot_not,plot_blue, plot_red} G2a_iyplotmode;
struct G2aTransferPar
{
	G2a_iyplotmode iym[nyabs_max];
	void init(int nyabs);
	G2aTransferPar() {init(nyabs_max);}
};

void CalcAndShowGraph2d(bool call_from_rb);
void SetGraph2VisibleTo(bool vi2, bool vi2a);


//sort along double, int=count, if double repeatedly
typedef map < double, bool > Vmap; //bool=dummy, not used
typedef Vmap::iterator Vmapi;
typedef pair < double, bool > Vpair;

//---
struct GPar
{
	TColor color_grid, color_axes;
	void DrawGrid(TImage* Gimage, bool colored, int W, int H,
	double x0, double x1, double y0, double y1);
};

//---
const String ProgName = "wqp";
const AS CotypRegularInput = "1234567890/I+-E.\t\b";
const AS LatticesEmptyString = " Lattices are empty. ";

const AS FileEndDefault = "aa1";
const AS FileNameDefault = "a." + FileEndDefault;
//filename_for_uniform_configuarion:
const AS FnCfg = ProgName+"cfg." + FileEndDefault;
const AS s_kb_format="# ##0.000";
const int combtest_nscntmax=127;//nearest_sums_count, so many sums are listened in combtest

//------- Sllist:
class SllistPar
{
	int itolkcurrent;
	public:
	Lk lkcurrent;
	void Init() {lkmin.coo[nlike] = intmin;
		lkcurrent=lkmin; itolkcurrent=1;}
	void Fill_Sllist_Ab_Lkcurrent(bool update_itolkacurrent);
	void Fill_Sllist_AfterScrollBy(int scrollrows);
};

//---
AS s_nlast();
AS s_LatticesState();
void SetF1Caption(const AS& prefix);
void UpdateSums2();
void Delete_smallest_percent_of_nlastRow_in_lmap(int delpercent);
void ReadFromFnAndFnCfg(const int nelast);
void ReadConfigFromFnCfgIfExistent();
int MB_allocatable(const int Max_MB_Count);
//Wheader Ende

SlUpd sldimqupd, slqcellupd, slds1upd, slaaupd;
Lgl lgl;
AlgaddVar aav;
AS fn = FileNameDefault;
bool user_has_entered_fn = false;
cpar cp;
Slds1_Par s1p;
Slsums2_Par s2p;
G1Par gr1par;
GPar gpar;
G2aTransferPar g2at;
SllistPar sllp;

//---------------------------------------------------------------------------
__fastcall TF1::TF1 (TComponent* Owner): TForm (Owner)
	
{
	InitLkMaxMinZero_3(lkmax, lkmin, lkzero);//first of all
	
	F1->Sldim->ColCount = 2;
	F1->Sldim->RowCount = MaxDimCount;
	cp.IkUk_and_CphInit();
	s1p.InitSums1();
	
	Application->HelpFile = ProgName+".hlp";
	ForceCurrentDirectory = true;
	SetF1Caption(ProgName+" (no file specified)");
	
	InitFixedSlAlgadd();
	InitFixedSllist();
	cp.InitPrgParAndSlconfig();
	
	lgl.InitLglSldimSlq (zeroall);
	gr1par.InitColors();
	SetGraph2VisibleTo(false,false);
	sllp.Init();
	
	if (ParamCount()>1)
	{pip("Too many start parameters"); return;}
	
	if (ParamCount()==1)
	{
		fn = LowStrAfterLast(ParamStr(1), "\\");
		ReadFromFnAndFnCfg(intmax);
	}
	else
		ReadConfigFromFnCfgIfExistent();
	
	//  KeyPreview = true;
}

//----------------------

//---------------------------------------------------------------------------
//----- after definition of cp:
//--- usual eventhandler, calls of cphclass subroutines:
void __fastcall TF1::ConfigShow(TObject *Sender)
{cp.UpdateSlconfigFromcph();}

void __fastcall TF1::SlconfigKeyPress(TObject *Sender, char &Key)
{cp.OnSlconfigKeyPress(Key);}

void __fastcall TF1::SlconfigMouseMove(TObject *Sender,
TShiftState Shift, int X, int Y)
{cp.CorrectAndUpdateSlconfigCellOnXYChange(X, Y);}

void __fastcall TF1::SlconfigExit(TObject *Sender)
{cp.CorrectSlconfigCellOrUpdatecph ();}

void __fastcall TF1::SlconfigSelectCell(TObject *Sender, int ACol,
int ARow, bool &CanSelect)
{cp.CorrectSlconfigCellOrUpdatecph();}
//--- end of usual eventhandler calls of cphclass subroutines:
//---------------------------------------------------------------------------
//---------------------- begin config:

void cpar::UpdateGraph1CBfromConfig()
{
	int org_cb_saving=kmi("Graph1_CB_state_saving");
	setkmi_1("Graph1_CB_state_saving", 0);//because setting of checked causes OnClick:
	
	F1->CB0qre->Checked = kmi("Graph1_CB0qre_checked");
	F1->CB0qim->Checked = kmi("Graph1_CB0qim_checked");
	F1->CB0qa->Checked = kmi("Graph1_CB0qa_checked");
	F1->CB0qq->Checked = kmi("Graph1_CB0qq_checked");
	F1->CB0cntAt->Checked = kmi("Graph1_CB0cntAt_checked");
	
	F1->CB1qre->Checked = kmi("Graph1_CB1qre_checked");
	F1->CB1qim->Checked = kmi("Graph1_CB1qim_checked");
	F1->CB1qa->Checked = kmi("Graph1_CB1qa_checked");
	F1->CB1qq->Checked = kmi("Graph1_CB1qq_checked");
	F1->CB1cntAt->Checked = kmi("Graph1_CB1cntAt_checked");
	
	setkmi_1("Graph1_CB_state_saving", org_cb_saving);
}



cpar::cpar():
entry_lattice("e_l"),
entry_algadd("e_aa"),
entry_ls_ps_dim("e_lpd"),  //lattice pointcount, pairsize, MaxDimCount

entry_lkoffset("e_lkoffset"),
entry_sums1_range1min("e_sums1_range1min"),
entry_sums1_range2min("e_sums1_range2min"),
entry_sums1_range1max("e_sums1_range1max"),
entry_sums1_range2max("e_sums1_range2max"),
entry_xdim_ydim("e_xdim_ydim"),
entry_ix1g_ix2g_iy1g2_iy2g2("e_ix1g_ix2g_iy1g2_iy2g2"),
entry_g2at("e_g2at"),
entry_aa_imm_selected_p("e_aa_imm_p")
{}


const AS seol = ": end of line expected";

int sl_irow(int icoo)
{
	#ifdef wdebug
	if (icoo < 0 || icoo >= MaxDimCount)
		pip ("sl_irow:icoo=" + IntToStr(icoo));
	#endif
	return icoo == llike ? 0 : icoo + 1; //show l in 0, rest below
}

int sl_icoo(int irow)
{
	int icoo = irow == 0 ? llike : irow - 1; //inverse of above
	#ifdef wdebug
	if (icoo < 0 || icoo >= MaxDimCount)
		pip ("sl_icoo:icoo=" + IntToStr(icoo));
	#endif
	return icoo;
}
AS CutLkStr_2(Lk& lk, AS& s, const AS& se)
	//return NullString, if ok, else errorstring
{
	bool ok = true;
	int i;
	for (i = 0; i < MaxDimCount && ok; ++i)
		ok = TryStrToInt(CutTillSpaceOrEnd_1(s), lk.coo[sl_icoo(i)]);
	
	if (!ok)
		return se+" Error in coo[sl_icoo(" + IntToStr(i) + ")]";
	
	if (!s.IsEmpty())
		return se+seol;
	
	return NullString;
}

bool Cut_ita_FromStr_3(int& ita_loc, AS& s, AS& se, const AS& skey)
	//return true, if ok
{
	if (!TryStrToInt(CutTillSpaceOrEnd_1(s), ita_loc))
	{
		se= skey + ": ita_loc is no int";
		return false;
	}
	if (ita_loc<0 || ita_loc>=Sums1_TableCount)
	{
		se= skey + ": ita_loc out of range";
		return false;
	}
	return true;
}

void Set_Caption_of_Button_aat_Select_p()
{
	F1->Button_aat_Select_p->Caption="Select p (curr.: "
	+AS(aav.imm_selected_entries[immin])+"..."
	+AS(aav.imm_selected_entries[immax])+")";
}

void SetAlgaddEntrySelection(const int a, const int b)
{
	int i_min=a, i_max=b;
	if (i_max<i_min) {warn(wl_all,"Selection ignored because min>max"); return;}
	if (i_min<0) i_min=0;
	if (i_max>=Algadd_EntryCount) i_max=Algadd_EntryCount-1;
	aav.imm_selected_entries[immin]=i_min;
	aav.imm_selected_entries[immax]=i_max;
	Set_Caption_of_Button_aat_Select_p();
}

AS cpar::ProcessFileInputLine_2
(int& lsiz_of_infile, LP_State& lp_state, int nelast, const AS& s_org)
{
	lp_state = no_lattice_point;
	
	AS s = s_org.Trim();
	
	//before accessing s[1]:
	if (s.IsEmpty())
		return NullString;
	
	if (s[1] == char_skipline)
		return NullString;
	
	if (s[1] == char_comment)
		if (nelast==this_nelast_means_read_config_only)
			return NullString;
		else
		{
			s.Delete(1, 1);
			F1->Memo_Comment->Lines->Add(s);
			return NullString;
		}
	
	AS skey = CutTillSpaceOrEnd_1(s);
	bool ok = true;
	int i;
	
	//first of all, due to speed and to set lp_state correctly
	if (skey == entry_lattice)
	{
		if (nelast==this_nelast_means_read_config_only)
		{lp_state = lp_above_nelast; return NullString;}
		
		Lpair lp;
		
		//#define slow_latticeread_for_variable_maxdimcount_and_llike
		#ifdef slow_latticeread_for_variable_maxdimcount_and_llike
		//-----
		//following 2 lines need time...
		for (i = 0; i < MaxDimCount && ok; ++i)
			ok = TryStrToInt(CutTillSpaceOrEnd_1(s), lp.first.coo[sl_icoo(i)]);
		
		if (!ok)
			return "entry_lattice: Error in coo[sl_icoo(" + IntToStr(i) + ")]";
		
		if (!lp.second.InputFromStr(CutTillSpaceOrEnd_1(s)))
			return "entry_lattice: Error in cotyp quantity";
		
		if (!s.IsEmpty())
			return "entry_lattice" + seol;
		//-----
		#else
			//-----
			
			#if (MaxDimCount!=32 || llike!=31)
			this compiler - error should tell you:
			define
			slow_latticeread_for_variable_maxdimcount_and_llike
			before compilation because of
			(MaxDimCount != 32 || llike != 31) ;
		#endif
		
		char endstring[256];
		int nscanned = sscanf(s.c_str(),
		"%d %d %d %d %d %d %d %d %d %d "
		"%d %d %d %d %d %d %d %d %d %d "
		"%d %d %d %d %d %d %d %d %d %d "
		"%d %d %s",
		&lp.first.coo[31],
		&lp.first.coo[ 0], &lp.first.coo[ 1], &lp.first.coo[ 2],
		&lp.first.coo[ 3], &lp.first.coo[ 4], &lp.first.coo[ 5],
		&lp.first.coo[ 6], &lp.first.coo[ 7], &lp.first.coo[ 8],
		&lp.first.coo[ 9], &lp.first.coo[10], &lp.first.coo[11],
		&lp.first.coo[12], &lp.first.coo[13], &lp.first.coo[14],
		&lp.first.coo[15], &lp.first.coo[16], &lp.first.coo[17],
		&lp.first.coo[18], &lp.first.coo[19], &lp.first.coo[20],
		&lp.first.coo[21], &lp.first.coo[22], &lp.first.coo[23],
		&lp.first.coo[24], &lp.first.coo[25], &lp.first.coo[26],
		&lp.first.coo[27], &lp.first.coo[28], &lp.first.coo[29],
		&lp.first.coo[30], &endstring);
		if (nscanned != 33)
			return "entry_lattice: sscanf = "
			+ IntToStr(nscanned) + " instead of 33";
		
		if (!lp.second.InputFromStr(AS(endstring)))
			return "entry_lattice: Error in cotyp quantity";
		//-----
		#endif
		
		if (lp.second == NullQuantity)
			return "entry_lattice: NullQuantity input is redundant";
		
		Lmapi li = lgl.lmap.find(lp.first);
		if (li != lgl.lmap.end())
			return "entry_lattice: coordinate already occupied";
		
		if (lp.first.coo[nlike] > nelast)
			lp_state = lp_above_nelast;
		else
		{
			lp_state = lattice_point_read;
			lgl.lmap.insert(lp);
		}
		return NullString;
	}
	
	
	//after latticetest lp_state ok, therefore:
	if (nelast==this_nelast_means_read_config_only)
		return TryToReadConfigEntry_1(s, skey, !user_has_entered_fn);
	//remark to above: read all only, if no active user file
	
	
	if (skey == entry_algadd)
	{
		int aanr_read;
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), aanr_read))
			return "entry_algadd: aanr_read no int";
		if (aanr_read >= Algadd_TableCount)
			return "entry_algadd: aanr_read=" + AS(aanr_read)
				+ " > Algadd_TableCount=" + AS(Algadd_TableCount);
		//int i_entry = aav.UsedEntryCount(aanr_read);//automatically one more
		int i_entry;
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), i_entry))
			return "entry_algadd: i_entry no int";
		if (i_entry >= Algadd_EntryCount)
			return "entry_algadd: i_entry_read=" + AS(i_entry)
				+ " > Algadd_EntryCount=" + AS(Algadd_EntryCount);
		if(!aav.ae[aanr_read][i_entry].p.InputFromStr(CutTillSpaceOrEnd_1(s)))
			return "entry_algadd: p no cotyp";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), aav.ae[aanr_read][i_entry].ldest))
			return "entry_algadd: ldest no int";
		
		for (i = 0; i < MaxDimCount && ok; ++i)
			ok = TryStrToInt(CutTillSpaceOrEnd_1(s),
			aav.ae[aanr_read][i_entry].lkadd.coo[sl_icoo(i)]);
		if (!ok)
			return "entry_algadd: Error in coo[sl_icoo(" + IntToStr(i) + ")]";
		if (!s.IsEmpty()) return skey + seol;
		return NullString;
	}
	
	
	
	if (skey == entry_aa_imm_selected_p)
	{
		int a,b;
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), a))
			return "entry_aa_imm_selected_p: min no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), b))
			return "entry_aa_imm_selected_p: max no int";
		if (!s.IsEmpty()) return skey + seol;
		SetAlgaddEntrySelection(a, b);
		return NullString;
	}
	
	if (skey == entry_date)
	{
		SetF1Caption(fn + " :  "
		+ s.SubString(1, s.Pos("=") - 2));
		F1->Caption = "reading from " + fn;
		return NullString;
	}
	
	
	if (skey == entry_ls_ps_dim)
	{
		int lpsiz, mdim;
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), lsiz_of_infile))
			return skey + ": lsiz_of_infile is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), lpsiz))
			return skey + ": lpsiz is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), mdim))
			return skey + ": mdim is no int";
		if (!s.IsEmpty())
			return skey + seol;
		#if 0  //disabled to allow variation of floating point format in cotyp
		if (lpsiz != sizeof(Lpair))
			return skey + " lpsiz = " + IntToStr(lpsiz)
				+ " != " + IntToStr(sizeof(Lpair)) + " = sizeof(Lpair)";
		#endif
		if (mdim != MaxDimCount)
			return skey + " mdim = " + IntToStr(mdim)
				+ " != " + IntToStr(MaxDimCount) + " = MaxDimCount";
		
		return NullString;
	}
	
	if (skey == entry_xdim_ydim)
	{
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), lgl.xdim))
			return skey + ": xdim is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), lgl.ydim))
			return skey + ": ydim is no int";
		if (!s.IsEmpty())
			return skey + seol;
		return NullString;
	}
	
	
	if (skey == entry_g2at)
	{
		bool ok = true;
		int int_to_enum;
		for (i = 0; i < nyabs_max && ok; ++i)
		{
			ok = TryStrToInt(CutTillSpaceOrEnd_1(s), int_to_enum);
			g2at.iym[i]=int_to_enum;
		}
		if (!ok) return skey+" Error in iym[" + IntToStr(i) + "]";
		if (!s.IsEmpty()) return skey+seol;
		return NullString;
	}
	
	if (skey == entry_lkoffset)
		return CutLkStr_2(lgl.lkoffset, s, skey);
	
	int ita_loc;
	AS serr;
	if (skey == entry_ix1g_ix2g_iy1g2_iy2g2)
	{
		if (!Cut_ita_FromStr_3(ita_loc, s, serr, skey))
			return serr;
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), s1p.ta[ita_loc].icoo_along_x_in_g[0]))
			return skey + ": ta[ita_loc].icoo_along_x_in_g[0] is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), s1p.ta[ita_loc].icoo_along_x_in_g[1]))
			return skey + ": ta[ita_loc].icoo_along_x_in_g[1] is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), s1p.ta[ita_loc].icoo_along_y_in_g2[0]))
			return skey + ": ta[ita_loc].icoo_along_y_in_g2[0] is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), s1p.ta[ita_loc].icoo_along_y_in_g2[1]))
			return skey + ": ta[ita_loc].icoo_along_y_in_g2[1] is no int";
		if (!s.IsEmpty())
			return skey + seol;
		return NullString;
	}
	
	if (skey == entry_sums1_range1min)
	{
		if (!Cut_ita_FromStr_3(ita_loc, s, serr, skey))
			return serr;
		return CutLkStr_2(s1p.ta[ita_loc].range[0][immin], s, skey);
	}
	if (skey == entry_sums1_range1max)
	{
		if (!Cut_ita_FromStr_3(ita_loc, s, serr, skey))
			return serr;
		return CutLkStr_2(s1p.ta[ita_loc].range[0][immax], s, skey);
	}
	
	if (skey == entry_sums1_range2min)
	{
		if (!Cut_ita_FromStr_3(ita_loc, s, serr, skey))
			return serr;
		return CutLkStr_2(s1p.ta[ita_loc].range[1][immin], s, skey);
	}
	if (skey == entry_sums1_range2max)
	{
		if (!Cut_ita_FromStr_3(ita_loc, s, serr, skey))
			return serr;
		return CutLkStr_2(s1p.ta[ita_loc].range[1][immax], s, skey);
	}
	
	//because nelast!=after other possibilities: test for "" keyword
	return TryToReadConfigEntry_1(s, skey, true);
}

void cpar::IkUk_and_CphInit()
{
	Ukpair("Slq_ColCount", 20,
	"number of columns in Slq (contains lattice quantities)", 2, 1000);
	Ukpair("Slq_RowCount", 50,
	"number of rows of Slq", 2, 2000);
	Ukpair("Slq_DefaultColWidth", 86,
	"default width of cells", 1);
	
	Ikpair("Algadd_DefaultTableIndex", 0,
	"Initial table index in Algadd", 0, Algadd_TableCount - 1);
	Ikpair("Algadd_DefaultStepCount", 1,
	"default number of steps of Algadd", 1);
	Ukpair("Algadd_del_p0_entries", 0,
	"automatically delete Algadd entries with zero p  (0=no)", 0, 1);
	
	Ukpair("Algadd_mem1_DisplayAfterKB", 1000,
	"KB of memory allocation per headline display during Algadd", 10, 10000);
	Ukpair("MaxAllowedMemOccupationInKB", 200000,
	"Max. KB of memory allocation", 100);
	Ukpair("Algadd_TM_DelSmallestAfterKB", 100000,
	"KB mem alloc., which causes Del smallest in AA Tracking Mode", 100);
	Ukpair("Algadd_TM_BeepOnDelSmallest", 0,
	"Beep on every deletion cycle during AA Tracking Mode (0=false)", 0, 1);
	Ukpair("Algadd_TM_DelAlsoTillRow0", 0,
	"Del also till (usual first) row n=0 during AA TM (0=false)", 0, 1);
	
	Ukpair("SlAlgadd_DefaultColWidth", 50,
	"default width of cells", 1);
	
	Ikpair("Slq_xdim_default", 1,
	"default x-coordonate in Slq", 0, MaxDimCount - 1);
	Ikpair("Slq_ydim_default", 0,
	"default y-coordonate in Slq", 0, MaxDimCount - 1);
	Ikpair("Slq_xoffset_default", 0,
	"default x-offset in Slq");
	Ikpair("Slq_yoffset_default", 0,
	"default y-offset in Slq");
	
	Ukpair("File_IO_PointCountPerDisplay", 1000,
	"Count of saved or read lattice points per display", 1);
	Ukpair("File_Save_WarnKB", 5000,
	"if wl>="+AS(wl_usual)
		+": Warn before save, if lattices have more KB", 100);
	
	Ikpair("F1_Initial_Active_Page", 0,
	"Index of initial table sheet after file read",0, F1->PaCo->PageCount-1);
	
	Ukpair("Graph_Gridlines_x", 7,
	"Approx. number of grid lines along x", 0, 300);
	Ukpair("Graph_Gridlines_y", 4,
	"Approx. number of grid lines along y", 0, 200);
	Ukpair("Graph_Gridlines_Auto", 1,
	"Auto pos. grid lines to round values (0=false)", 0, 1);
	Ukpair("Graph_num_precision", 4,
	"Lettering precision", 1, 17);
	Ukpair("Graph_BarsEdgesVertical", 1,
	"Make bar edges exact vertical (0=false)", 0, 1);
	Ukpair("Graph_y_border_percent", 2,
	"Scaling: y zoom factor in percent", 0, 30);
	Ukpair("Graph_BeepMsgIfTooLessPixel", 0,
	"Graph: Warn, if warnlevel high and too less pixel (0=false)", 0, 1);
	
	Ukpair("DelSmallPercent_Default", 30,
	"Default perc. of points with small quantities to delete", 0, 100);
	
	Ikpair("Graph1_BarDbl_Fill0", 0,
	"1:Bars to double width if 2er steps,  2:Fill zero q from left", 0, 2);
	
	Ikpair("Graph1_CB0qre_checked", 1,
	"Graph1, range 0: initially draw qre (0=false)", 0, 1);
	Ikpair("Graph1_CB0qim_checked", 0,
	"Graph1, range 0: initially draw qim (0=false)", 0, 1);
	Ikpair("Graph1_CB0qq_checked", 0,
	"Graph1, range 0: initially draw qq (0=false)", 0, 1);
	Ikpair("Graph1_CB0qa_checked", 0,
	"Graph1, range 0: initially draw qa (0=false)", 0, 1);
	Ikpair("Graph1_CB0cntAt_checked", 0,
	"Graph1, range 0: initially draw cntAt (0=false)", 0, 1);
	
	Ikpair("Graph1_CB1qre_checked", 0,
	"Graph1, range 1: initially draw qre (0=false)", 0, 1);
	Ikpair("Graph1_CB1qim_checked", 0,
	"Graph1, range 1: initially draw qim (0=false)", 0, 1);
	Ikpair("Graph1_CB1qq_checked", 0,
	"Graph1, range 1: initially draw qq (0=false)", 0, 1);
	Ikpair("Graph1_CB1qa_checked", 0,
	"Graph1, range 1: initially draw qa (0=false)", 0, 1);
	Ikpair("Graph1_CB1cntAt_checked", 0,
	"Graph1, range 1: initially draw cntAt (0=false)", 0, 1);
	
	Ukpair("Graph1_CB_state_saving", 1,
	"Graph1: Save also last Checkbox state (0=false)", 0, 1);
	Ikpair("Graph1_oplot_skip_zeros", 0,
	"Skip 0:not   1:if x=0 and y=0   2:if x=0 or y=0", 0, 2);
	Ikpair("Graph1_oplot_if_2_curves", 0,
	"if two curves, draw oplot (with x=y1 y=y2) (0=false)", 0, 1);
	
	Ikpair("Graph1_divmode", 0,
	"0:nodiv, 1:q/cnt, 2:v1/v2 with v1/0:=0", 0, 2);
	Ukpair("Graph1_quick_xscale_r12_common", 0,
	"Graph1 scaling: quick common x scale for range 1 and 2 (0=false)", 0, 1);
	Ikpair("Graph1_OnlyBlackWhite", 0,
	"Graph1 only backwhite (e.g. for hardcopy) (0=false)", 0, 1);
	
	
	Ukpair("Graph2_AvoidOverlappingSum", 1,
	"Avoid overl. summation also if too less pixel (0=false)", 0, 1);
	Ikpair("Graph2_BoxDoubleWidth", 0,
	"Enlarge Boxes to double width if 2er steps (0=false)", 0, 1);
	Ukpair("Graph2_color_white_offset", 25,
	"brightness: minimal white percentage", 0, 100);
	Ikpair("Graph2_color_mode", 0,
	"0:bw 1:red_to_white 2:green_to_white 3:blue_red_to_white", 0, 3);
	
	Ikpair("Graph2_divide_y_by_count", 0,
	"divide Graph2 y scale by cnt (0=false)", 0, 1);
	Ukpair("Graph2_color_distribution", 0,
	"0:distributed  1:linear", 0, 1);
	
	Ukpair("Graph2_LineCountPerDisplay", 30,
	"Count of plotted lines per ProgressBar update", 1);
	
	Ikpair("Graph2_RB_re_im_qa_qq_cntAt_12", 0,
	"default index for active RadioButton", 0, 2*igc_count - 1);
	Ukpair("Graph2_RB_state_saving", 1,
	"Graph2: Save also last RadioButton state (0=false)", 0, 1);
	Ikpair("Graph2a_ny", 0,
	"Multi 1D graphs with last y_max (ny>0) or y_min (ny<0)",
	-nyabs_max,nyabs_max);
	Ikpair("Graph2a_max_dypix_per_plot", 6,
	"Max. y-Offset; if nonzero, y-scaling is valid only for plot 1",0);
	Ikpair("Graph2a_max_dypix_percent", 50,
	"Max. percentage of y-range used for all offsets",0,90);
	
	Ukpair("Sums_ShowAsFloat", 1,
	"Show Sums1 and Sums2 in floating point (0=false)", 0, 1);
	Ukpair("Sums_lt_precision", 7,
	"precision of Sums1 and Sums2 output", 0);
	Ukpair("Sums_Slsums_DefaultColWidth", 128,
	"default width of cells", 1);
	Ukpair("Sums_EntryCountPerDisplay", 10000,
	"count of summed lattice points per display", 1);
	
	Ukpair("Sums1_SumUp_at_once", 0,
	"sum up at once after change of range (0=false)", 0, 1);
	Ikpair("Sums1_DefaultTableIndex", 0,
	"default range table index", 0,Sums1_TableCount-1);
	
	Ikpair("Sums2_n_first", 0,
	"First n for summation in Sums2");
	Ikpair("Sums2_n_second", 1,
	"Second n for summation in Sums2");
	Ikpair("Sums2_both_eo", 0,
	"Sums2: force both blockbegins even/odd (0=false)", 0, 1);
	
	Ukpair("Graph_EntryCountPerDisplay", 10000,
	"Graph: Count of summed lattice points per display", 1);
	
	Ukpair("File_in_nelast", 0,
	"File menu: For option 'read till n='",this_nelast_means_read_config_only+1);
	
	Ukpair("Combtest1_ShowSquaredDev", 0,
	"Show squared deviations (0=false)",0,1);
	Ukpair("Combtest1_WarnMillions", 100,
	"Warn, if more Millions of combinations",0);
	Ukpair("Combtest1_ShowOnlyIncDev", 1,
	"Show not more than one comb with the same deviation",0);
	Ukpair("Combtest1_nscnt", 4,
	"Count of nearest sums to show",1,combtest_nscntmax);
	
	Ikpair("Obarr0_ldest1", 0,
	"0: no absorbing barrier0 (no Obarr0), else ldest1 for absorbed quantities");
	Ikpair("Obarr1_ldest2", 0,
	"If Obarr0: ldest2 for absorbing barrier in ldest1");
	Ikpair("Obarr1_k1", 0,
	"If Obarr0: k1 coordinate of absorbing barrier1");
	Ikpair("Obarr1_k1_of_add_ldest2", 0,
	"If Obarr0: k1 coordinate dest of add into ldest2");
	Ikpair("Obarr1_multp_ldest2", 0,
	"If Obarr0: percent of in barrier1 abs. q. before add to ldest2");
	
	Ikpair("N0iniarea_dimcount", 3,
	"Init n=0 area: 1=along x, 2=along xy, 3=along xyz",1,3);
	Ikpair("N0iniarea_stepdist", 2,
	"Init n=0 area: step distance",1);
	Ikpair("N0iniarea_sign_alternation", 0,
	"Init n=0 area: sign alternation 0:no, 1:x, 2:xy, 3:xyz, 4:maximal",0,4);
	Ikpair("N0iniarea_square_round", 0,
	"Init n=0 area: area borders 0:square 1:round",0,3);
	Ikpair("N0iniarea_maxcoo", 12,
	"Init n=0 area: maximal k1,k2,k3 coordinates to be initializated",1);
	
	CphInitAfterAllCpIkUkpairInit();
}

bool FnCfgExists()
	//return true, if FnCfgExists
{
	ifstream incfg(FnCfg.c_str());
	return incfg?true:false;
}//Blockend closes incfg

void SetMainMenuCaptions()
{
	F1->Menu_Algadd_Is->Caption = "A:" + AS(aav.aanr);
	F1->Menu_S1_is->Caption = "S:" + AS(s1p.ita);
	F1->ConfigFileHintMenue->Caption=
	FnCfgExists()?"C":"(C)";
	if (FnCfgExists())
		F1->DelCfgFile->Enabled=true;
	else
		F1->DelCfgFile->Enabled=false;
}

void SetDefaultLkOffset()
{
	lgl.xdim = cp.kmi("Slq_xdim_default");
	lgl.ydim = cp.kmi("Slq_ydim_default");
	lgl.lkoffset = lkzero;
	lgl.lkoffset.coo[lgl.xdim] =  cp.kmi("Slq_xoffset_default");
	lgl.lkoffset.coo[lgl.ydim] =  cp.kmi("Slq_yoffset_default");
}

void cpar::InitPrgPar(bool set_default_lk_offset)
{
	F1->Slq->RowCount = kmi("Slq_RowCount");
	F1->Slq->ColCount = kmi("Slq_ColCount");
	F1->Slq->DefaultColWidth = kmi("Slq_DefaultColWidth");
	F1->Slsums1->DefaultColWidth = kmi("Sums_Slsums_DefaultColWidth");
	F1->Slsums2->DefaultColWidth = kmi("Sums_Slsums_DefaultColWidth");
	F1->SlAlgadd->DefaultColWidth = kmi("SlAlgadd_DefaultColWidth");
	
	F1->ReadTillNelast->Caption
	= "Read till n=" + AS(kmi("File_in_nelast"));
	
	aav.aanr = kmi("Algadd_DefaultTableIndex");
	s1p.ita = kmi("Sums1_DefaultTableIndex");
	gr1par.oplot_if_2_curves=kmi("Graph1_oplot_if_2_curves");
	UpdateGraph1CBfromConfig();
	
	if (set_default_lk_offset)
		SetDefaultLkOffset();
	SetMainMenuCaptions();
	SetScreenConfiguration();
}

void cpar::DothisAfterCfgUpdate() {InitPrgPar(true);}

void cpar::UpdateConfigFromGraph1CB()
{
	if (kmi("Graph1_CB_state_saving"))
	{
		setkmi_1("Graph1_CB0qre_checked", F1->CB0qre->Checked);
		setkmi_1("Graph1_CB0qim_checked", F1->CB0qim->Checked);
		setkmi_1("Graph1_CB0qa_checked", F1->CB0qa->Checked);
		setkmi_1("Graph1_CB0qq_checked", F1->CB0qq->Checked);
		setkmi_1("Graph1_CB0cntAt_checked", F1->CB0cntAt->Checked);
		
		setkmi_1("Graph1_CB1qre_checked", F1->CB1qre->Checked);
		setkmi_1("Graph1_CB1qim_checked", F1->CB1qim->Checked);
		setkmi_1("Graph1_CB1qa_checked", F1->CB1qa->Checked);
		setkmi_1("Graph1_CB1qq_checked", F1->CB1qq->Checked);
		setkmi_1("Graph1_CB1cntAt_checked", F1->CB1cntAt->Checked);
	}
}

void cpar::UpdateConfigFromGraph2RB()
{
	if (kmi("Graph2_RB_state_saving"))
	{
		int i = 999; //invalid value for debug
		if (F1->RB0qre->Checked) i = 0;
		if (F1->RB0qim->Checked) i = 1;
		if (F1->RB0qq ->Checked) i = 2;
		if (F1->RB0qa ->Checked) i = 3;
		if (F1->RB0cntAt ->Checked) i = 4;
		if (F1->RB1qre->Checked) i = 5;
		if (F1->RB1qim->Checked) i = 6;
		if (F1->RB1qq ->Checked) i = 7;
		if (F1->RB1qa ->Checked) i = 8;
		if (F1->RB1cntAt ->Checked) i = 9;
		setkmi_1("Graph2_RB_re_im_qa_qq_cntAt_12", i);
	}
}

void cpar::InitPrgParAndSlconfig(bool set_default_lk_offset)
{
	InitPrgPar(true);
	UpdateSlconfigFromcph();
}

void WriteLkToOut(ofstream& out, const Lk& lk, const AS& s_entry)
{
	int j;
	out << s_entry << aspace;
	for (j = 0; j < MaxDimCount; ++j)
		out << lk.coo[sl_icoo(j)] << aspace;
	out << endl;
}

void cpar::SaveAllToFile(const AS& fn) const
{SaveDataToFile(fn, true);}


void cpar::SaveDataToFile(const AS& fn, bool save_also_lattices) const
//save all data to ascii file
{
	GetScreenConfiguration();
	size_type lsiz = lgl.LmapSize();
	if (save_also_lattices)
		if (double(lsiz)*LpairSize > 1000.0*double(kmi("File_Save_WarnKB"))
		&& warnlevel>=wl_usual)
		if (!YesToQuestion(s_LatticesState() +
		"\nModification of lattice (e.g. choose last)\n"
		"may be recommendable before saving.\n"
		"Do you really want to save all data?")) return;
	
	F1->Repaint();
	
	ofstream out;
	out.open(fn.c_str());
	
	AS sdate = DateTimeToStr(Now());
	if (save_also_lattices) SetF1Caption(fn + " <= " + sdate);
	
	out << entry_date << aspace << sdate << " = T.M.J h:m:s" << endl;
	out << char_skipline << "this file = " << fn << endl << endl;
	
	out << char_skipline <<
	"lattice_point_count sizeof_entry MaxDimCount :" << endl;
	out << entry_ls_ps_dim
	<< aspace << IntToStr(lsiz) << aspace << IntToStr(sizeof(Lpair))
		<< aspace << IntToStr(MaxDimCount) << endl;
	out << entry_xdim_ydim
	<< aspace << IntToStr(lgl.xdim) << aspace << IntToStr(lgl.ydim) << endl;
	
	out << entry_aa_imm_selected_p << aspace
	<< IntToStr(aav.imm_selected_entries[immin]) << aspace
	<< IntToStr(aav.imm_selected_entries[immax]) << endl << endl;
	
	out << entry_g2at << aspace;
	for (int j = 0; j < nyabs_max; ++j) out << g2at.iym[j] << aspace;
	out << endl;
	
	AS s = F1->Memo_Comment->Text.Trim();
	int len = s.Length();
	if (len)
	{
		out << endl;
		out << char_skipline << "the following " <<
		"lines contain the comment (Length=" << len << ")" << endl;
		int isep;
		while (isep = s.Pos("\r\n"))
		{
			out << char_comment << s.SubString(1, isep - 1) << endl;
			s.Delete(1, isep + 1);
		}
		if (!s.IsEmpty())
			out << char_comment << s << endl;
		out << endl;
	}
	SaveCpToOut(out);
	
	aav.ToStream(out);
	
	WriteLkToOut(out, lgl.lkoffset, entry_lkoffset);
	out << endl;
	
	for (int ita_loc=0; ita_loc<Sums1_TableCount;++ita_loc)
		if (!equal(Slds1_Par::tazero,s1p.ta[ita_loc]))
		{
			out << char_skipline
			<< "Sums1: Range Table "<< ita_loc << ":" << endl;
			out << entry_ix1g_ix2g_iy1g2_iy2g2<< aspace << IntToStr(ita_loc)
				<< aspace << IntToStr(s1p.ta[ita_loc].icoo_along_x_in_g[0])
					<< aspace << IntToStr(s1p.ta[ita_loc].icoo_along_x_in_g[1])
						<< aspace << IntToStr(s1p.ta[ita_loc].icoo_along_y_in_g2[0])
							<< aspace << IntToStr(s1p.ta[ita_loc].icoo_along_y_in_g2[1]) << endl;
			WriteLkToOut(out, s1p.ta[ita_loc].range[0][immin],
			entry_sums1_range1min + aspace +AS(ita_loc));
			WriteLkToOut(out, s1p.ta[ita_loc].range[0][immax],
			entry_sums1_range1max + aspace +AS(ita_loc));
			WriteLkToOut(out, s1p.ta[ita_loc].range[1][immin],
			entry_sums1_range2min + aspace +AS(ita_loc));
			WriteLkToOut(out, s1p.ta[ita_loc].range[1][immax],
			entry_sums1_range2max + aspace +AS(ita_loc));
			out << endl;
		}
	//lattice saving at last:
	if (lsiz && save_also_lattices)
	{
		probar pb(0, lsiz);
		
		out << endl;
		out << char_skipline << "the following " << lsiz <<
		" lines contain all non-zero quantities of the lattices" << endl;
		out << char_skipline <<
		"in the table order: l, n=coo[0], coo[1] ... coo["
		<< MaxDimCount - 2 << "] quantity" << endl;
		Lpair lp;
		
		int dstep = kmi("File_IO_PointCountPerDisplay");
		int ecount = 0;
		int j;
		for (Lmapi it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
		{
			lp = *it;
			out << entry_lattice << aspace;
			for (j = 0; j < MaxDimCount; ++j)
				out << lp.first.coo[sl_icoo(j)] << aspace;
			
			out << lp.second << endl;
			if (!(++ecount%dstep))
			{
				F1->Caption = "lattice point " + AS(ecount) + " of "
				+ AS(lsiz) + " saved to " + fn;
				pb.SetProgressBarPosition(ecount);
			}
		}
	}
	if (!lsiz) out << char_skipline << LatticesEmptyString << endl;
	if (!save_also_lattices) out << char_skipline << "Lattice not saved"<< endl;
	
	SetF1Caption(NullString);
}

//--------- end config


int MB_allocatable(const int Max_MB_Count=1000000)
	//return amout fo free mem in MB, max Max_MB_Count
{
	const int int_per_MB=1000000/sizeof(int);
	int** iptr=new(nothrow) int*[Max_MB_Count];
	if (iptr==NULL) return 0;
	
	int i,iup;
	for(iup=0;iup<Max_MB_Count;++iup)
	{
		iptr[iup]=new(nothrow) int[int_per_MB];
		if (iptr[iup]==NULL) break;
	}
	
	int MB_alloc=iup+sizeof(int*)*Max_MB_Count/1000000;
	
	for(i=0;i<iup;++i) delete[] iptr[i];
	delete[] iptr;
	return MB_alloc;
}

void SetF1Caption(const AS& prefix)
	//append actual nlast and state
	//if prefix empty, use old prefix
{
	static AS last_F1caption_prefix = NullString;
	
	if (prefix != NullString)
		last_F1caption_prefix = prefix;
	
	F1->Caption = last_F1caption_prefix + ", " + s_nlast();
}
//--------------------------------------
void __fastcall TF1::SetDefaultOffset1Click(TObject *Sender)
{	SetDefaultLkOffset(); lgl.UpdateSldimSlqFromLgl ();}
//----------------------

#if 0
AS FnWithEnd
(const AS& filename, const AS& filename_end)
{
	if (filename.Pos("."))
		return filename;
	else
		return filename+"." + filename_end;
}
#endif

//---
void Lgl::InitLglSldimSlq (Options_InitLglSldimSlq option)
{
	lmap.clear();
	cp.InitPrgParAndSlconfig(false);
	
	Lpair lpair;
	cotyp vl;
	int i, j;
	int xoffs;
	int yoffs;
	
	switch (option)
	{
		case init_n0_with_1:
			lpair.second = 1;
			lpair.first = lkzero;
			SetLpair (lpair);
			break;
			
		case init_n0_with_1_1:
			lpair.second = 1;
			lpair.first = lkzero;
			xdim=2;//14.2.04: const. init (of Ex) along k2 preferable
			lpair.first.coo[xdim] -= 2;
			SetLpair (lpair);
			
			lpair.second = - 1;
			lpair.first.coo[xdim] += 4;
			SetLpair (lpair);
			break;
			
		case testq:
			xoffs = lkoffset.coo[xdim];
			yoffs = lkoffset.coo[ydim];
			for (i = 1; i < 7; i++)
				for (j = 1; j < 11; j++)
				{
					vl = NullQuantity + cotyp (j + yoffs, 1, i + xoffs, 2);
					SetLpairQuantityAtLkoffsetPlusSlOffset(vl, i + 1, j + 1);
				}
			break;
			
		case zeroall:
		default: break;
			
	}
	UpdateSldimSlqFromLgl ();
}


//------- access to Lgl-coordinates

void Lgl::SetLpair (const Lpair& lpair_akt)
{
	//nun evtl entstandene 0-Lcke=NullQuantity-Lcke wieder schliessen
	if (lpair_akt.second == NullQuantity)
		lmap.erase(lpair_akt.first);
	else
		lmap[lpair_akt.first] = lpair_akt.second;
}

void Lgl::SetLpairQuantityAtLkoffsetPlusSlOffset
(const cotyp& vl, const int& col, const int& row)
{
	Lpair lpair;
	lpair.second = vl;
	lpair.first = lkoffset;
	lpair.first.coo[xdim] += col - 1;
	lpair.first.coo[ydim] += row - 1;
	SetLpair (lpair);
}

void Lgl::GetLpairQuantity_1 (Lpair& lpair_akt) const
{
	const_Lmapi li = lmap.find(lpair_akt.first);
	if (li == lmap.end())
		lpair_akt.second = NullQuantity;
	else
		lpair_akt.second = li->second;
}

cotyp Lgl::LpairQuantityAtLkoffsetPlusSlOffset
(const int& col, const int& row) const
{
	Lpair lpair;
	lpair.first = lkoffset;
	lpair.first.coo[xdim] += col - 1;
	lpair.first.coo[ydim] += row - 1;
	GetLpairQuantity_1 (lpair);
	return lpair.second;
}

void Lgl::UpdateLglifCorrectSldimCell_1 (TStringGrid *Sldim)
{
	int k;
	if (TryStrToInt (Sldim->Cells[1][Sldim->Row], k))
		lkoffset.coo[sl_icoo(Sldim->Row)] = k;
	else
		Beep();
}

void Lgl::UpdateLglifCorrectSlqCell_1 (TStringGrid *Slq)
	//F1->Slq->Options >> goEditing;// erases goEditing
	//F1->Slq->Options << goEditing;//sets goEditing
{
	cotyp vl;
	
	if (vl.InputFromStr (Slq->Cells[Slq->Col][Slq->Row]))
		SetLpairQuantityAtLkoffsetPlusSlOffset(vl, Slq->Col, Slq->Row);
	else
		Beep();
}


AS DimNumString(int xydim)
	//for remembering user on special role of llike
{
	if (xydim == llike) return "l"; //Index no. llike contains component no.
	else if (xydim == nlike) return "n"; //Index no. nlike reserved for n
	//argorithm should calc to increasing n so that n is related to time
	else return "k"+AS (xydim);
}

AS DeltaDimNumString(int xydim)
	//for SlAlgadd
{if (xydim == llike) return "l";	else return "d"+DimNumString(xydim);}

void Lgl::UpdateSldimSlqFromLgl () const
{
	for (int j = 0; j < F1->Sldim->RowCount; ++j)
	{
		F1->Sldim->Cells[1][sl_irow(j)] = AS(lkoffset.coo[j]);
		F1->Sldim->Cells[0][sl_irow(j)] = DimNumString(j); //default fr gesperrte Zellen
	}
	//0<=xydim<=imaxdim notw. (berprfung u.a. bei File IO)
	F1->Sldim->Cells[0][sl_irow(xdim)] = DimNumString(xdim) + "=x";
	F1->Sldim->Cells[0][sl_irow(ydim)] = DimNumString(ydim) + "=-y";
	
	UpdateSlqFromLgl_1 (F1->Slq);
}

void HideSlsums1_ShowModifyRangeMenu()
{
	F1->Slds1->ShowHint = false;
	
	F1->Slsums1->Visible = false;
	F1->Button_RangeChooseTableNum->Caption
	="Choose new Table (curr.: "+AS(s1p.ita)+")";
	F1->GroupBox_Modify_Range->Visible = true;
}

void ShowSlsums1_HideModifyRangeMenu()
{
	if (cp.kmi("Sums1_SumUp_at_once"))
	{
		F1->Slds1->Hint = "Press right mouse button \n"
		"to activate the Modify Range Menu ";
		F1->Slds1->ShowHint = true;
	}
	F1->GroupBox_Modify_Range->Visible = false;
	F1->Slsums1->Visible = true;
}


void UpdateSums1()
{
	HideSlsums1_ShowModifyRangeMenu();
	s1p.UpdateSlds1_from_range();
	
	if (s1p.CalcSums1FromLgl())
		s1p.UpdateSlsums1_from_cs1();
}

void UpdateActivePage()
{
	SetF1Caption(NullString);
	
	if (F1->PaCo->ActivePage == F1->Sums2)
		UpdateSums2();
	else
		if (F1->PaCo->ActivePage == F1->Sums1)
			UpdateSums1();
		else
			if (F1->PaCo->ActivePage == F1->Graph1)
				gr1par.UpdateAndShowGraph1(true);
			else
				if (F1->PaCo->ActivePage == F1->Graph2)
					CalcAndShowGraph2d(false);
	if (F1->PaCo->ActivePage == F1->LatticeList)
		sllp.Fill_Sllist_Ab_Lkcurrent(true);
}



void Lgl::UpdateSlqFromLgl_1 (TStringGrid *Slq) const
{
	//    F1->Caption = "wqp Slq : Col=" + AS(Slq->Col)
	//    +", Row="+ AS(Slq->Row);
	int i, j;
	
	for (i = 1; i < Slq->ColCount; i++)
		for (j = 1; j < Slq->RowCount; j++)
		{
			Slq->Cells[i][j] =
			AS(LpairQuantityAtLkoffsetPlusSlOffset(i, j));
		}
	
	// Update reserved cells
	Slq->Cells[0][0] = "-y="+DimNumString (ydim) + "  x="
	+ DimNumString (xdim);
	for (int i = 1; i < Slq->ColCount; i++)
		Slq->Cells[i][0] = AS (i - 1 + lkoffset.coo[xdim]);
	for (int j = 1; j < Slq->RowCount; j++)
		Slq->Cells[0][j] = AS (j - 1 + lkoffset.coo[ydim]);
	
	if (lgl.OnShowLattices)
		lgl.OnShowLattices=false;
	else
		UpdateActivePage();
}

void Lgl::UpdateSlqCellFromLgl_1 (TStringGrid *Slq) const
{
	Slq->Cells[Slq->Col][Slq->Row] =
	AS(LpairQuantityAtLkoffsetPlusSlOffset(Slq->Col, Slq->Row));
	
	SetF1Caption(NullString);
}

//##### Ende Globallattice ################

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void CorrectAndUpdateSlqCell()
{
	lgl.UpdateLglifCorrectSlqCell_1 (F1->Slq);
	lgl.UpdateSlqCellFromLgl_1 (F1->Slq);
	slqcellupd.uptodate=true;
}

void CorrectAndUpdateSldimAndThenSlq()
{
	lgl.UpdateLglifCorrectSldimCell_1 (F1->Sldim);
	lgl.UpdateSldimSlqFromLgl ();
	sldimqupd.uptodate=true;
}


//-----------------------------------------------------------------
void __fastcall TF1::SlqEnter(TObject *Sender)
{
	if (!sldimqupd.uptodate)
		CorrectAndUpdateSldimAndThenSlq();
}


void __fastcall TF1::SldimSelectCell (TObject *Sender, int ACol, int ARow,
bool &CanSelect)
{
	if (!sldimqupd.uptodate)
		CorrectAndUpdateSldimAndThenSlq();
}

void __fastcall TF1::SlqSelectCell (TObject *Sender, int ACol, int ARow,
bool &CanSelect)
{CorrectAndUpdateSlqCell();}

//---------------------------------------------------------------------------

void __fastcall TF1::LatticesShow(TObject *Sender)
{
	//trf:
	Sldim->Height=Lattices->Height - Sldim->Top;
	Slq->Height=Lattices->Height - Slq->Top;
	Slq->Width=Lattices->Width - Slq->Left;
	
	lgl.OnShowLattices=true;
	CorrectAndUpdateSldimAndThenSlq();
}
//---------------------------------------------------------------------------

void Lgl::Set_xdim (int x_dim)
{
	if (x_dim==xdim) return;
	if (x_dim == ydim) ydim=xdim;//exchange
	xdim = x_dim;
}

void Lgl::Set_ydim (int y_dim)
{
	if (y_dim==ydim) return;
	if (y_dim == xdim) xdim=ydim;
	ydim = y_dim;
}

//---------------------------------------------------------------------------

void __fastcall TF1::SlqMouseMove(TObject *Sender, TShiftState Shift,
int X, int Y)
{slqcellupd.CorrectAndUpdateSlCellOnXYChange (X, Y,	CorrectAndUpdateSlqCell);}

void __fastcall TF1::SldimMouseMove(TObject *Sender, TShiftState Shift,
int X, int Y)
{//   Caption = "wqp mousedebug Sldim : X=" + AS(X) + "   Y=" + AS(Y);
	sldimqupd.CorrectAndUpdateSlCellOnXYChange (X, Y,CorrectAndUpdateSldimAndThenSlq);}
//---------------------------------------------------------------------------

void __fastcall TF1::SldimKeyPress(TObject *Sender, char &Key)
{
	
	if (NoTextChangeKeys.Pos(Key) == 0)//if TextChangeKey
	sldimqupd.uptodate = false;
	
	char c = UpCase(Key);
	
	if (intRegularInput.Pos(c))
		return;
	
	switch (c)
	{
		case '\r': break;
		case 'X':
			lgl.Set_xdim (sl_icoo(Sldim->Row));
			break;
		case 'Y':
			lgl.Set_ydim (sl_icoo(Sldim->Row));
			break;
		case 'P':
		case 'M':
			{
				int add = (c  == 'P') ? 1: - 1;
				Sldim->Cells[Sldim->Col][Sldim->Row] = AS
				(StrToInt(Sldim->Cells[Sldim->Col][Sldim->Row]) + add);
			}
			break;
		default:
			Beep();
			break;
	}
	Key = 0;
	CorrectAndUpdateSldimAndThenSlq();
}

void __fastcall TF1::SlqKeyPress(TObject *Sender, char &Key)
{
	
	if (NoTextChangeKeys.Pos(Key) == 0)//if TextChangeKey
	slqcellupd.uptodate = false;
	
	char c = UpCase(Key);
	
	if (CotypRegularInput.Pos(c))
		return;
	
	switch (c)
	{
		case '\r': break;
		case 'P':
		case 'M':
			{
				cotyp c1;
				c1.InputFromStr(Slq->Cells[Slq->Col][Slq->Row]);
				if (c  == 'P')
					c1 += 1;
				else
					c1 -= 1;
				Slq->Cells[Slq->Col][Slq->Row] = AS(c1);
			}
			break;
		default:
			Beep();
			break;
	}
	Key = 0;
	CorrectAndUpdateSlqCell();
}
//---------------------------------------------------------------------------

void __fastcall TF1::DeleteAll1Click(TObject *Sender)
{
	lgl.lmap.clear();
	lgl.UpdateSlqFromLgl_1 (Slq);
}
//---------------------------------------------------------------------------

bool Input_cotyp_1(cotyp& c,
const AS& headline, const AS& text = NullString,
const AS& edittext = NullString)
{
	bool ok, syntax_ok;
	do
	{
		AS s = edittext;
		ok = InputQuery (headline, text +
		"\nenter (complex rational)  c", s);
		syntax_ok = c.InputFromStr(s);
		if (ok && !syntax_ok)
			Beep();
	}
	while (ok && !syntax_ok);
	return ok;
}

//-------
void InitLkMaxMinZero_3(Lk &lkmax, Lk &lkmin, Lk &lkzero)
{
	for (int i = 0; i < MaxDimCount; ++i)
	{
		lkmax.coo[i] = lcoomax;
		lkmin.coo[i] = lcoomin;
		lkzero.coo[i] = 0;
	}
}

Lmapi UpBound(Lmap& lm, int a)
	//upbound is the first entry with first.coo[nlike] > b
{
	lkmax.coo[nlike] = a;
	return lm.upper_bound(lkmax);
}

Lmapi LoBound(Lmap& lm, int a)
	//lobound is the first entry with first.coo[nlike] >= a
{
	lkmin.coo[nlike] = a;
	return lm.lower_bound(lkmin);
}

void GetLowUpBound_2(Lmapi& lobound, Lmapi& upbound,
Lmap& lm, int a, int b)
//get iterators margins of first.coo[nlike] == a until incl. first.coo[nlike] == b
//lobound is the first entry with first.coo[nlike] >= a
//upbound is the first entry with first.coo[nlike] > b
{
	#ifdef wdebug
	if (a > b)
	{
		upbound = lobound;
		pip (
		"GetLowUpBound_2: a="
		+ AS(a) + " > " + AS(b) + "=b\n"
		"upbound set to lobound");
	}
	#endif
	
	lobound = LoBound(lm, a);
	upbound = UpBound(lm, b);
}

void EraseLglPart(const int a, const int b)
	//erase from n=coo[nlike] == a until inclusive coo[nlike] == b
{
	Lmapi lobound, upbound;
	if (a > b) return;
	GetLowUpBound_2(lobound, upbound, lgl.lmap, a, b);
	lgl.lmap.erase(lobound, upbound);
}

void EraseLglPartOutsideSums1Table
(const int a, const int b, const Sums1Table& ta)
	//erase from n=coo[nlike] == a until inclusive coo[nlike] == b
	//only those points outside current Sums1
{
	Lmap lm;
	Lmapi lobound, upbound, it;
	if (a > b) return;
	int isu;
	
	GetLowUpBound_2(lobound, upbound, lgl.lmap, a, b);
	
	for (it = lobound; it != upbound; ++it)
		for (isu = 0; isu < Sums1_SumCount; ++isu)
			if (it->first.between
			(ta.range[isu][immin],
			ta.range[isu][immax]))
			lm.insert(*it);
	
	lgl.lmap.erase(lobound, upbound);
	for (it = lm.begin(); it != lm.end(); ++it)
		lgl.lmap.insert(*it);
}


void __fastcall TF1::DeletePart1Click(TObject *Sender)
{
	int a, b;
	if (Input_ab_2(a, b, "Delete part of lattice",
	"To delete all quantities with a<=n<=b"))
	{
		EraseLglPart(a, b);
		lgl.UpdateSlqFromLgl_1 (Slq);
	}
}

//---------------------------------------------------------------------------


void __fastcall TF1::Deleteall_n_greater_zeroClick(TObject *Sender)
{
	EraseLglPart(1, intmax);
	lgl.UpdateSlqFromLgl_1 (Slq);
}
//---------------------------------------------------------------------------

void __fastcall TF1::InitForTest1Click(TObject *Sender)
{
	lgl.InitLglSldimSlq (testq);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Initn0with1Click(TObject *Sender)
{
	
	lgl.InitLglSldimSlq (init_n0_with_1);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Initn0with1_1Click(TObject *Sender)
{
	lgl.InitLglSldimSlq (init_n0_with_1_1);
}
//---------------------------------------------------------------------------

void __fastcall TF1::MoveAll1Click(TObject *Sender)
{
	int a;
	if (Input_a_1(a, "Move lattice",
	"To move all quantities from n to n+a"))
	{
		Lmap lm(lgl.lmap);
		//per full copy faster and consideration of zero quantities
		//NO swap of lgl.lmap with local lm !
		lgl.lmap.clear();
		Lmapi it;
		Lpair lp;
		for (it = lm.begin(); it != lm.end(); ++it)
		{
			lp = *it;
			lp.first.coo[nlike] += a;
			lgl.lmap.insert(lp);
		}
		lgl.UpdateSlqFromLgl_1 (Slq);
	}
}
//---------------------------------------------------------------------------

void MoveLglBetweenIncl_ab_to_c(int a, int b, int c)
	// move quantities with a<=n<=b to c (offset=c-a)"))
{
	if (a <= b)
	{
		
		Lmap lm(lgl.lmap); //Copy, s. above
		Lpair lp;
		Lmapi lobound, upbound, it;
		EraseLglPart(a, b);
		EraseLglPart(c, b + c - a);
		
		GetLowUpBound_2(lobound, upbound, lm, a, b);
		for (it = lobound; it != upbound; ++it)
		{
			lp = *it;
			lp.first.coo[nlike] += c - a;
			lgl.lmap.insert(lp); //insert into erased part of lmap
			//        lgl.lmap[lp.first]=lp.second;  //analog, but insert faster
		}
		lgl.UpdateSlqFromLgl_1 (F1->Slq);
	}
}


void __fastcall TF1::MovePart1Click(TObject *Sender)
{
	int a, b, c;
	if (Input_abc_3(a, b, c, "Move lattice part",
	"To move quantities with a<=n<=b to c (offset=c-a)"))
	MoveLglBetweenIncl_ab_to_c(a, b, c);
}
//---------------------------------------------------------------------------


void __fastcall TF1::CopyPart1Click(TObject *Sender)
{
	int a, b, c;
	if (Input_abc_3(a, b, c, "Copy lattice part",
	"To copy quantities with a<=n<=b to c (offset=c-a)"))
	if (a <= b)
	{
		
		Lmap lm(lgl.lmap);
		Lmapi it;
		Lpair lp;
		Lmapi lobound, upbound;
		EraseLglPart(c, b + c - a);
		
		GetLowUpBound_2(lobound, upbound, lm, a, b);
		for (it = lobound; it != upbound; ++it)
		{
			lp = *it;
			lp.first.coo[nlike] += c - a;
			lgl.lmap.insert(lp);
		}
		lgl.UpdateSlqFromLgl_1 (Slq);
	}
}
//---------------------------------------------------------------------------


void __fastcall TF1::ChoosePart1Click(TObject *Sender)
	//Choose: Del all except choosen part and move it to c
{
	int a, b, c;
	if (Input_abc_3(a, b, c, "Choose lattice part",
	"Choose: To move quantities with\n"
	" a<=n<=b to c and delete rest"))
	if (a <= b)
	{
		EraseLglPart(intmin, a-1);
		EraseLglPart(b+1,intmax);
		Lmapi it;
		Lpair lp;
		Lmapi lobound, upbound;
		Lmap lm(lgl.lmap);
		lgl.lmap.clear();
		
		GetLowUpBound_2(lobound, upbound, lm, a, b);
		for (it = lobound; it != upbound; ++it)
		{
			lp = *it;
			lp.first.coo[nlike] += c - a;
			lgl.lmap.insert(lp);
		}
		lgl.UpdateSlqFromLgl_1 (Slq);
	}
}
//---------------------------------------------------------------------------

size_type sizeofLmWith_nlast_1(int& nlast, const Lmap& lm)
{
	size_type lsiz = lm.size();
	if (lsiz)
	{
		const_Lmapi it = lm.end();
		--it;
		nlast = it->first.coo[nlike];
	}
	return lsiz;
}

size_type sizeofLmWith_nfirst_1(int& nfirst, const Lmap& lm)
{
	size_type lsiz = lm.size();
	if (lsiz)
	{
		const_Lmapi it = lm.begin();
		nfirst = it->first.coo[nlike];
	}
	else nfirst=0;//default
	return lsiz;
}

size_type SizeofLm_Calc_nlast_Msg_if_Empty_1(int& nlast, const Lmap& lm)
{
	size_type lsiz = sizeofLmWith_nlast_1(nlast, lm);
	if (!lsiz)
		pip (LatticesEmptyString);
	return lsiz;
}

void Move_last_a_lglrows_to_b_and_del_rest(int a, int b)
	//Choose last: Del all except choosen last a lines and move them to b
{
	int nlast;
	if (a <= 0)
		return;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast, lgl.lmap))
		return;
	EraseLglPart(intmin, nlast-a);
	Lmap lm(lgl.lmap);
	lgl.lmap.clear();
	Lmapi it;
	Lpair lp;
	Lmapi lobound, upbound;
	GetLowUpBound_2(lobound, upbound, lm, nlast + 1 - a, nlast);
	for (it = lobound; it != upbound; ++it)
	{
		lp = *it;
		lp.first.coo[nlike] += a + b - 1 - nlast;
		lgl.lmap.insert(lp);
	}
	lgl.UpdateSlqFromLgl_1 (F1->Slq);
}


void __fastcall TF1::ChooseLast1Click(TObject *Sender)
{
	int a, b;
	if (Input_ab_2(a, b, "Choose last part of lattice",
	"Choose last a rows: To move quantities with\n"
	"nlast-a < n <= nlast to b and delete rest"))
	Move_last_a_lglrows_to_b_and_del_rest(a, b);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Chlasta01Click(TObject *Sender)
{
	int a;
	if (Input_a_1(a, "Choose last part as start in n=0",
	"To choose last a rows, move them\n"
	"after inclusive n=0 and delete rest", "1"))
	Move_last_a_lglrows_to_b_and_del_rest(a, 0);
}
//---------------------------------------------------------------------------


void __fastcall TF1::ChooseFirstClick(TObject *Sender)
{
	int a;
	if (Input_a_1(a, "Choose first: Delete last part of lattice",
	"To delete all quantities with a>=n", "1"))
	{
		EraseLglPart(a, intmax);
		lgl.UpdateSlqFromLgl_1 (Slq);
	}
}
//---------------------------------------------------------------------------

void __fastcall TF1::Chlastb01Click(TObject *Sender)
{
	int a;
	if (Input_a_1(a, "Choose last part as past in n=0",
	"To choose last a rows, move them\n"
	"before inclusive n=0 and delete rest", "1"))
	Move_last_a_lglrows_to_b_and_del_rest(a, 1 - a);
}

//---------------------------------------------------------------------------

void __fastcall TF1::Deleteallbutlast1Click(TObject *Sender)
{
	int a,nlast;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast, lgl.lmap)) return;
	if (Input_a_1(a, "Delete all but last",
	"To erase all of lattice except\n"
	"its last a rows", "1"))
	{
		if (a < 0) return;
		EraseLglPart(intmin, nlast-a);
		lgl.UpdateSlqFromLgl_1 (F1->Slq);
	}
}
//---------------------------------------------------------------------------
void __fastcall TF1::DelAllButLastAndOutsideAktualSums1Click(
TObject *Sender)
{
	int a, nlast;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast, lgl.lmap)) return;
	if (Input_a_1(a, "Del outside Sums1",
	"To erase all of lattice except its part\n"
	"within the Ranges of current Sums1 Table "+AS(s1p.ita)
		+"\nand except its last a rows", "1"))
	{
		if (a < 0) return;
		EraseLglPartOutsideSums1Table(intmin, nlast-a, s1p.ta[s1p.ita]);
		lgl.UpdateSlqFromLgl_1 (F1->Slq);
	}
}
//---------------------------------------------------------------------------

void __fastcall TF1::DelnlastoutsideS1Click(TObject *Sender)
{
	int nlast;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast, lgl.lmap)) return;
	EraseLglPartOutsideSums1Table(nlast, nlast, s1p.ta[s1p.ita]);
	lgl.UpdateSlqFromLgl_1 (F1->Slq);
}
//---------------------------------------------------------------------------
void __fastcall TF1::DelnlastClick(TObject *Sender)
{
	int nlast;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast, lgl.lmap)) return;
	EraseLglPart(nlast, nlast);
	lgl.UpdateSlqFromLgl_1 (F1->Slq);
}
//---------------------------------------------------------------------------



void __fastcall TF1::Info1Click(TObject *Sender)
{
	meld (
	"Date of this version:  " +Compilation.Date()+ "\n\n"
	"Description:\n"
	" Software for testing algorithms\n"
	" on multidimensional numerical lattices\n"
	" and for visualization the results\n\n"
	"Further info:\n"
	"http://www.orthuber.com \n");
}
//---------------------------------------------------------------------------

void __fastcall TF1::Contents1Click(TObject *Sender)
{
	#if 1
	//if use .hlp
	//for following in .hpj map entry contents=1 necessary
	//and contents must be in # footnote of rtf source
	#define contents 1
	Application->HelpContext(contents);
	
	#else
		//if use .chm
		//system( "start hh.exe wqp.chm" ); //geht ber DOS-Fenster, daher:
		STARTUPINFO si = {0};          // Startup info for CreateProcess
	PROCESS_INFORMATION pi = {0};     // Process info returned from CreateProcess
	// Initialize the startup info structure
	si.cb = sizeof(STARTUPINFO);
	if (!CreateProcess(NULL, "hh wqp.chm", NULL, NULL,
	FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi))
	Beep();
	
	#endif
}
//---------------------------------------------------------------------------

void __fastcall TF1::Index1Click(TObject *Sender)
{
	const static int HELP_TAB = 15;
	const static int INDEX_ACTIVE = - 2;
	Application->HelpCommand(HELP_TAB, INDEX_ACTIVE);
	
	//Example for specific call:
	//WinHelp( Application->Handle, "wqp.hlp", HELP_KEY, (DWORD)"Lattice");
	//geht nicht:    WinHelp( Application->Handle, "wqp.chm", HELP_KEY, (DWORD)"Lattice");
	// aber test "C:\WINDOWS\hh.exe" durch Ausfhren von "hh wqp.chm"
}
//---------------------------------------------------------------------------

void __fastcall TF1::Search1Click(TObject *Sender)
{
	const static int HELP_TAB = 15;
	const static int SEARCH_ACTIVE = - 1;
	Application->HelpCommand(HELP_TAB, SEARCH_ACTIVE);
}
//---------------------------------------------------------------------------

void __fastcall TF1::AllToFloat1Click(TObject *Sender)
{
	if (YesToQuestion("Do you want irreversible conversion\n"
	"of all quantities to floating point?"))
	{
		Lmapi it;
		for (it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
			it->second = it->second.florep();
		
		lgl.UpdateSlqFromLgl_1 (F1->Slq);
	}
}

void Lgl::Invert ()
{
	Lmapi it;
	for (it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
		it->second = 1 / it->second;
	
	lgl.UpdateSlqFromLgl_1 (F1->Slq);
}

//---------------------------------------------------------------------------


void __fastcall TF1::Invert1Click(TObject *Sender)
{
	if (Invert1->Checked)
	{
		if (YesToQuestion ("Actually nonzero quantities of lattice are\n"
		"represented in inverted form (1/quantity).\n"
		"Do you again want regular representation\n"
		"of all quantities?"))
		{
			Invert1->Checked = false;
			lgl.Invert();
			F1->Label_quantities->Caption = "quantities";
			F1->Label_quantities->ParentColor = true;
			F1->Label_quantities->ParentFont = true;
			F1->Slq->Color = clWindow;
		}
	}
	else //not Invert1->Checked
	if (YesToQuestion("Actually all quantities of lattice are\n"
	"represented regularly (non-inverted).\n"
	"Do you want inverted representation\n"
	"of nonzero quantities in the form 1/quantity?"))
	{
		Invert1->Checked = true;
		lgl.Invert();
		F1->Label_quantities->Caption = "   nonzero quantities inverted   ";
		F1->Label_quantities->Color = clBlack;
		F1->Label_quantities->Font->Color = clWhite;
		F1->Slq->Color = cl3DLight;
	}
}
//---------------------------------------------------------------------------

AS s_nlast()
{
	int nlast;
	size_type lsiz = sizeofLmWith_nlast_1(nlast, lgl.lmap);
	if (lsiz)
	{
		return "nlast = " + AS(nlast)
			+ " (" + FormatFloat(s_kb_format,
			double(double(lsiz)*LpairSize)/1000.0) + " KB = "
			+ AS(lsiz) + "e)";
	}
	else
		return LatticesEmptyString;
}

AS s_LatticesState()
{
	size_type lsiz = lgl.LmapSize();
	return "Lattice: " + AS(lsiz) + " non-zero points\n"
	"used bytes: "
	+ FS(lsiz) + " * "
	+ FS(LpairSize) + " = "
	+ FS(double(lsiz)*LpairSize) + "\n" + s_nlast();
}

AS hms_string_from_seconds(const int &seconds)
{
	int h=seconds/3600; int sm=seconds%3600;
	int m=sm/60; int s=sm%60;
	return AS(h)+" hours "+AS(m)+" min "+AS(s)+" sec";
}

void __fastcall TF1::State1Click(TObject *Sender)
{
	AS stime_of_last_algadd;
	if (aav.needed_seconds_of_last_algadd)
		stime_of_last_algadd="\n\nThe last "+AS(aav.stepcount_of_last_algadd)
			+" steps of Algadd needed "+AS(aav.needed_seconds_of_last_algadd)
				+" sec\n resp. "+
				hms_string_from_seconds(aav.needed_seconds_of_last_algadd)
					+"\n(average: "+FS(double(aav.needed_seconds_of_last_algadd)
					/double(aav.stepcount_of_last_algadd))
					+" seconds per step)";
				else
					stime_of_last_algadd=NullString;
	
	int tnr = MessageDlg (s_LatticesState() + stime_of_last_algadd +
	"\n\nPress <All> to check all available memory\nelse <OK>",
	mtInformation, TMsgDlgButtons () << mbOK << mbAll, 0);
	if (tnr != mrAll)
		return;
	meld(FS(MB_allocatable())+" MB are allocatable\n"
	"using RAM and virtual memory on HD");
}
//---------------------------------------------------------------------------

//-------------------- Algadd:

void TF1::InitFixedSlAlgadd()
{
	SlAlgadd->RowCount = SlAlgadd_RowCount;
	SlAlgadd->ColCount = Algadd_EntryCount + 1;
	
	SlAlgadd->Cells[0][SlAlgadd_Row_of_p] = "p";
	SlAlgadd->Cells[0][SlAlgadd_Row_ldest] = "ldest";
	
	for (int i = 1; i < SlAlgadd->ColCount; i++)
		SlAlgadd->Cells[i][0] = AS (i-1);
	for (int j = SlAlgaddRowIndexOffset; j < SlAlgadd->RowCount; j++)
		SlAlgadd->Cells[0][j] =
		DeltaDimNumString (sl_icoo(j - SlAlgaddRowIndexOffset));
	
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
}

void TF1::InitFixedSllist()
{
	Sllist->ColCount = MaxDimCount + 2;//+1 for fixed col, +1 for quantity
	Sllist->Cells[0][0] = " Nr";
	Sllist->Cells[1][0] = "    quantity";
	for (int i = 0; i < MaxDimCount; ++i)
		Sllist->Cells[2+sl_irow(i)][0] = aspace+DimNumString(i);
}


void AlgaddVar::InitEntriesOfTable(int ia)
{
	for (int i = 0; i < Algadd_EntryCount; ++i)
		ae[ia][i] = ae_empty;
}

void AlgaddVar::InitAllEntries()
{
	for (int ia = 0; ia < Algadd_TableCount; ++ia)
		InitEntriesOfTable(ia);
}

AlgaddVar::AlgaddVar()
{
	stepcount_of_last_algadd = aanr = 0;
	ae_empty.p = 0.0;
	ae_empty.ldest = 0;
	for (int j = 0; j < MaxDimCount; ++j)
		ae_empty.lkadd.coo[j] = 0;
	ae_empty.lkadd.coo[nlike] = 1;
	
	imm_selected_entries[immin]=0;
	imm_selected_entries[immax]=Algadd_EntryCount-1;
	
	InitAllEntries();
}

void CloseGroupBox_aat()
{
	F1->GroupBox_aat->Visible=false;
	F1->SlAlgadd->SetFocus();
}

void AlgaddVar::UpdateSlAlgaddFromAlgaddVar_1 (TStringGrid *SlAlgadd) const
{
	SlAlgadd->Cells[0][0] = AS(aav.aanr)+"=aanr";
	int i, j;
	//next loop needs some time in dependence of Algadd_EntryCount:
	for (i = 1; i < F1->SlAlgadd->ColCount; ++i)
	{
		SlAlgadd->Cells[i][SlAlgadd_Row_of_p] = AS(ae[aanr][i - 1].p); //cotyp
		SlAlgadd->Cells[i][SlAlgadd_Row_ldest] = AS(ae[aanr][i - 1].ldest);
		for (j = SlAlgaddRowIndexOffset; j < F1->SlAlgadd->RowCount; ++j)
			SlAlgadd->Cells[i][j] =
			AS (ae[aanr][i - 1].lkadd.
			coo[sl_icoo(j - SlAlgaddRowIndexOffset)]);
	}
	F1->GroupBox_aat->Visible=false;
}

void AlgaddVar::IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (TStringGrid *SlAlgadd) const
{
	SetMainMenuCaptions();
	if (F1->PaCo->ActivePage == F1->Algadd) UpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
}

void AlgaddVar::CopyTable2to1(int idest, int isrc)
{for (int i=0; i<Algadd_EntryCount;++i) ae[idest][i]=ae[isrc][i];}

void AlgaddVar::UpdateSlAlgaddCellFromAlgaddVar_1 (TStringGrid *SlAlgadd) const
{
	if (SlAlgadd->Row == SlAlgadd_Row_of_p)
		SlAlgadd->Cells[SlAlgadd->Col][SlAlgadd->Row] =
		AS(ae[aanr][SlAlgadd->Col - 1].p);
	else
	{
		if (SlAlgadd->Row == SlAlgadd_Row_ldest)
			SlAlgadd->Cells[SlAlgadd->Col][SlAlgadd->Row] =
			AS(ae[aanr][SlAlgadd->Col - 1].ldest);
		else
			SlAlgadd->Cells[SlAlgadd->Col][SlAlgadd->Row] = AS(
			ae[aanr][SlAlgadd->Col - 1].lkadd.
			coo[sl_icoo(SlAlgadd->Row - SlAlgaddRowIndexOffset)]);
	}
}

void AlgaddVar::SetAlgCaptions()
{
	F1->ChangeAlgaddNr->Caption = "Change aanr=" + AS(aanr);
	bool fifempty;
	{
		int nfirst;
		size_type lsiz = sizeofLmWith_nfirst_1(nfirst, lgl.lmap);
		if (lsiz)
		{F1->DelAfterFirstAndDoAlgadd->Caption
			= "Del n>nf="+AS(nfirst)+", "+AS(cp.kmi("Algadd_DefaultStepCount"))+" AA";
			fifempty=true;}
		else
		{F1->DelAfterFirstAndDoAlgadd->Caption= "<Lattices empty>";
			fifempty=false;}
	}
	F1->StartAlgadd0->Enabled =
	aav.UsedEntryCount(0) ? fifempty:false;
	F1->StartAlgadd1->Enabled =
	aav.UsedEntryCount(1) ? fifempty:false;
	F1->StartAlgadd2->Enabled =
	aav.UsedEntryCount(2) ? fifempty:false;
	F1->StartAlgadd->Enabled =
	aav.UsedEntryCount(aav.aanr) ? fifempty:false;
	F1->DelAndDoAlgaddSteps->Enabled =
	aav.UsedEntryCount(aav.aanr) ? fifempty:false;
	F1->DelAfterFirstAndDoAlgadd->Enabled =
	aav.UsedEntryCount(aav.aanr) ? fifempty:false;
	F1->DelAndDoAlgaddSteps->Caption
	= "Del n>0, then "+AS(cp.kmi("Algadd_DefaultStepCount"))+" AA";
	
	F1->StartdeletingAlgadd->Enabled =
	aav.UsedEntryCount(aav.aanr) ? fifempty:false;
	F1->StartAlgaddDelOutsideSums1->Enabled =
	aav.UsedEntryCount(aav.aanr) ? fifempty:false;
	F1->AATrackingMode->Enabled =
	aav.UsedEntryCount(aav.aanr) ? fifempty:false;
}

void AlgaddVar::CorrectSlAlgaddCellOrUpdateAlgaddVar()
{
	if (F1->SlAlgadd->Row == SlAlgadd_Row_of_p)
	{
		cotyp vl;
		if (vl.InputFromStr (F1->SlAlgadd->Cells[F1->SlAlgadd->Col][F1->SlAlgadd->Row]))
			ae[aanr][F1->SlAlgadd->Col - 1].p = vl;
		else
			Beep();
	}
	else//if integer input
	{
		int k;
		if (TryStrToInt (F1->SlAlgadd->Cells[F1->SlAlgadd->Col][F1->SlAlgadd->Row], k))
		{
			if (F1->SlAlgadd->Row == SlAlgadd_Row_ldest)
				ae[aanr][F1->SlAlgadd->Col - 1].ldest = k;
			else//if input of lkadd
			{
				ae[aanr][F1->SlAlgadd->Col - 1].lkadd.coo
				[sl_icoo(F1->SlAlgadd->Row - SlAlgaddRowIndexOffset)] = k;
			}
		}//if no int
		else
			Beep();
	}
	UpdateSlAlgaddCellFromAlgaddVar_1 (F1->SlAlgadd);
	slaaupd.uptodate = true;
}

void __fastcall TF1::SlAlgaddSelectCell(TObject *Sender, int ACol,
int ARow, bool &CanSelect)
{
	aav.CorrectSlAlgaddCellOrUpdateAlgaddVar();
}
//---------------------------------------------------------------------------

void __fastcall TF1::SlAlgaddKeyPress(TObject *Sender, char &Key)
{
	if (Key=='\x1B')
	{
		CloseGroupBox_aat();
		return;
	}
	
	if (SlAlgadd->Row - SlAlgaddRowIndexOffset - 1 == nlike)
	{
		Beep(); //n == time-directional, add=1 obligat
		Key = 0;
		return;
	}
	
	if (NoTextChangeKeys.Pos(Key) == 0)
		slaaupd.uptodate = false;
	
	char c = UpCase(Key);
	
	if (CotypRegularInput.Pos(c))
		return;
	
	switch (c)
	{
		case '\r': break;
			aav.UpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
		case 'Q'://TableIndex -1
			if (aav.aanr > 0)
				aav.aanr--;
			else
				aav.aanr = Algadd_TableCount - 1;
			cp.setkmi_1("Algadd_DefaultTableIndex", aav.aanr);
			SetMainMenuCaptions();
			aav.UpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
			break;
		case 'W'://TableIndex +1
			if (aav.aanr < Algadd_TableCount - 1)
				aav.aanr++;
			else
				aav.aanr = 0;
			cp.setkmi_1("Algadd_DefaultTableIndex", aav.aanr);
			SetMainMenuCaptions();
			aav.UpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
			break;
		case 'P':
		case 'M':
			{
				int add = (c  == 'P') ? 1: - 1;
				
				if (SlAlgadd->Row == SlAlgadd_Row_of_p)
				{
					cotyp c1;
					c1.InputFromStr(SlAlgadd->Cells[SlAlgadd->Col][SlAlgadd->Row]);
					c1 += add;
					SlAlgadd->Cells[SlAlgadd->Col][SlAlgadd->Row] = AS(c1);
				}
				else//if integer
				{
					int k = add + StrToInt (SlAlgadd->Cells[SlAlgadd->Col][SlAlgadd->Row]);
					SlAlgadd->Cells[SlAlgadd->Col][SlAlgadd->Row] = StrToInt(k);
				}
			} break;
			
		default: Beep(); break;
	}
	Key = 0;
	aav.CorrectSlAlgaddCellOrUpdateAlgaddVar ();
}
//---------------------------------------------------------------------------
void aavCorrfunc()
{aav.CorrectSlAlgaddCellOrUpdateAlgaddVar();}

void __fastcall TF1::SlAlgaddMouseMove(TObject *Sender,
TShiftState Shift, int X, int Y)
{slaaupd.CorrectAndUpdateSlCellOnXYChange(X, Y,aavCorrfunc);}
//---------------------------------------------------------------------------

bool AlgaddEntriesEqual(const AlgaddEntry& a1, const AlgaddEntry& a2)
{
	if (a1.p != a2.p) return false;
	if (a1.ldest != a2.ldest) return false;
	for (int j = 0; j < MaxDimCount; ++j)
		if (a1.lkadd.coo[j] != a2.lkadd.coo[j]) return false;
	return true;
}


int AlgaddVar::UsedEntryCount(int aanrloc)
{
	int ucom = - 1;
	for (int i = 0; i < Algadd_EntryCount; ++i)
		if (!AlgaddEntriesEqual(ae[aanrloc][i],ae_empty))
			//if (ae[aanrloc][i].p!= 0)//causes auto del trailing ae with p=0
			ucom = i;
	return ucom + 1;
}

void AlgaddVar::CompressEntry(int aanrloc)
{
	int i, j;
	AlgaddVar aavloc(*this); //*this=aav
	InitEntriesOfTable(aanrloc); //del table
	
	//copy used entries back:
	for (j = 0, i = 0; i < Algadd_EntryCount; ++i)
		if (aavloc.ae[aanrloc][i].p!= 0)
		{
			ae[aanrloc][j] = aavloc.ae[aanrloc][i];
			++j;
		}
}

void AlgaddVar::CompressAllEntries()
{
	if (cp.kmi("Algadd_del_p0_entries"))
		for (int aanrloc=0; aanrloc<Algadd_TableCount;++aanrloc)
			CompressEntry(aanrloc);
}


int AlgaddVar::UsedEntryCount_After_Compression(int aanrloc)
{
	if (cp.kmi("Algadd_del_p0_entries"))
		CompressEntry(aanrloc);
	return UsedEntryCount(aanrloc);
}

void AlgaddVar::AddLpairToLmap_1
(Lmap &lm, Lmapi it_org, int used_entry_count, int aanr_current) const
//add to next n ( because lkadd[nlike]=1 )
{
	Lpair lp;
	int i, j;
	
	#if 0
	if (it_org->second == NullQuantity)
		pip ("AddLpairToLmap_1: add of zero quantity, probably underflow");
	#endif
	
	if (it_org->second == NullQuantity)
		throw w_exception("AddLpairToLmap_1: add of zero quantity,\n"
		"probably underflow");
	
	for (i = 0; i < used_entry_count; ++i)
		if (ae[aanr_current][i].p!= 0 &&
		ae[aanr_current][i].lkadd.coo[llike] == it_org->first.coo[llike])//if lkadd spec fits
	{
		lp.first = ae[aanr_current][i].lkadd;
		
		for (j = 0; j < MaxDimCount; ++j)
			lp.first.coo[j] += it_org->first.coo[j]; //therefore Alg"Add"
		
		lp.first.coo[llike] = ae[aanr_current][i].ldest; //add only to those spec
		
		Lmapi li = lm.find(lp.first);
		if (li == lm.end())
		{
			lp.second = ae[aanr_current][i].p * it_org->second;
			if (lp.second != NullQuantity) lm.insert(lp);
		}
		else
		{
			li->second = li->second + ae[aanr_current][i].p * it_org->second;
			if (li->second == NullQuantity)
				lm.erase(li);
		}
	}
}

AS S_Exception_DelNlastOfLmap(int n_current)
{
	int nla = n_current + 1;
	EraseLglPart(nla, nla);
	return
	"\n\nLast n=" + AS(nla) + " deleted, because not necessarily complete.";
}
//-----------------------
//begin absorbing barrier (obarr) -----------------------------

class obarrclass{ //absOrbing_barrier_class
	int absorbing0_ld1,absorbing1_ld2;
	int absorbing1_k1;
	int k1_of_add_to_ldest2;
	cotyp absorbing1_mult_to_ld2;
	public:
	obarrclass();
	AS obarr_comment() const;
	void do_absorption_1(Lmap &lm, const int &n_current) const;
};

obarrclass::obarrclass(){
	absorbing0_ld1	= cp.kmi("Obarr0_ldest1");
	absorbing1_ld2	= cp.kmi("Obarr1_ldest2");
	absorbing1_k1	= cp.kmi("Obarr1_k1");
	k1_of_add_to_ldest2	= cp.kmi("Obarr1_k1_of_add_ldest2");
	absorbing1_mult_to_ld2.assign	(cp.kmi("Obarr1_multp_ldest2"),100,0,1);
}

AS obarrclass::obarr_comment() const
{
	if (!absorbing0_ld1) return NullString;
	else
	{
		return
		"The origin, i.e. (0,0...,0), of lattice 0\n"
		"is defined as absorbing barrier and will\n"
		"be set to 0 after every iteration.\n"
		"The absorbed quantity will be moved\n"
		"to (0,0...,0) of lattice "+AS(absorbing0_ld1)+
		" in which ("+AS(absorbing1_k1)+",0...,0)\nis absorbing "
		"and the there absorbed\nquantities will be added to ("+
		AS(k1_of_add_to_ldest2)+",0,0...,0)\n"
		"of lattice "+AS(absorbing1_ld2)+
		" after multiplication by "+AS(absorbing1_mult_to_ld2)+" .\n" ;
	}
}

void obarrclass::do_absorption_1(Lmap &lm, const int &n_current) const
{
	if (!absorbing0_ld1) return;
	
	cotyp ld1_second_multiplied;
	Lpair lp;
	lp.first = lkzero;
	lp.first.coo[nlike]=n_current+1;//last alg-add has been done to n_current+1
	
	//absorb at 0 in latttice 0
	Lmapi li = lm.find(lp.first);
	if (li != lm.end())//if something at absorbing barrier
	{
		lp.second = li->second;//save it
		lm.erase(li);//erasing equivalent to li.second=0.0 => absorption
	}
	else lp.second=NullQuantity;//lp.second now defined source of ld2
	
	//absorb at k1 in ld1
	lp.first.coo[llike]=absorbing0_ld1;
	lp.first.coo[1]=absorbing1_k1;
	li = lm.find(lp.first);
	if (li != lm.end())//if ld1 nonzero at k1
	{
		ld1_second_multiplied=li->second*absorbing1_mult_to_ld2;//save it
		lm.erase(li);//erase resp absorb it
	}
	else 	ld1_second_multiplied=NullQuantity;
	
	//add lp_second (of barrier0) to origin in ld1
	lp.first.coo[1]=0;//k1=0 in origin
	li = lm.find(lp.first);
	if (li != lm.end())//if ld1 nonzero at origin
	{
		li->second = li->second + lp.second;
		if (li->second == NullQuantity)	lm.erase(li);
	}
	else if (lp.second!=NullQuantity) lm.insert(lp);
	
	//add ld1_second_multiplied to k1_of_add_to_ldest2 in ld2
	if (ld1_second_multiplied != NullQuantity)
	{	lp.second = ld1_second_multiplied;
		lp.first.coo[llike]=absorbing1_ld2;
		lp.first.coo[1]=k1_of_add_to_ldest2;
		li = lm.find(lp.first);
		if (li != lm.end())
		{
			li->second = li->second + lp.second;//in ld2 no absorption
			if (li->second == NullQuantity)	lm.erase(li);
		}
		else lm.insert(lp);
	}
}

//end absorbing -----------------------------

void SignalExceedingOf_MaxAllowedMemOccupationInKB()
{pip (s_LatticesState() +
	"\nStop, because more memory used \n"
	"than specified in configuration by "
	"MaxAllowedMemOccupationInKB");
}

void AlgaddVar::PerformAlgadd(int aanr_current, AlgaddDelmode aadelmode,
const AS& s_explanation, int stepcount)
//if stepcount<0, Input_a_1(stepcount...
{
	obarrclass obarr;
	int nlast_before_aa;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast_before_aa, lgl.lmap))
		return;
	if (stepcount<0)
	{
		MMI mmi;
		mmi.i = cp.kmi("Algadd_DefaultStepCount");
		mmi.min=0;
		mmi.max=intmax;
		if (Input_i_of_mmi_1(mmi,"Perform Algadd " + AS(aanr_current),s_explanation
		+obarr.obarr_comment()
			+"\nFor i iterations of  Algadd "
			+ AS(aanr_current) + "  from n="
			+ AS(nlast_before_aa) + " on"))
			stepcount=mmi.i;
		else
			return;
	}
	if (!stepcount)
		return;
	
	long seconds_on_algadd_start, seconds_on_algadd_end;
	
	seconds_on_algadd_start = time(NULL);
	
	F1->Repaint();
	
	Lmapi lobound;
	int n_upper = nlast_before_aa + stepcount;
	Lmap lm;
	int uco = UsedEntryCount_After_Compression(aanr_current);
	
	const double mdstep = 1000.0*cp.kmi("Algadd_mem1_DisplayAfterKB");
	double mem_next_display = mdstep;
	
	double mem_break = 1000.0*cp.kmi("MaxAllowedMemOccupationInKB");
	double mem_DelSmallestAfterKB = 1000.0*cp.kmi("Algadd_TM_DelSmallestAfterKB");
	int first_del_row=cp.kmi("Algadd_TM_DelAlsoTillRow0")?intmin:1;
	
	
	double mem_occupied;
	bool stopadd = false;
	int n_current;
	Lmapi it;
	
	size_type lsiz;
	lsiz = lgl.LmapSize();
	mem_occupied = double(lsiz)*LpairSize;
	probar pb(nlast_before_aa, n_upper - 1);
	AS s1,s2;
	AS sa[aad_AlgaddDelmodesize]={"Algadd ","d. Algadd ","o.d. Algadd ", "D:0  Algadd:"};
	int aad_tm_delcount=0;
	bkc bk;
	
	try
	{
		for (n_current = nlast_before_aa; n_current < n_upper && !stopadd; ++n_current)
			//for validity of ++n_current is lkadd.coo[nlike] == 1 necessary
		{
			lobound = LoBound(lgl.lmap, n_current);
			for (it = lobound; it != lgl.lmap.end(); ++it)
				AddLpairToLmap_1(lm, it, uco, aanr_current);
			
			obarr.do_absorption_1(lm,n_current);
			
			for (it = lm.begin(); it != lm.end(); ++it)
				lgl.lmap.insert(*it);
			lm.clear();
			
			lsiz = lgl.LmapSize();
			mem_occupied = double(lsiz)*LpairSize;
			
			if (mem_occupied > mem_next_display
			|| mem_occupied > mem_DelSmallestAfterKB
			|| mem_occupied > mem_break)
			{
				s1 = sa[aadelmode]+AS(aanr_current)
					+" : " + AS(n_current + 1)
						+ "=n, all lattices have "
						+ AS(lsiz) + " points, ";
				s2 = FormatFloat(s_kb_format,
				double(mem_occupied)/1000.0) + " KB used";
				
				F1->Caption = s1 + s2;
			}
			
			if (aadelmode!=aad_NoDel)
			{
				if (aadelmode==aad_DelAllButLast)
					EraseLglPart(intmin, n_current);
				else
					if (aadelmode==aad_DelAllButLastAndSums1
					|| aadelmode==aad_TrackingMode)
				{
					EraseLglPartOutsideSums1Table
					(first_del_row, n_current, s1p.ta[s1p.ita]);
					
					if (aadelmode==aad_TrackingMode
					&& mem_occupied > mem_DelSmallestAfterKB)
					{
						if (cp.kmi("Algadd_TM_BeepOnDelSmallest")) Beep();
						
						Delete_smallest_percent_of_nlastRow_in_lmap
						(cp.kmi("DelSmallPercent_Default"));
						pb.init(nlast_before_aa, n_upper - 1);
						sa[aad_TrackingMode]="D:"+AS(++aad_tm_delcount)+" Algadd:";
					}
				}
				lsiz = lgl.LmapSize();
				mem_occupied = double(lsiz)*LpairSize;
			}
			if (mem_occupied > mem_break)
			{
				SignalExceedingOf_MaxAllowedMemOccupationInKB();
				stopadd = true;
			}
			if (bk.breaksignaled()) stopadd=true;
			
			if (mem_occupied > mem_next_display)
				mem_next_display = mem_occupied+mdstep;
			
			pb.SetProgressBarPosition(n_current);
		}
	}
	catch (exception& e)
	{
		pip(AS(e.what())
		+ S_Exception_DelNlastOfLmap(n_current));
	}
	catch (EOverflow&)
	{
		pip("Break because of floating point overflow in Algadd\n"
		+ S_Exception_DelNlastOfLmap(n_current));
	}
	catch (EMathError& ema)
	{
		pip("Break because of MathError in Algadd:\n"
		+ ema.Message
		+ S_Exception_DelNlastOfLmap(n_current));
	}
	catch (...)
	{
		pip("Break because of Algadd error"
		+ S_Exception_DelNlastOfLmap(n_current));
	}
	
	seconds_on_algadd_end = time(NULL);
	needed_seconds_of_last_algadd=
	seconds_on_algadd_end-seconds_on_algadd_start;
	stepcount_of_last_algadd=n_current - nlast_before_aa;
	
	lgl.UpdateSlqFromLgl_1 (F1->Slq);
	SetF1Caption(NullString);
}


//---------------------------------------------------------------------------

void __fastcall TF1::ChangeAlgaddNrClick(TObject *Sender)
{
	MMI mmi;
	mmi.i = aav.aanr;
	mmi.min=0;
	mmi.max=Algadd_TableCount - 1;
	if (Input_i_of_mmi_1(mmi,"Algadd Nr.",
	"To choose Algadd table index"))
	{
		aav.aanr = mmi.i;
		cp.setkmi_1("Algadd_DefaultTableIndex", aav.aanr);
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
	}
}
//---------------------------------------------------------------------------

void __fastcall TF1::SlAlgaddMouseDown(TObject *Sender,
TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button == mbRight)
	{
		int i, j, k;
		
		for (j = 0, i = 0, k=0; i < Algadd_TableCount; ++i)
			if (aav.UsedEntryCount(i)) {++j; k=i;}
		
		GroupBox_aat->Caption=
		" Table "+AS(aav.aanr)+"   ( "
		+AS(k+1-j)+" empty in 0.."+AS(k)
			+" ,    "+AS(Algadd_TableCount-j)
				+" empty in 0.."+AS(Algadd_TableCount-1)+" ) ";
		
		Set_Caption_of_Button_aat_Select_p();
		GroupBox_aat->Visible=true;
	}
}
//---------------------------------------------------------------------------
void __fastcall TF1::StartAlgadd0Click(TObject *Sender)
{
	aav.PerformAlgadd(0, aad_NoDel);
}
//---------------------------------------------------------------------------
void __fastcall TF1::StartAlgadd1Click(TObject *Sender)
{
	aav.PerformAlgadd(1, aad_NoDel);
}
//---------------------------------------------------------------------------


void __fastcall TF1::StartAlgadd2Click(TObject *Sender)
{
	aav.PerformAlgadd(2, aad_NoDel);
}
//---------------------------------------------------------------------------

void __fastcall TF1::StartAlgaddClick(TObject *Sender)
{
	aav.PerformAlgadd(aav.aanr, aad_NoDel);
}
//---------------------------------------------------------------------------

void __fastcall TF1::DelAndDoAlgaddStepsClick(TObject *Sender)
{
	EraseLglPart(1, intmax);
	lgl.UpdateSlqFromLgl_1 (Slq);
	aav.PerformAlgadd(aav.aanr, aad_NoDel, NullString, cp.kmi("Algadd_DefaultStepCount"));
}

void __fastcall TF1::DelAfterFirstAndDoAlgaddClick(TObject *Sender)
{
	
	int nfirst;
	size_type lsiz = sizeofLmWith_nfirst_1(nfirst, lgl.lmap);
	if (!lsiz) pip (LatticesEmptyString); else
	{
		EraseLglPart(nfirst+1, intmax);
		lgl.UpdateSlqFromLgl_1 (Slq);
		aav.PerformAlgadd(aav.aanr, aad_NoDel, NullString, cp.kmi("Algadd_DefaultStepCount"));
	}
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TF1::StartdeletingAlgaddClick(TObject *Sender)
{
	aav.PerformAlgadd(aav.aanr, aad_DelAllButLast,
	"DelAllButLast: to save maximal memory, after every step\n"
	"all lattice points except those with n=nlast\n"
	"(history) will be deleted"
	"\n"
	);
}
//---------------------------------------------------------------------------
const AS saa_del_declaration=
"To save memory, after every step\n"
"all lattice points outside\n"
"the current Sums1 table "+AS(s1p.ita)
	+"\nwith n<nlast will be deleted.\n"
	"So history of current Sums1 definition\n"
	"remains available."
	"\n";

void __fastcall TF1::StartAlgaddDelOutsideSums1Click(
TObject *Sender)
{
	aav.PerformAlgadd(aav.aanr, aad_DelAllButLastAndSums1,saa_del_declaration);
}
//---------------------------------------------------------------------------
void __fastcall TF1::AATrackingModeClick(TObject *Sender)
{
	aav.PerformAlgadd(aav.aanr,aad_TrackingMode,saa_del_declaration
	+"\nAdditionally the smallest "+AS(cp.kmi("DelSmallPercent_Default"))
		+"\npercent of the last row nlast are deleted\n"
		"iteratively every time when more\n"
		"than "+AS(cp.kmi("Algadd_TM_DelSmallestAfterKB"))+" KB are used.\n");
}
//---------------------------------------------------------------------------

void ClearLatticesAlgaddMemo()
{
	lgl.lmap.clear();
	aav.InitAllEntries();
	F1->Memo_Comment->Clear();
}

bool GetFnFromOpenDialog(const AS& title)
	//return true, if fn valid
{
	F1->OpenDialog1->DefaultExt = FileEndDefault;
	AS FileEndFilter = FileEndDefault +
	" files (*." + FileEndDefault + ")|*." + FileEndDefault;
	F1->OpenDialog1->FileName = fn;
	return GetFnFromOpenDialog_1(fn, title, FileEndFilter);
}


void ReadFromFn(const int nelast)
	//if (nelast==this_nelast_means_read_config_only) read only config, don't init
	//else init and read all but lattice points with n>nelast
{
	//DecimalSeparator=',';//old, only for conversion of files with "," as DecimalSeparator
	
	if (F1->PaCo->ActivePage == F1->Graph2)
		F1->PaCo->ActivePage = F1->Graph1;//avoid double plotting
	
	F1->Repaint();
	
	ifstream in(fn.c_str());
	if (!in)
	{SignalOpenErr(fn);	return;}
	
	if (nelast!=this_nelast_means_read_config_only)
		ClearLatticesAlgaddMemo();
	
	AS s, s_error;
	string s1;
	int dstep = cp.kmi("File_IO_PointCountPerDisplay");
	int lp_count = 0; //lattice_point_count
	int i = 0;
	bool lineok = true;
	LP_State lp_state = no_lattice_point;
	
	int lsiz_of_infile = 0;
	AS s_lsiz = NullString;
	
	while (lineok && getline(in, s1) && lp_state != lp_above_nelast)
	{
		++i;
		s = s1.c_str(); //the same as s=AS(s1.c_str());
		//inverse would be: s1=s.c_str();
		s_error = cp.ProcessFileInputLine_2(lsiz_of_infile, lp_state, nelast, s);
		
		lineok = s_error == NullString;
		if (lp_state == lattice_point_read)
		{
			++lp_count;
			if (lineok && !(lp_count%dstep))
			{
				probar pb;
				if (lsiz_of_infile && s_lsiz == NullString)
				{
					pb.init(0, lsiz_of_infile);
					s_lsiz = " of " + AS(lsiz_of_infile);
				}
				pb.SetProgressBarPosition(lp_count);
				F1->Caption = "lattice point " + AS(lp_count)
					+ s_lsiz + " read from " + fn;
			}
		}
		
		if (!lineok)
		{
			if (warnlevel>=wl_beep) Beep();
			if (warnlevel>=wl_usual)
			{
				int tnr = MessageDlg ("Error reading line "
				+ IntToStr(i) + " of " + fn + ":\n" + s_error
				+"\n(Abort of reading will cause default init.)"
				+"\n\nDo you want to proceed?",
				mtInformation, TMsgDlgButtons () << mbYes << mbAbort, 0);
				if (tnr == mrYes) lineok=true;
			}
			else lineok=true;
		}
	}
	if (!lineok)
	{
		cp.IkUk_and_CphInit();
		ClearLatticesAlgaddMemo();
	}
	else
		user_has_entered_fn = true;
	
	if (!cp.FirstPassBeforeCfgUpdate)
	{
		cp.InitPrgParAndSlconfig(false);
		lgl.UpdateSldimSlqFromLgl ();
		aav.CompressAllEntries();
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
		
		F1->PaCo->ActivePageIndex = cp.kmi("F1_Initial_Active_Page");
		
		SetF1Caption(NullString);
		//DecimalSeparator='.';//only, if above changed (s.o.)
	}
}

void ReadConfigFromFnCfgIfExistent()
{
	if (FnCfgExists())
	{
		AnsiString afn=fn;
		fn=FnCfg;
		ReadFromFn(this_nelast_means_read_config_only);
		fn=afn;
	}
}

void ReadFromFnAndFnCfg(const int nelast)
{
	if (FnCfgExists()) cp.FirstPassBeforeCfgUpdate=true;
	ReadFromFn(nelast);
	cp.FirstPassBeforeCfgUpdate=false;
	ReadConfigFromFnCfgIfExistent();
}

AnsiString s_fn_cfg_hint()
{
	return FnCfgExists()?
	"(uniform config from "+FnCfg+")":NullString;
}

void __fastcall TF1::OpenClick(TObject *Sender)
{
	if (GetFnFromOpenDialog("Open File and read it"+s_fn_cfg_hint()))
		ReadFromFnAndFnCfg(intmax);
}
//---------------------------------------------------------------------------
void __fastcall TF1::ReadagainClick(TObject *Sender)
{	if (user_has_entered_fn) ReadFromFnAndFnCfg(intmax);
	else OpenClick(this);}
//---------------------------------------------------------------------------

void __fastcall TF1::Read_individualClick(TObject *Sender)
{
	//read and ignore uniform default cfg
	if (GetFnFromOpenDialog("Read File, use its individual cfg"))
		ReadFromFn(intmax);
}
//---------------------------------------------------------------------------


void __fastcall TF1::ReadTillNelastClick(TObject *Sender)
{
	int nelast = cp.kmi("File_in_nelast");
	if (GetFnFromOpenDialog("Read all but lattices only till n=" + AS(nelast)
	+aspace+s_fn_cfg_hint()))
	ReadFromFnAndFnCfg(nelast);
}
//---------------------------------------------------------------------------
void __fastcall TF1::ReadNewCfgClick(TObject *Sender)
{
	AnsiString s=FnCfgExists()?
	", ignore "+FnCfg:NullString;
	
	if (GetFnFromOpenDialog("Read uniform configuration only"+s))
		ReadFromFn(this_nelast_means_read_config_only);
}
//---------------------------------------------------------------------------

void __fastcall TF1::CWarnlevelClick(TObject *Sender)
{ChangeWarnLevel();}
//---------------------------------------------------------------------------

void __fastcall TF1::FileClick(TObject *Sender)
{CWarnlevel->Caption="Change warnl.  "+AS(warnlevel);}
//---------------------------------------------------------------------------


bool GetWqpSaveFn_1(AS& fn)
{
	bool do_save=GetSaveFn_1(fn);
	if (do_save) user_has_entered_fn = true;
	return do_save;
}

void __fastcall TF1::Save1Click(TObject *Sender)
{
	bool SaveAll;
	if (user_has_entered_fn)
		SaveAll = true;
	else
		SaveAll = GetWqpSaveFn_1(fn);
	
	if (SaveAll)
		cp.SaveAllToFile(fn);
}
//---------------------------------------------------------------------------

void __fastcall TF1::SaveAs1Click(TObject *Sender)
{
	if (GetWqpSaveFn_1(fn))
		cp.SaveAllToFile(fn);
	//if ofOverwritePrompt is set to true, warning is displayed, if file exists
}
//---------------------------------------------------------------------------

void __fastcall TF1::Exit1Click(TObject *Sender)
{ exit(0); //F1->Close();
}
//---------------------------------------------------------------------------

void __fastcall TF1::ResetConfigClick(TObject *Sender)
{
	
	AnsiString s=FnCfgExists()?
	" contained in "+FnCfg:NullString;
	if (YesToQuestion("Do you want to set all program parameters\n"
	"to default values"+s+"?"))
	{
		cp.IkUk_and_CphInit();
		ReadConfigFromFnCfgIfExistent();
	}
	
	cp.InitPrgParAndSlconfig();
}
//---------------------------------------------------------------------------
void AlgaddVar::ToStream(ofstream &out) const
{
	bool write_also_p0=!cp.kmi("Algadd_del_p0_entries");
	for (int ia = 0; ia < Algadd_TableCount; ++ia)
	{
		int uco = UsedEntryCount_After_Compression(ia);
		if (uco)
		{
			if (write_also_p0)
				out << cp.char_skipline << "the following lines"
				" contain the first " << uco << " entries of Algadd[" <<
				ia << "]" << endl;
			else
				out << cp.char_skipline << "the following " << uco <<
				" lines contain all nonempty entries of Algadd[" <<
				ia << "]" << endl;
			
			out << cp.char_skipline <<
			"in the order  "
			<< cp.entry_algadd <<aspace<< ia <<" i_entry p ldest l ..." << endl;
			int j;
			for (int i = 0; i < uco; ++i)
				if (ae[ia][i].p!= 0 || write_also_p0)
				{
					out << cp.entry_algadd << aspace << ia << aspace << i
					<< aspace << ae[ia][i].p << aspace << ae[ia][i].ldest;
					for (j = 0; j < MaxDimCount; ++j)
						out << aspace << ae[ia][i].lkadd.coo[sl_icoo(j)];
					out << endl;
				}
			out << endl;
		}
	}
	IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}

//---------------------------------------------------------------------------
void __fastcall TF1::CommentShow(TObject *Sender)
{
	Memo_Comment->SetFocus();
}
//---------------------------------------------------------------------------
//------ sums2

void Slsums2_Par::DefaultInit()
{
	s2map.clear();
	int i_n, isum;
	
	for (i_n = 0; i_n < Slsums2_n_count; ++i_n)
	{
		n_of_sum[i_n] = 0;
		empty_cs2.cnt[i_n] = 0;
		for (isum = 0; isum < Slsums_results_per_sum; ++isum)
			empty_cs2.sum[i_n][isum] = 0; //cotyp (i_n, 1, isum, 1);
	}
	
}

void Slsums2_Par::FillSlsums2()
{
	
	int icol;
	int icolup = s2map.size() + 1;
	//+1 for fixed
	F1->Slsums2->ColCount = icolup;
	F1->Slsums2->RowCount = 1 + Slsums_rows_per_sum * Slsums2_n_count;
	//already in wqp.dfm:    F1->Slsums2->Enabled=false;
	
	F1->Slsums2->Cells[0][0] = "              l->";
	AS sn;
	int i_n, irow, isum, iroffs;
	sn="all n: ";
	for (i_n = 0; i_n < Slsums2_n_count;)
	{
		for (iroffs = 0, irow = 1 + i_n*Slsums_rows_per_sum;
		iroffs < Slsums_rows_per_sum;
		++iroffs, ++irow)
		F1->Slsums2->Cells[0][irow] = sn + ssumfixed[iroffs];
		++i_n;
		sn = "n=" + AS(n_of_sum[i_n]) + ": ";
	}
	S2mapi its2;
	int count;
	bool as_float = cp.kmi("Sums_ShowAsFloat");
	int lt= cp.kmi("Sums_lt_precision");
	for (icol = 1, its2 = s2map.begin(); its2 != s2map.end(); ++its2, ++icol)
	{
		F1->Slsums2->Cells[icol][0] = AS(its2->first); //l=lattice-index
		for (i_n = 0; i_n < Slsums2_n_count; ++i_n)
		{
			count = its2->second.cnt[i_n];
			irow = 1 + i_n*Slsums_rows_per_sum;
			F1->Slsums2->Cells[icol][irow++] = AS(count);
			if (count)
				for (isum = 0; isum < Slsums_results_per_sum; ++isum, ++irow)
					F1->Slsums2->Cells[icol][irow] =
					as_float ? astr(lt, its2->second.sum[i_n][isum].florep()):
					astr(lt, its2->second.sum[i_n][isum]);
				else
					for (isum = 0; isum < Slsums_results_per_sum; ++isum, ++irow)
						F1->Slsums2->Cells[icol][irow] = NullString;
		}
	}
	#ifdef wdebug
	if (icol != F1->Slsums2->ColCount)
		pip ("icol=" + IntToStr(icol)
		+ " != " + IntToStr(F1->Slsums2->ColCount) + "=F1->Slsums2->ColCount");
	#endif
}

bool Slsums2_Par::CalcSums2ParFromLmap(Lmap& lm) //const Lmap -> Zugriffsverletzung
{
	int nlast;
	size_type lsiz=sizeofLmWith_nlast_1(nlast, lgl.lmap);
	if (!lsiz)
	{
		F1->Label_behind_Slsums2->Caption = LatticesEmptyString;
		return false;
	}
	
	probar pb(0, lsiz);
	int dstep = cp.kmi("Sums_EntryCountPerDisplay");
	int ecount = 0;
	
	int i_n = 1;//i_n=0 reserved for total count
	
	n_of_sum[i_n++] = cp.kmi("Sums2_n_first");
	n_of_sum[i_n++] = cp.kmi("Sums2_n_second");
	if (cp.kmi("Sums2_both_eo") && (nlast + n_of_sum[1])%2)
		nlast--; //if both blocks should begin even or odd
	
	n_of_sum[i_n++] = nlast - 1;
	n_of_sum[i_n++] = nlast;
	
	#ifdef wdebug
	if (i_n != Slsums2_n_count)
		pip ("i_n=" + IntToStr(i_n)
		+ " != " + IntToStr(Slsums2_n_count) + "=Slsums2_n_count");
	#endif
	
	s2map.clear();
	
	int isum;
	Lmapi lobound, upbound, it;
	S2mapi its2;
	S2pair s2pai;
	try
	{
		for (it = lm.begin(); it != lm.end(); ++it)
		{
			s2pai.first = it->first.coo[llike];//first=lattice-index
			its2 = s2map.find(s2pai.first);
			
			if (its2 == s2map.end())
			{
				s2pai.second = empty_cs2;
				s2map.insert(s2pai);
			}
			else
				s2pai.second = its2->second;
			
			++s2pai.second.cnt[0];
			s2pai.second.sum[0][Slsums_isumq] += it->second; //_div later
			s2pai.second.sum[0][Slsums_isumqq] += abs2(it->second);
			
			//GetLowUpBound_2(lobound, upbound, lm,n_of_sum[i_n], n_of_sum[i_n]);
			for (i_n = 1; i_n < Slsums2_n_count; ++i_n)
				if (it->first.coo[nlike]==n_of_sum[i_n])
				{
					++s2pai.second.cnt[i_n];
					s2pai.second.sum[i_n][Slsums_isumq] += it->second; //_div later
					s2pai.second.sum[i_n][Slsums_isumqq] += abs2(it->second);
				}
			s2map[s2pai.first] = s2pai.second;
			
			if (!(++ecount%dstep))
			{
				F1->Caption = "lattice point " + AS(ecount) + " of "
				+ AS(lsiz) + " summed up";
				pb.SetProgressBarPosition(ecount);
			}
		}
		
		int count;
		for (its2 = s2map.begin(); its2 != s2map.end(); ++its2)
			for (i_n = 0; i_n < Slsums2_n_count; ++i_n)
			{
				count = its2->second.cnt[i_n];
				if (count)
				{
					its2->second.sum[i_n][Slsums_isumq_div] =
					its2->second.sum[i_n][Slsums_isumq]/count;
					its2->second.sum[i_n][Slsums_isumqq_div] =
					its2->second.sum[i_n][Slsums_isumqq]/count;
				}
			}
	}
	catch (EMathError& ema)
	{
		F1->Label_behind_Slsums2->Caption
		= " MathError during creating Sums2: \n " + ema.Message+aspace;
		return false;
	}
	catch (...)
	{
		F1->Label_behind_Slsums2->Caption
		= " Error during creating Sums2 ";
		return false;
	}
	SetF1Caption(NullString);
	return true;
}

void UpdateSums2()
{
	F1->Label_behind_Slsums2->Visible = false;
	F1->Slsums2->Visible = false;
	if (s2p.CalcSums2ParFromLmap(lgl.lmap))
	{
		s2p.FillSlsums2();
		
		//F1->Slsums2->Col=F1->Slsums2->ColCount-1;
		//F1->Slsums2->Row=F1->Slsums2->RowCount-1;
		
		F1->Slsums2->Visible = true;
	}
	else
		F1->Label_behind_Slsums2->Visible = true;
}


void __fastcall TF1::Sums2Show(TObject *Sender)
{
	UpdateSums2();
}
//---------------------------------------------------------------------------

void __fastcall
TF1::SLDrawCell(TObject *Sender, int ACol, int ARow,
TRect &Rect, TGridDrawState State, TStringGrid* CallingStringGrid,
bool showselection)
// if showselection == false, there is no blue cell
{
	TStringGrid* StringGrid =
	static_cast < TStringGrid*>(Sender);
	if (StringGrid == NULL)
		throw Exception ("StringGrid == NULL in SlDrawcell");
	
	TCanvas* SGCanvas = StringGrid->Canvas;
	SGCanvas->Font = StringGrid->Font;
	
	RECT RText = static_cast < RECT >(Rect);
	const AS text(
	StringGrid->Cells[ACol][ARow]);
	
	const bool fixed =
	State.Contains(gdFixed);
	const bool focused =
	State.Contains(gdFocused);
	bool selected =
	State.Contains(gdSelected);
	if (!CallingStringGrid->Options.Contains(
	goDrawFocusSelected)) {
		selected = selected && !focused;
	}
	// if the cell is fixed (headers)
	if (fixed) {
		SGCanvas->Brush->Color =
		CallingStringGrid->FixedColor;
		SGCanvas->Font->Color = clBtnText;
		SGCanvas->FillRect(Rect);
		Frame3D(SGCanvas, Rect,
		clBtnHighlight, clBtnShadow, 1);
	}
	// if the cell is selected
	else if (selected && showselection) {
		SGCanvas->Brush->Color = clHighlight;
		SGCanvas->Font->Color =
		clHighlightText;
		SGCanvas->FillRect(Rect);
	}
	// if the cell is normal
	else {
		SGCanvas->Brush->Color =
		CallingStringGrid->Color;
		SGCanvas->Font->Color =
		CallingStringGrid->Font->Color;
		SGCanvas->FillRect(Rect);
	}
	// if the cell is focused
	if (focused) {
		DrawFocusRect(
		SGCanvas->Handle, &RText);
	}
	
	// draw the text
	RText.left += 2; RText.top += 2;
	DrawText(SGCanvas->Handle,
	text.c_str(), text.Length(), &RText,
	DT_LEFT |DT_VCENTER |DT_SINGLELINE);
}

void __fastcall TF1::Slsums2DrawCell(TObject *Sender, int ACol,
int ARow, TRect &Rect, TGridDrawState State)
{
	SLDrawCell(Sender, ACol, ARow, Rect, State, Slsums2, false);
}
//---------------------------------------------------------------------------
//sums1:


AS RangeLimitToStr(int i)
{
	if (i == intmax)
		return "+"; else
		if (i == intmin)
			return "-"; else
			return IntToStr(i);
}

bool TryStrToRangeLimit(AS s, int& i)
{
	AS strim = s.Trim();
	if (strim == "+")
	{
		i = intmax;
		return true;
	} else
		if (strim == "-")
		{
			i = intmin;
			return true;
		} else
			return TryStrToInt(strim, i);
}

void Slds1_Par::UpdateSlsums1_from_cs1()
{
	int iblock, iresult, icolm, irowstart;
	cotyp ctmp;
	iblock = 0;
	bool as_float = cp.kmi("Sums_ShowAsFloat");
	int lt= cp.kmi("Sums_lt_precision");
	
	for (icolm = 0; icolm < Sums1_Cols_with_Sum; ++icolm)
	{
		irowstart = 2;
		ctmp = cs1.cnt[icolm][iblock];
		F1->Slsums1->Cells[1 + icolm][irowstart - 1] =
		as_float ? astr(lt, ctmp.florep()): astr(lt, ctmp);
		
		for (iresult = 0; iresult < Slsums_results_per_sum; ++iresult)
			if (ctmp != 0)
				F1->Slsums1->Cells[1 + icolm][irowstart + iresult]
				= as_float ?
				astr(lt, cs1.sum[icolm][iblock][iresult].florep()):
				astr(lt, cs1.sum[icolm][iblock][iresult]);
			else
				F1->Slsums1->Cells[1 + icolm][irowstart + iresult]
				= NullString;
	}
	
	for (icolm = 0; icolm < Sums1_Cols_with_Sum; ++icolm)
		for (iblock = 1; iblock < Sums1_BlockCount; ++iblock)
		{
			irowstart = 2 + iblock*Slsums_rows_per_sum;
			ctmp = cs1.cnt[icolm][iblock];
			
			if (ctmp != 0)//if nothing to divide, leave cell empty
			F1->Slsums1->Cells[1 + icolm][irowstart - 1] =
			as_float ? astr(lt, ctmp.florep()): astr(lt, ctmp);
			else
				F1->Slsums1->Cells[1 + icolm][irowstart - 1] = NullString;
			
			for (iresult = 0; iresult < Slsums_results_per_sum; ++iresult)
				if (cs1.sum[iblock - 1][0][iresult]!= 0 && ctmp != 0)
				{
					if (cs1.sum_calculated[icolm][iblock][iresult])
						F1->Slsums1->Cells[1 + icolm][irowstart + iresult]
						= as_float ?
						astr(lt, cs1.sum[icolm][iblock][iresult].florep()):
						astr(lt, cs1.sum[icolm][iblock][iresult]);
					else
						F1->Slsums1->Cells[1 + icolm][irowstart + iresult]="?";//indicates e.g. Eoverflow
				}
				else
					F1->Slsums1->Cells[1 + icolm][irowstart + iresult]
					= NullString;
		}
	ShowSlsums1_HideModifyRangeMenu();
}

bool Lk::between(const Lk& lkmin, const Lk& lkmax) const
{
	for (int i = 0; i < MaxDimCount; ++i)
		if (coo[i] < lkmin.coo[i] || coo[i] > lkmax.coo[i])
			return false;
	
	return true;
}


bool Slds1_Par::CalcSums1FromLgl()
	//true if ok
{
	cs1 = cs1_zero;
	size_type lsiz = lgl.LmapSize();
	
	if (!lsiz)
	{
		F1->Label_behind_Slsums1->Caption = LatticesEmptyString;
		F1->Button_RangeModifyClose->Visible = false;
		return false;
	}
	
	F1->Label_behind_Slsums1->Caption =
	" Double clck on table \n"
	" or close this menu \n"
	" to sum up ";
	F1->Button_RangeModifyClose->Visible = true;
	
	bool sum1_valid = true;
	try
	{
		probar pb(0, lsiz);
		int isu;
		int dstep = cp.kmi("Sums_EntryCountPerDisplay");
		int ecount = 0;
		for (Lmapi it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
		{
			//sums betweeen ta[ita].range[isu]:
			for (isu = 0; isu < Sums1_SumCount; ++isu)
				if (it->first.between(ta[ita].range[isu][immin], ta[ita].range[isu][immax]))
				{
					++cs1.cnt[isu][0];
					cs1.sum[isu][0][Slsums_isumq] += it->second;
					cs1.sum[isu][0][Slsums_isumqq] += abs2(it->second);
				}
			//total sum:
			isu = Sums1_Cols_with_Sum - 1;
			{
				++cs1.cnt[isu][0];
				cs1.sum[isu][0][Slsums_isumq] += it->second;
				cs1.sum[isu][0][Slsums_isumqq] += abs2(it->second);
			}
			
			if (!(++ecount%dstep))
			{
				F1->Caption = "lattice point " + AS(ecount) + " of "
				+ AS(lsiz) + " summed up";
				pb.SetProgressBarPosition(ecount);
			}
		}
		//the rest can be done out of loop
		int iresult, iblock;
		//calc rest of raw values
		for (isu = 0; isu < Sums1_Cols_with_Sum; ++isu)
			if (cs1.cnt[isu][0]!= 0)
			{
				cs1.sum[isu][0][Slsums_isumq_div] =
				cs1.sum[isu][0][Slsums_isumq]/cs1.cnt[isu][0];
				cs1.sum[isu][0][Slsums_isumqq_div] =
				cs1.sum[isu][0][Slsums_isumqq]/cs1.cnt[isu][0];
			}
		for (isu = 0; isu < Sums1_Cols_with_Sum; ++isu)
			if (cs1.cnt[isu][0]!= 0)
			{
				for (iblock = 1; iblock < Sums1_BlockCount; ++iblock)
					if (cs1.cnt[iblock - 1][0]!= 0)
					{
						cs1.cnt[isu][iblock] =
						cs1.cnt[isu][0] / cs1.cnt[iblock - 1][0];
						
						for (iresult = 0; iresult < Slsums_results_per_sum; ++iresult)
							if (cs1.sum[iblock - 1][0][iresult]!= 0)
							{	try
								{
									cs1.sum[isu][iblock][iresult]=cs1.sum[isu][0][iresult]
									/ cs1.sum[iblock - 1][0][iresult];
									
									cs1.sum_calculated[isu][iblock][iresult]=true;//only, if not EMathError in (*)
								}
								catch (EMathError& ema)	{}//(*)
							}
					}
			}
	}
	catch (EMathError& ema)
	{
		F1->Label_behind_Slsums1->Caption
		= " MathError when creating Sums1: \n " + ema.Message;
		sum1_valid = false;
	}
	catch (...)
	{
		F1->Label_behind_Slsums1->Caption
		= "Error when creating Sums1";
		sum1_valid = false;
	}
	SetF1Caption(NullString);
	return sum1_valid;
}

AS Slds1_Par::s_xygraph (int ixy) const
{
	AS s=NullString;
	const static AS sxyblank="      ";
	
	if (ixy == ta[ita].icoo_along_x_in_g[0]) s="=x1";
	if (ixy == ta[ita].icoo_along_y_in_g2[0]) s+="=y1";//s_before should be Nullstring, if true
	if (ixy == ta[ita].icoo_along_x_in_g[1])
		if (s==NullString) s=sxyblank+" x2"; else s+="=x2";
	if (ixy == ta[ita].icoo_along_y_in_g2[1])
		if (s==NullString) s=sxyblank+" y2"; else s+="=y2";
	return s;
}

void Slds1_Par::UpdateSlds1_from_range()
{
	F1->Slds1->Cells[0][0]=AS(ita)+": R->";
	
	for (int j = 0; j < MaxDimCount; ++j)
		F1->Slds1->Cells[0][1 + sl_irow(j)]
		= DimNumString(j) + s_xygraph (j);
	
	int i, isu, imm;
	for (i = 0; i < MaxDimCount; ++i)
		for (isu = 0; isu < Sums1_SumCount; ++isu)
			for (imm = 0; imm < MinMaxCount; ++imm)
				F1->Slds1->Cells
				[1 + isu*MinMaxCount + imm]  [1 + sl_irow(i)]
				= RangeLimitToStr(ta[ita].range[isu][imm].coo[i]);
}

void Slds1_Par::InitStatics()
{
	for (int isu = 0; isu < Sums1_SumCount; ++isu)
	{
		tazero.range[isu][immin] = tazero.range[isu][immax] = lkzero;
		tazero.icoo_along_x_in_g[isu] = 1;
		tazero.icoo_along_y_in_g2[isu] = nlike;
	}
	tazero.range[0][immin].coo[1] = lcoomin; //default: Range 0 along xsecond sum: invalid as default
	tazero.range[0][immax].coo[1] = lcoomax;
	tazero.range[1][immin].coo[1] = lcoomax; //second sum: invalid as default
	tazero.range[1][immax].coo[1] = lcoomax;
}

void Slds1_Par::InitSums1Table(int italoc)
{ta[italoc]=tazero;}

void Slds1_Par::InitSums1()
{
	int i, j;
	F1->Slds1->ColCount = Sums1_SumCount*MinMaxCount + 1;
	F1->Slds1->RowCount = MaxDimCount + 1;
	F1->Slsums1->ColCount = Sums1_Cols_with_Sum + 1; //+1:fixedcol
	F1->Slsums1->RowCount = Sums1_BlockCount*Slsums_rows_per_sum + 1; //+1:fixed
	
	const static AS ssds1[Sums1_SumCount*MinMaxCount + 1] =
	{
		"  R->",
		"Min 1",
		"Max 1",
		"Min 2",
		"Max 2"
	};
	for (i = 0; i < Sums1_SumCount*MinMaxCount + 1; ++i)
		F1->Slds1->Cells[i][0] = ssds1[i];
	
	const static AS ssums1[Sums1_BlockCount] =
	{
		"s   : ",
		"s/s1: ",
		"s/s2: ",
		"s/st: ",
	};
	
	for (i = 0; i < Sums1_BlockCount; ++i)
		for (j = 0; j < Slsums_rows_per_sum; ++j)
			F1->Slsums1->Cells[0][1 + Slsums_rows_per_sum*i + j]
			= ssums1[i] + ssumfixed[j];
	
	F1->Slsums1->Cells[1][0] = "          Sum 1";
	F1->Slsums1->Cells[2][0] = "          Sum 2";
	F1->Slsums1->Cells[3][0] = "     Sum total";
	
	int isu, italoc;
	
	//init range
	for (italoc=0; italoc<Sums1_TableCount;++italoc)
		InitSums1Table(italoc);
	
	ita=0;//init ita
	
	int iblock, iresult, icolm;
	for (icolm = 0; icolm < Sums1_Cols_with_Sum; ++icolm)
		for (iblock = 0; iblock < Sums1_BlockCount; ++iblock)
		{
			cs1_zero.cnt[icolm][iblock] = 0; //debug: icolm+10*iblock;
			for (iresult = 0; iresult < Slsums_results_per_sum; ++iresult)
			{
				cs1_zero.sum[icolm][iblock][iresult] = 0;
				//debug: 10*icolm+100*iblock+iresult;
				cs1_zero.sum_calculated[icolm][iblock][iresult] = false;
			}
		}
	cs1 = cs1_zero;
	UpdateSlds1_from_range();
	UpdateSlsums1_from_cs1();
}

void Slds1_Par::UpdateRange_if_CorrectSlds1Cell()
{
	int k;
	if (TryStrToRangeLimit(F1->Slds1->
	Cells[F1->Slds1->Col][F1->Slds1->Row], k))
	{
		int imm = (F1->Slds1->Col - 1)%MinMaxCount;
		int isu = (F1->Slds1->Col - 1)/MinMaxCount;
		int icoo = sl_icoo(F1->Slds1->Row - 1);
		
		if (imm)//if k should be Max
		{
			if (ta[ita].range[isu][imm - 1].coo[icoo] > k)
			{
				ta[ita].range[isu][imm - 1].coo[icoo] = k;
				--F1->Slds1->Col;
				Beep();
			}
			else
				ta[ita].range[isu][imm].coo[icoo] = k;
		}
		else //if k should be Min
		{
			if (ta[ita].range[isu][imm + 1].coo[icoo] < k)
			{
				ta[ita].range[isu][imm + 1].coo[icoo] = k;
				++F1->Slds1->Col;
				Beep();
			}
			else
				ta[ita].range[isu][imm].coo[icoo] = k;
		}
	}
	else
		Beep();
}



void Slds1_Par::UpdateSlds1Cell_from_range()
{
	int icol = F1->Slds1->Col;
	F1->Slds1->Cells[icol][F1->Slds1->Row] = RangeLimitToStr(
	ta[ita].range[(icol - 1)/MinMaxCount][(icol - 1)%MinMaxCount]
	.coo[sl_icoo(F1->Slds1->Row - 1)]);
}

void Slds1_Par::CorrectSlds1CellOrUpdateRange()
{
	UpdateRange_if_CorrectSlds1Cell();
	UpdateSlds1Cell_from_range();
	slds1upd.uptodate = true;
	
	if (lgl.lmap.empty())
		return;
	
	if (cp.kmi("Sums1_SumUp_at_once"))
		UpdateSums1();
	else
		HideSlsums1_ShowModifyRangeMenu();
}

void slds1updfunc()
{s1p.CorrectSlds1CellOrUpdateRange();}

void __fastcall TF1::Slds1MouseMove(TObject *Sender, TShiftState Shift,
int X, int Y)
{slds1upd.CorrectAndUpdateSlCellOnXYChange(X, Y, slds1updfunc);}
//---------------------------------------------------------------------------

void __fastcall TF1::Slds1DblClick(TObject *Sender)
{
	UpdateSums1();
}
//---------------------------------------------------------------------------



void __fastcall TF1::Slds1SelectCell(TObject *Sender, int ACol,
int ARow, bool &CanSelect)
{
	if (!slds1upd.uptodate)
		s1p.CorrectSlds1CellOrUpdateRange();
}

//---------------------------------------------------------------------------

void Set_icoo_along_x_to_Rowm(int isu)
{
	int inew=sl_icoo(F1->Slds1->Row - 1);
	
	if (s1p.ta[s1p.ita].icoo_along_x_in_g[isu] == inew) return;
	
	if (s1p.ta[s1p.ita].icoo_along_y_in_g2[isu] == inew)
		s1p.ta[s1p.ita].icoo_along_y_in_g2[isu] =
		s1p.ta[s1p.ita].icoo_along_x_in_g[isu];//exchange
	
	s1p.ta[s1p.ita].icoo_along_x_in_g[isu] = inew;
}

void Set_icoo_along_y_to_Rowm(int isu)
{
	int inew=sl_icoo(F1->Slds1->Row - 1);
	
	if (s1p.ta[s1p.ita].icoo_along_y_in_g2[isu] == inew) return;
	
	if (s1p.ta[s1p.ita].icoo_along_x_in_g[isu] == inew)
		s1p.ta[s1p.ita].icoo_along_x_in_g[isu] =
		s1p.ta[s1p.ita].icoo_along_y_in_g2[isu];
	
	s1p.ta[s1p.ita].icoo_along_y_in_g2[isu] = inew;
}

void __fastcall TF1::Slds1KeyPress(TObject *Sender, char &Key)
{
	
	if (NoTextChangeKeys.Pos(Key) == 0)
		slds1upd.uptodate = false;
	
	char c = UpCase(Key);
	
	if (intRegularInput.Pos(c))
		return;
	
	switch (c)
	{
		case '\r': UpdateSums1(); break;
			
		case 'A': Set_icoo_along_x_to_Rowm(0); break;
		case 'B': Set_icoo_along_x_to_Rowm(1); break;
		case 'X': Set_icoo_along_x_to_Rowm(0);
			Set_icoo_along_x_to_Rowm(1); break;
			
		case 'C': Set_icoo_along_y_to_Rowm(0); break;
		case 'D': Set_icoo_along_y_to_Rowm(1); break;
		case 'Y': Set_icoo_along_y_to_Rowm(0);
			Set_icoo_along_y_to_Rowm(1); break;
			
		case 'Q'://TableIndex -1
			if (s1p.ita > 0)
				s1p.ita--;
			else
				s1p.ita = Sums1_TableCount - 1;
			cp.setkmi_1("Sums1_DefaultTableIndex", s1p.ita);
			SetMainMenuCaptions();
			s1p.UpdateSlds1_from_range();
			break;
		case 'W'://TableIndex +1
			if (s1p.ita < Sums1_TableCount - 1)
				s1p.ita++;
			else
				s1p.ita = 0;
			cp.setkmi_1("Sums1_DefaultTableIndex", s1p.ita);
			SetMainMenuCaptions();
			s1p.UpdateSlds1_from_range();
			break;
		case 'P':
		case 'M':
			{
				int add, i;
				TryStrToRangeLimit(Slds1->Cells[Slds1->Col][Slds1->Row], i);
				
				if (c  == 'P')
				{add = 1;
					if (i == intmax)
					{Beep(); break; }
				}
				else
				{add = - 1;
					if (i == intmin)
					{Beep(); break; }
				}
				Slds1->Cells[Slds1->Col][Slds1->Row]
				= RangeLimitToStr(i + add);
			}
			break;
		default:
			Beep();
			break;
	}
	Key = 0;
	s1p.CorrectSlds1CellOrUpdateRange();
	s1p.UpdateSlds1_from_range();
}
//---------------------------------------------------------------------------


void __fastcall TF1::Sums1Show(TObject *Sender)
{
	//trf:
	Slds1->Height=Sums1->Height - Slds1->Top;
	Slsums1->Height=Sums1->Height - Slsums1->Top;
	Slsums1->Width=Sums1->Width - Slsums1->Left;
	
	UpdateSums1();
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Slsums1DrawCell(TObject *Sender, int ACol,
int ARow, TRect &Rect, TGridDrawState State)
{
	SLDrawCell(Sender, ACol, ARow, Rect, State, Slsums1, false);
}
//---------------------------------------------------------------------------

void Menu_Modify_Range()
{
	HideSlsums1_ShowModifyRangeMenu();
}


void __fastcall TF1::Slds1MouseDown(TObject *Sender,
TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button == mbRight)
		Menu_Modify_Range();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeModifyCloseClick(TObject *Sender)
{
	UpdateSums1();
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------


void Slds1_Par::if_CBR_SetRangeTo(const Lk& lk, int imm)
	//imm=iminmax, =1 for Max, =0 for min
{
	if (F1->CB_Range1IsDest->Checked)
		ta[ita].range[0][imm] = lk;
	if (F1->CB_Range2IsDest->Checked)
		ta[ita].range[1][imm] = lk;
	UpdateSlds1_from_range();
}

void  Slds1_Par::if_CBR_CopyRangeMaxToMin()
{
	if (F1->CB_Range1IsDest->Checked)
		ta[ita].range[0][immin] = ta[ita].range[0][immax];
	if (F1->CB_Range2IsDest->Checked)
		ta[ita].range[1][immin] = ta[ita].range[1][immax];
	UpdateSlds1_from_range();
}

void  Slds1_Par::if_CBR_CopyRangeMinToMax()
{
	if (F1->CB_Range1IsDest->Checked)
		ta[ita].range[0][immax] = ta[ita].range[0][immin];
	if (F1->CB_Range2IsDest->Checked)
		ta[ita].range[1][immax] = ta[ita].range[1][immin];
	UpdateSlds1_from_range();
}


void __fastcall TF1::Button_RangeCopyMaxToMinClick(TObject *Sender)
{
	s1p.if_CBR_CopyRangeMaxToMin();
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeCopyMinToMaxClick(TObject *Sender)
{
	s1p.if_CBR_CopyRangeMinToMax();
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeMaxZeroClick(TObject *Sender)
{
	s1p.if_CBR_SetRangeTo(lkzero, 1);
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeTableToDefaultClick(TObject *Sender)
{
	s1p.InitSums1Table(s1p.ita);
	s1p.UpdateSlds1_from_range();
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeMinZeroClick(TObject *Sender)
{
	s1p.if_CBR_SetRangeTo(lkzero, 0);
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangePMClick(TObject *Sender)
{
	lkmax.coo[nlike] = lcoomax;
	lkmin.coo[nlike] = lcoomin;
	s1p.if_CBR_SetRangeTo(lkmax, 1);
	s1p.if_CBR_SetRangeTo(lkmin, 0);
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeCopyLkOffsetToMaxClick(TObject *Sender)
{
	s1p.if_CBR_SetRangeTo(lgl.lkoffset, 1);
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeCopyLkOffsetToMinClick(TObject *Sender)
{
	s1p.if_CBR_SetRangeTo(lgl.lkoffset, 0);
	Slds1->SetFocus();
}
void __fastcall TF1::Button_RangeChooseTableNumClick(TObject *Sender)
{
	MMI mmi;
	mmi.i = s1p.ita;
	mmi.min=0;
	mmi.max=Sums1_TableCount-1;
	if (Input_i_of_mmi_1(mmi,"Sums1: Choose Table Nr",
	"To choose Sums1 (Range) table index"))
	{
		s1p.ita = mmi.i;
		cp.setkmi_1("Sums1_DefaultTableIndex", s1p.ita);
		s1p.UpdateSlds1_from_range();
		HideSlsums1_ShowModifyRangeMenu();
		UpdateActivePage();
	}
	if (F1->PaCo->ActivePage == F1->Sums1)
		Slds1->SetFocus();
	SetMainMenuCaptions();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeCopyTableClick(TObject *Sender)
{
	MMI mmi;
	mmi.i = s1p.ita;
	mmi.min=0;
	mmi.max=Sums1_TableCount-1;
	if (Input_i_of_mmi_1(mmi,"Sums1: Copy Table Nr.",
	"To copy Sums1 table "+AS(s1p.ita)
		+" to table with index i"))
	{
		s1p.ta[mmi.i]=s1p.ta[s1p.ita];
		s1p.ita = mmi.i;
		cp.setkmi_1("Sums1_DefaultTableIndex", s1p.ita);
		s1p.UpdateSlds1_from_range();
		HideSlsums1_ShowModifyRangeMenu();
		SetMainMenuCaptions();
	}
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_RangeExchangeClick(TObject *Sender)
{
	Lk lk;
	int ita=s1p.ita;
	for (int imm=0; imm<MinMaxCount;++imm)
	{
		lk=s1p.ta[ita].range[0][imm];
		s1p.ta[ita].range[0][imm]=s1p.ta[ita].range[1][imm];
		s1p.ta[ita].range[1][imm]=lk;
	}
	s1p.UpdateSlds1_from_range();
	Slds1->SetFocus();
}
//---------------------------------------------------------------------------



//begin Graph

//--------- begin Graph1:
double x_World(int px, double x0, double x1, double W)
{ // transform px from [0,W] into world coo [x0,x1]
	return x0 + px*(x1 - x0)/W;
}

double y_World(int py, double y0, double y1, double H)
{ // transform py from [0,H] into world coo [y1,y0]
	return y1 + py*(y0 - y1)/H;
}
int x_Screen(double x, double x0, double x1, double W)
{ // transform  x from [x0,x1] into screencoordinates [0,W]
	return (x - x0)*W/(x1 - x0);
}

int y_Screen(double y, double y0, double y1, double H)
{ // transform  x from [y0,y1] into screencoordinates [H,0]
	return (y - y1)*H/(y0 - y1);
}

//0x00FF0000 = maxblue
//0x0000FF00 = maxgreen
//0x000000FF = maxred
//const TColor wcl_grid=clAqua;//0x00ffff00;
//const TColor wcl_axes=clBlue;//0x00ff8800;


void GPar::DrawGrid(TImage* Gimage, bool colored, int W, int H,
double x0, double x1, double y0, double y1)
{
	if (colored)
	{
		switch (cp.kmi("Graph2_color_mode"))
		{
			case g2_bw:
			case g2_red_to_white:
				{
					color_grid = clBlue;
					color_axes = clAqua;
					Gimage->Canvas->Font->Color = clAqua;
				}break;
			case g2_green_to_white:
				{
					color_grid = clMaroon;
					color_axes = clRed;
					Gimage->Canvas->Font->Color = clRed;
				} break;
			case g2_blue_red_to_white:
				{
					color_grid = clGreen;
					color_axes = clLime;
					Gimage->Canvas->Font->Color = clLime;
				} break;
			default: pip("DrawGrid: invalid colormode"); break;
		}
	}
	else
	{
		color_grid = cp.kmi("Graph1_OnlyBlackWhite") ? clBlack : clLtGray;
		color_axes = clBlack;
		Gimage->Canvas->Font->Color = clBlack;
	}
	
	//int W = Gimage->ClientWidth;
	//int H = Gimage->ClientHeight;
	
	//grid spacing:
	double dx = (x1 - x0)/(1 + cp.kmi("Graph_Gridlines_x"));
	double dy = (y1 - y0)/(1 + cp.kmi("Graph_Gridlines_y"));
	
	//for better view:
	if (cp.kmi("Graph_Gridlines_Auto"))
	{
		RoundUp1Decimalp_1(dx, dx);
		RoundUp1Decimalp_1(dy, dy);
	}
	
	bool xax_visible = false;
	bool yax_visible = false;
	
	int xt = x_Screen(0, x0, x1, W); //default for xt=x-textpos: in x=0
	
	if (xt < 0)
		xt = 0; //left
	else
		if (xt >= W)
			xt = W - 1; //right text
		else
			yax_visible = true;
	
	int yt = y_Screen(0, y0, y1, H); //default for yt=y-textpos: in y=0
	if (yt < 0)
		yt = 0;
	else
		if (yt >= H)
			yt = H - 1;
		else
			xax_visible = true;
	
	
	//move grid onto axes
	double x0_gridoffset = yax_visible ? dx*(ceil(x0/dx) - x0/dx):0.0;
	double y1_gridoffset = xax_visible ? dy*(ceil(y1/dy) - y1/dy - 1):0.0;
	
	//x0_gridoffset=0.0; y1_gridoffset=0.0;
	
	int tw, th;
	AS s;
	Gimage->Canvas->Pen->Color = color_grid;
	double xpos, ypos;
	
	int i = 0;
	int precision = cp.kmi("Graph_num_precision");
	xpos = x0_gridoffset + x0;
	int x = x_Screen(xpos, x0, x1, W);
	while (x < W)
	{ //draw parallels to y
		Gimage->Canvas->MoveTo(x, H - 1);
		Gimage->Canvas->LineTo(x, 0);
		s = FloatToStrF(xpos, ffGeneral, precision, precision);
		th = Gimage->Canvas->TextHeight(s);
		if (th + yt > H)
			Gimage->Canvas->TextOut(x, yt - th, s);
		else
			Gimage->Canvas->TextOut(x, yt, s);
		++i;
		xpos = x0_gridoffset + x0 + i*dx;
		x = x_Screen(xpos, x0, x1, W);
	}
	
	i = 0;
	double y_approx_zero = (y1 - y0)/1000.0;
	ypos = y1_gridoffset + y1;
	int y = y_Screen(ypos, y0, y1, H);
	while (y < H)
	{ //draw parallels to x
		Gimage->Canvas->MoveTo(0, y);
		Gimage->Canvas->LineTo(W - 1, y);
		if (fabs(ypos) > y_approx_zero) // to avoid 4,452E-14 etc.
		{
			s = FloatToStrF(ypos, ffGeneral, precision, precision);
			tw = Gimage->Canvas->TextWidth(s);
			if (tw + xt >= Gimage->Width)
				Gimage->Canvas->TextOut(xt - tw, y, s);
			else
				Gimage->Canvas->TextOut(xt, y, s);
		}
		++i;
		ypos = y1_gridoffset + y1 - i*dy;
		y = y_Screen(ypos, y0, y1, H);
	}
	
	// Draw coordinate axes
	Gimage->Canvas->Pen->Color = color_axes;
	
	if (xax_visible)
	{
		Gimage->Canvas->MoveTo(0, yt);
		Gimage->Canvas->LineTo(W - 1, yt);
	}
	if (yax_visible)
	{
		Gimage->Canvas->MoveTo(xt, H - 1);
		Gimage->Canvas->LineTo(xt, 0);
	}
}


//--- end Graph1
//--- begin  Graph1function
void G1Par::InitColors()
{
	gc[0].color[igc_qre] = F1->CB0qre->Color;
	gc[0].color[igc_qim] = F1->CB0qim->Color;
	gc[0].color[igc_qq] = F1->CB0qq->Color;
	gc[0].color[igc_qa] = F1->CB0qa->Color;
	gc[0].color[igc_cntAt] = F1->CB0cntAt->Color;
	
	gc[1].color[igc_qre] = F1->CB1qre->Color;
	gc[1].color[igc_qim] = F1->CB1qim->Color;
	gc[1].color[igc_qq] = F1->CB1qq->Color;
	gc[1].color[igc_qa] = F1->CB1qa->Color;
	gc[1].color[igc_cntAt] = F1->CB1cntAt->Color;
}

void G1Par::UpdateGcDrawFromCB()
{
	gc[0].draw[igc_qre] = F1->CB0qre->Checked;
	gc[0].draw[igc_qim] = F1->CB0qim->Checked;
	gc[0].draw[igc_qq] = F1->CB0qq->Checked;
	gc[0].draw[igc_qa] = F1->CB0qa->Checked;
	gc[0].draw[igc_cntAt] = F1->CB0cntAt->Checked;
	
	gc[1].draw[igc_qre] = F1->CB1qre->Checked;
	gc[1].draw[igc_qim] = F1->CB1qim->Checked;
	gc[1].draw[igc_qq] = F1->CB1qq->Checked;
	gc[1].draw[igc_qa] = F1->CB1qa->Checked;
	gc[1].draw[igc_cntAt] = F1->CB1cntAt->Checked;
}

void G1Par::InitMinMax_Zero_gc_til_hpixcount()
{
	int isu, hpix, igc;
	
	icoominmax[immin] = intmax; //opposite side, so that sure change
	icoominmax[immax] = intmin;
	for (isu = 0; isu < Sums1_SumCount; ++isu)
	{
		gc[isu].cnt = 0;
		for (igc = 0; igc < igc_count; ++igc)
		{
			//opposite initialization:
			gc[isu].ymm[igc][immin] = doublemax;
			gc[isu].ymm[igc][immax] = (- doublemax);
			for (hpix = 0; hpix < hpixcount; ++hpix)
				gc[isu].y[igc][hpix] = 0.0;
		}
	}
}

void WarnThatNotEnoughPixelAlong(const AS& s, bool overlapping_possible)
{
	if (cp.kmi("Graph_BeepMsgIfTooLessPixel"))
	{
		AS sdisplay=overlapping_possible?
		"\nOverlapping summation per pixel is possible.\n":
		"\nNot all, only one sum per pixel can be displayed.\n";
		
		warn(wl_all,"Warning:\n too less pixel along "+s+sdisplay);
	}
}


void G1Par::Calc_gc_from_lgl()
{
	size_type lsiz = lgl.LmapSize();
	gpvalid = false;
	int isu;
	F1->Label_g1_behind_Gimage1->Caption = NullString;
	
	if (!lsiz)
	{
		F1->Label_g1_behind_Gimage1->Caption = LatticesEmptyString;
		return;
	}
	
	hpixcount = F1->Gimage1->Width;
	vpixcount = F1->Gimage1->Height;
	
	if (hpixcount > G1Chainsize)
	{
		warn(wl_all,"Calc_gc_from_lgl: hpixcount="
		+ AS(hpixcount) + " set to G1Chainsize="
		+ AS(G1Chainsize));
		hpixcount = G1Chainsize;
	}
	
	if (!(hpixcount && vpixcount))
	{
		F1->Label_g1_behind_Gimage1->Caption = "No pixel";
		return;
	}
	
	F1->Label_g1_behind_Gimage1->Caption =
	" Click on checkboxes to draw Sums1 along x ";
	
	
	Graph1Divmode divmode = cp.kmi("Graph1_divmode");
	if (divmode == div_by_cnt)
	{
		F1->Label_g1_SR1->Caption = "SR1/cnt:";
		F1->Label_g1_SR2->Caption = "SR2/cnt:";
	}
	else
	{
		F1->Label_g1_SR1->Caption = "SR1:";
		F1->Label_g1_SR2->Caption = "SR2:";
	}
	
	InitMinMax_Zero_gc_til_hpixcount();
	
	int isucoomm_start = intmax;
	int isucoomm_up = intmin;
	if (cp.kmi("Graph1_quick_xscale_r12_common"))
	{
		isucoomm_start = 0;
		isucoomm_up = Sums1_SumCount;
	}
	else
	{
		int igc;
		for (isu = 0; isu < Sums1_SumCount; ++isu)
			for (igc = 0; igc < igc_count; ++igc)
				if (gc[isu].draw[igc])
					isucoomm_up = isu + 1;
		for (isu = Sums1_SumCount - 1; isu >= 0; --isu)
			for (igc = 0; igc < igc_count; ++igc)
				if (gc[isu].draw[igc])
					isucoomm_start = isu;
		if (isucoomm_start >= isucoomm_up)
		{
			F1->Label_g1_behind_Gimage1->Caption = " cnt=0 ";
			return;
		}
	}
	
	bool gc_valid = true;
	
	try
	{
		probar pb(0, lsiz);
		int dstep = cp.kmi("Graph_EntryCountPerDisplay");
		int ecount = 0;
		int itmp;
		
		//calc icoominmax:
		for (Lmapi it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
		{
			for (isu = isucoomm_start; isu < isucoomm_up; ++isu)
				if (it->first.between
				(s1p.ta[s1p.ita].range[isu][immin], s1p.ta[s1p.ita].range[isu][immax]))
			{
				itmp = it->first.coo[s1p.ta[s1p.ita].icoo_along_x_in_g[isu]];
				if (itmp < icoominmax[immin])
					icoominmax[immin] = itmp;
				
				if (itmp > icoominmax[immax])
					icoominmax[immax] = itmp;
			}
			if (!(++ecount%dstep))
			{
				F1->Caption = "lattice point " + AS(ecount) + " of "
				+ AS(lsiz) + " checked";
				pb.SetProgressBarPosition(ecount);
			}
		}
		//now icoominmax valid
		
		icoominmax[immax]+=ixy_minborder; //for spacing to border
		icoominmax[immin]-=ixy_minborder;
		
		ecount = 0;
		int icoostepcount = icoominmax[immax] - icoominmax[immin];
		double pix_per_icoo;
		if (icoostepcount > 0)
			pix_per_icoo = double(hpixcount)/double(icoostepcount);
		else
		{
			F1->Label_g1_behind_Gimage1->Caption =
			" no different x ";
			return;
		}
		
		
		if (pix_per_icoo<1)
			WarnThatNotEnoughPixelAlong("x in Graph 1\n"
			" (pix_per_icoo = "+FS(pix_per_icoo)+" < 1)\n", false);
		int hpix, hsteps;
		cotyp ctmp;
		double abs2tmp;
		
		
		double hpd;
		double hpix_double_used[G1Chainsize];//avoid overlapping summation
		for (hpix=0; hpix<G1Chainsize;++hpix) hpix_double_used[hpix]=noindex;
		
		//main loop:
		for (Lmapi it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
		{
			//sums betweeen ta[ita].range[isu]:
			ctmp = it->second;
			for (isu = isucoomm_start; isu < isucoomm_up; ++isu)
				if (it->first.between //i.e.icoostepcount>0
				(s1p.ta[s1p.ita].range[isu][immin], s1p.ta[s1p.ita].range[isu][immax]))
			{
				++gc[isu].cnt;
				hsteps=it->first.coo[s1p.ta[s1p.ita].icoo_along_x_in_g[isu]] - icoominmax[immin];
				hpd = pix_per_icoo * hsteps;
				//hpix = int(hpd);//not sufficient because of unexpected rounding error, therefore again:
				hpix = int(pix_per_icoo * hsteps);
				if (hpix_double_used[hpix]==noindex) hpix_double_used[hpix]=hpd;//first init
				
				if (hpix_double_used[hpix]==hpd)//sum only, if identical to first, i.e. nonoverlapping
				{
					gc[isu].y[igc_qre][hpix] += ctmp.real().florep();
					gc[isu].y[igc_qim][hpix] += ctmp.imag().florep();
					abs2tmp = abs2(ctmp).florep();
					gc[isu].y[igc_qq][hpix] += abs2tmp;
					gc[isu].y[igc_qa][hpix] += sqrt(abs2tmp);
					++gc[isu].y[igc_cntAt][hpix];
				}
			}
			if (!(++ecount%dstep))
			{
				F1->Caption = "lattice point " + AS(ecount) + " of "
				+ AS(lsiz) + " summed up";
				pb.SetProgressBarPosition(ecount);
			}
		}
		
		//the rest can be done outside of loop
		
		double fcnt;
		int igc;
		
		if (divmode == div_r12 && gc[0].cnt && gc[1].cnt)
		{
			F1->Label_g1_SR1->Caption = "SR1/SR2:";
			for (igc = 0; igc < igc_count; ++igc)
				for (hpix = 0; hpix < hpixcount; ++hpix)
				{
					if (gc[1].y[igc][hpix] == 0.0)
						gc[0].y[igc][hpix] = 0.0; //usage of inf would make rest of graph flat
					else
						gc[0].y[igc][hpix]/= gc[1].y[igc][hpix];
				}
		}
		
		for (isu = isucoomm_start; isu < isucoomm_up; ++isu)
			if (gc[isu].cnt)
			{
				if (divmode == div_by_cnt)
				{
					fcnt = gc[isu].cnt;
					for (igc = 0; igc < igc_count; ++igc)
						for (hpix = 0; hpix < hpixcount; ++hpix)
							gc[isu].y[igc][hpix]/= fcnt;
				}
				
				for (igc = 0; igc < igc_count; ++igc)
					for (hpix = 0; hpix < hpixcount; ++hpix)
					{
						if (gc[isu].ymm[igc][immin] > gc[isu].y[igc][hpix])
							gc[isu].ymm[igc][immin] = gc[isu].y[igc][hpix];
						if (gc[isu].ymm[igc][immax] < gc[isu].y[igc][hpix])
							gc[isu].ymm[igc][immax] = gc[isu].y[igc][hpix];
					}
			}
		int ibar, hpix_in_bar, hpix_in_bar_min, hpix_in_bar_max;
		double ybar;
		int halfbarwidth = pix_per_icoo / 2;
		bool ibarodd_is_zero[Sums1_SumCount];
		bool ibareven_is_zero[Sums1_SumCount];
		for (isu = isucoomm_start; isu < isucoomm_up; ++isu)
		{
			ibareven_is_zero[isu] = true;
			ibarodd_is_zero[isu] = true;
			for (igc = 0; igc < igc_count; ++igc)
			{
				hpix_in_bar_max=intmin;//empty
				for (ibar = 1; ibar < icoostepcount; ++ibar)
				{
					hpix = int(pix_per_icoo * ibar);
					ybar = gc[isu].y[igc][hpix];
					if (ybar != 0)
					{
						if (ibar%2)
							ibarodd_is_zero[isu] = false;
						else
							ibareven_is_zero[isu] = false;
					}
					if (hpix_in_bar_max ==intmin)
						hpix_in_bar_min=hpix - halfbarwidth;
					else
						hpix_in_bar_min=hpix_in_bar_max+1;// (*no holes*)
					hpix_in_bar_max = hpix + halfbarwidth;
					for (hpix_in_bar = hpix_in_bar_min;
					hpix_in_bar <= hpix_in_bar_max; ++hpix_in_bar)
					gc[isu].y[igc][hpix_in_bar] = ybar;
				}
			}
		}
		
		if (cp.kmi("Graph1_BarDbl_Fill0")==1)
		{
			AS sg1s=NullString;
			for (isu = isucoomm_start; isu < isucoomm_up; ++isu)
			{
				int barwidth = pix_per_icoo; //trunc
				int ibar_doublewidth_start = intmax; //default: no loop
				//enlarge only, if only every second bar nonzero (and enough pixel)
				if (ibareven_is_zero[isu] && !ibarodd_is_zero[isu])
					ibar_doublewidth_start = 1;
				else
					if (ibarodd_is_zero[isu] && !ibareven_is_zero[isu])
						ibar_doublewidth_start = 2;
				
				if (ibar_doublewidth_start != intmax)
				{
					sg1s += AS(isu); //show nr of plot with double width bars
					for (igc = 0; igc < igc_count; ++igc)
						for (ibar = ibar_doublewidth_start;
						ibar < icoostepcount; ++ibar, ++ibar)
					{
						hpix = int(pix_per_icoo * ibar);
						ybar = gc[isu].y[igc][hpix];
						hpix_in_bar_max = hpix + barwidth;
						for (hpix_in_bar = hpix - barwidth;
						hpix_in_bar <= hpix_in_bar_max; ++hpix_in_bar)
						gc[isu].y[igc][hpix_in_bar] = ybar;
					}
				}
			}
			if (sg1s!=NullString)//if bars with double width
			{
				sg1s="d"+sg1s;
				//fill isolated zero pixel
				//only in double width mode necessary because of  (*no holes*)
				int hpcm = hpixcount - 1;
				if (int(pix_per_icoo) >= 1)//else surely to ever index summed
				for (isu = isucoomm_start; isu < isucoomm_up; ++isu)
					for (igc = 0; igc < igc_count; ++igc)
						for (hpix = 1; hpix < hpcm; ++hpix)
							if (gc[isu].y[igc][hpix] == 0.0 &&
							gc[isu].y[igc][hpix - 1]!= 0.0 &&
							gc[isu].y[igc][hpix + 1]!= 0.0)
							gc[isu].y[igc][hpix] = gc[isu].y[igc][hpix - 1];
			}
			F1->Label_g1_sep->Caption = sg1s;
			
		}
		if (cp.kmi("Graph1_BarDbl_Fill0")==2)//if fill all zero quantities with prev
		{
			F1->Label_g1_sep->Caption = " F ";
			//fill all zero pixel
			int hpcm = hpixcount - 1;
			for (isu = isucoomm_start; isu < isucoomm_up; ++isu)
				for (igc = 0; igc < igc_count; ++igc)
					for (hpix = 1; hpix < hpcm; ++hpix)
						if (gc[isu].y[igc][hpix] == 0.0)
							gc[isu].y[igc][hpix] = gc[isu].y[igc][hpix - 1];
		}
	}
	catch (EMathError& ema)
	{
		F1->Label_g1_behind_Gimage1->Caption
		= " MathError when calculating G1Par: \n " + ema.Message;
		gc_valid = false;
	}
	catch (...)
	{
		F1->Label_g1_behind_Gimage1->Caption
		= "Error when calculating G1Par";
		gc_valid = false;
	}
	SetF1Caption(NullString);
	gpvalid = gc_valid;
}

void G1Par::Draw_oplot_of_2_valid_curves(const double& y0, const double& y1)
	//x of oplot =y1 of first curve, y of oplot =y2 of second curve
	//analog "o" in oscilloscope, if the two curves are y1=sin(x) and y2=cos(x)
{
	int igc01[2],isu01[2];
	isu01[1]=intmin;
	
	{
		int isu,igc,i01;
		for (isu = 0, i01=0; isu < Sums1_SumCount; ++isu)
			for (igc = 0; igc < igc_count; ++igc)
				if (gc[isu].draw[igc])
				{
					if (i01<2)
					{
						isu01[i01]=isu;
						igc01[i01]=igc;
					}
					++i01;
				}
		#ifdef wdebug
		if (i01!=2)
		{pip("oplot: not 2 but "+AS(i01)+ " valid curves"); return;}
		#endif
	}
	//now in isu01[0] and igc01[0] indices of first curve and
	//    in isu01[1] and igc01[1] indices of second curve
	
	//x-Interface:
	double x0, x1;
	{
		double xcenter=(y0+y1)/2.0;//same as ycenter
		double xoffset=((y1-y0)*hpixcount / vpixcount)/2.0;
		x0=xcenter-xoffset;
		x1=xcenter+xoffset;
	}
	
	//x0 = double(icoominmax[immin]); x1 = double(icoominmax[immax]);
	
	ClearImage(F1->Gimage1, false);
	gpar.DrawGrid(F1->Gimage1, false, hpixcount, vpixcount, x0, x1, y0, y1);
	
	F1->Gimage1->Canvas->Pen->Color
	= cp.kmi("Graph1_OnlyBlackWhite") ? clBlack : clRed;
	
	int hpix, px, py;
	double wx=0;
	double wy=0;
	bool moved=false;
	
	switch (cp.kmi("Graph1_oplot_skip_zeros"))
	{
		case 1://skip only, if both x and y are zero
			for (hpix = 0; hpix < hpixcount; ++hpix)
			{
				if (gc[isu01[0]].y[igc01[0]][hpix]!=0) wx=gc[isu01[0]].y[igc01[0]][hpix];
				if (gc[isu01[1]].y[igc01[1]][hpix]!=0) wy=gc[isu01[1]].y[igc01[1]][hpix];
				if (wx!=0.0 || wy!=0)
				{
					px = x_Screen(wx,x0, x1, hpixcount);
					py = y_Screen(wy,y0, y1, vpixcount);
					if (moved)
						F1->Gimage1->Canvas->LineTo(px, py);
					else
					{
						F1->Gimage1->Canvas->MoveTo(px, py);
						moved=true;
					}
				}
			} break;
		case 2://skip if x or y is zero
			for (hpix = 0; hpix < hpixcount; ++hpix)
			{
				if (gc[isu01[0]].y[igc01[0]][hpix]!=0) wx=gc[isu01[0]].y[igc01[0]][hpix];
				if (gc[isu01[1]].y[igc01[1]][hpix]!=0) wy=gc[isu01[1]].y[igc01[1]][hpix];
				if (wx!=0.0 && wy!=0)
				{
					px = x_Screen(wx,x0, x1, hpixcount);
					py = y_Screen(wy,y0, y1, vpixcount);
					if (moved)
						F1->Gimage1->Canvas->LineTo(px, py);
					else
					{
						F1->Gimage1->Canvas->MoveTo(px, py);
						moved=true;
					}
				}
			} break;
			
		default://0, dont'skip, draw all
			for (hpix = 0; hpix < hpixcount; ++hpix)
			{
				wx=gc[isu01[0]].y[igc01[0]][hpix];
				wy=gc[isu01[1]].y[igc01[1]][hpix];
				px = x_Screen(wx,x0, x1, hpixcount);
				py = y_Screen(wy,y0, y1, vpixcount);
				if (moved)
					F1->Gimage1->Canvas->LineTo(px, py);
				else
				{
					F1->Gimage1->Canvas->MoveTo(px, py);
					moved=true;
				}
			}
	}
}

void G1Par::DrawGimage1FromGc()
{
	F1->Label_g1_cnt1->Caption = "cnt=" + AS(gc[0].cnt);
	F1->Label_g1_cnt2->Caption = "cnt=" + AS(gc[1].cnt);
	F1->Label_g1_x1->Caption = "x="
	+ DimNumString(s1p.ta[s1p.ita].icoo_along_x_in_g[0]);
	F1->Label_g1_x2->Caption = "x="
	+ DimNumString(s1p.ta[s1p.ita].icoo_along_x_in_g[1]);
	
	if (gpvalid)
	{
		F1->Label_g1_behind_Gimage1->Visible = false;
		F1->Gimage1->Visible = true;
	}
	else
	{
		F1->Label_g1_behind_Gimage1->Visible = true;
		F1->Gimage1->Visible = false;
		F1->Label_g1_oplot->Visible = false;
		return;
	}
	
	int igc, isu;
	double yMinMax[MinMaxCount];
	
	yMinMax[immax] = (- doublemax);
	yMinMax[immin] = doublemax;
	int plotcount=0;
	for (isu = 0; isu < Sums1_SumCount; ++isu)
		for (igc = 0; igc < igc_count; ++igc)
			if (gc[isu].draw[igc])
			{
				plotcount++;
				if (yMinMax[immin] > gc[isu].ymm[igc][immin])
					yMinMax[immin] = gc[isu].ymm[igc][immin];
				if (yMinMax[immax] < gc[isu].ymm[igc][immax])
					yMinMax[immax] = gc[isu].ymm[igc][immax];
			}
	if (yMinMax[immax] <= yMinMax[immin])
	{
		F1->Label_g1_behind_Gimage1->Visible = true;
		F1->Gimage1->Visible = false;
		return;
	}
	
	
	double y0, y1;
	//koosys world frontiers: x from x0 to x1, y from y0 to y1
	{
		double ydiff = yMinMax[immax] - yMinMax[immin];
		double yborder = double(cp.kmi("Graph_y_border_percent"))/100.0
		* ydiff;
		
		//y-Interface:
		y1 = yMinMax[immax] + yborder;
		y0 = yMinMax[immin] - yborder;
		if (cp.kmi("Graph_Gridlines_Auto"))
		{
			RoundUp1Decimalp_1(y1, ydiff);
			RoundDown1Decimalp_1(y0, ydiff);
		}
	}
	
	
	if (plotcount==2)
	{
		F1->Label_g1_oplot->Visible=true;
		//visible, if well defined plot with y=y_plot1 und x=y_plot2 is possible
		if (oplot_if_2_curves)
		{
			F1->Label_g1_oplot->Caption="o";
			Draw_oplot_of_2_valid_curves(y0, y1);
			return;
		}
		else
			F1->Label_g1_oplot->Caption="T";
	}
	else
		F1->Label_g1_oplot->Visible=false;
	
	
	//x-Interface:
	double x0, x1;
	x0 = double(icoominmax[immin]);
	x1 = double(icoominmax[immax]);
	
	ClearImage(F1->Gimage1, false);
	gpar.DrawGrid(F1->Gimage1, false, hpixcount, vpixcount, x0, x1, y0, y1);
	
	int hpix, py;
	bool barsvertical = cp.kmi("Graph_BarsEdgesVertical");
	bool onlyblackwhite=cp.kmi("Graph1_OnlyBlackWhite");
	
	for (isu = 0; isu < Sums1_SumCount; ++isu)
		for (igc = 0; igc < igc_count; ++igc)
			if (gc[isu].draw[igc])
			{
				F1->Gimage1->Canvas->Pen->Color = onlyblackwhite ? clBlack : gc[isu].color[igc];
				
				if (barsvertical)
					for (hpix = 0; hpix < hpixcount; hpix++)
					{
						py = y_Screen(gc[isu].y[igc][hpix], y0, y1, vpixcount);
						if (hpix == 0) F1->Gimage1->Canvas->MoveTo(hpix+1, py);
						else
						{
							F1->Gimage1->Canvas->LineTo(hpix, py);
							F1->Gimage1->Canvas->LineTo(hpix+1, py);
						}
					}
					else
						for (hpix = 0; hpix < hpixcount; hpix++)
						{
							py = y_Screen(gc[isu].y[igc][hpix],y0, y1, vpixcount);
							if (hpix == 0) F1->Gimage1->Canvas->MoveTo(hpix+1, py);
							else         F1->Gimage1->Canvas->LineTo(hpix+1, py);
						}
			}
}

void G1Par::UpdateAndShowGraph1(bool calc_gc_new)
{
	cp.UpdateGraph1CBfromConfig();
	
	//trf: necessary for transfer over different screen resolutions
	F1->Gimage1->Width=F1->Graph1->Width;
	F1->Gimage1->Height=F1->Graph1->Height - F1->Gimage1->Top;
	
	resize_bitmap_image(F1->Gimage1, F1->Gimage1->Width, F1->Gimage1->Height);
	gr1par.UpdateGcDrawFromCB();
	if (calc_gc_new)
		gr1par.Calc_gc_from_lgl();
	gr1par.DrawGimage1FromGc();
}

//---------------------------------------------------------
void __fastcall TF1::Label_g1_oplotClick(TObject *Sender)
{
	gr1par.oplot_if_2_curves=!gr1par.oplot_if_2_curves;
	cp.setkmi_1("Graph1_oplot_if_2_curves", gr1par.oplot_if_2_curves);
	gr1par.UpdateAndShowGraph1(false);
}
//---------------------------------------------------------------------------
void __fastcall TF1::AlgaddShow(TObject *Sender)
{
	aav.UpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
	SlAlgadd->SetFocus();
}
//---------------------------------------------------------------------------


void __fastcall TF1::AlgClick(TObject *Sender)
{
	aav.SetAlgCaptions();
}
//---------------------------------------------------------------------------
void UpsGraph1()
{
	cp.UpdateConfigFromGraph1CB();
	gr1par.UpdateAndShowGraph1
	(!cp.kmi("Graph1_quick_xscale_r12_common"));
}
//--------
void __fastcall TF1::CB0qreClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB0qqClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB1qimClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB1qqClick(TObject *Sender)
{UpsGraph1();}
void __fastcall TF1::CB0qimClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB1qreClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB1qaClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB0qaClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB0cntAtClick(TObject *Sender)
{UpsGraph1(); }
void __fastcall TF1::CB1cntAtClick(TObject *Sender)
{UpsGraph1(); }
//--------
void __fastcall TF1::Graph1Show(TObject *Sender)
{
	gr1par.UpdateAndShowGraph1(true);
}
//---------------------------------------------------------------------------

//----Graph2:

void G2Par::InitMinMax_RB_Zero_box_til_hvpixcount()
	//gpvalid=false, cnt=0, hpixcount, vpixcount must be set
{
	//void G2Par::SetIgcaktIsuaktFromRadioButtons()
	{
		if (F1->RB0qre->Checked)
		{isu_akt = 0; igc_akt = igc_qre; }
		if (F1->RB0qim->Checked)
		{isu_akt = 0; igc_akt = igc_qim; }
		if (F1->RB0qq->Checked)
		{isu_akt = 0; igc_akt = igc_qq; }
		if (F1->RB0qa->Checked)
		{isu_akt = 0; igc_akt = igc_qa; }
		if (F1->RB0cntAt->Checked)
		{isu_akt = 0; igc_akt = igc_cntAt; }
		
		if (F1->RB1qre->Checked)
		{isu_akt = 1; igc_akt = igc_qre; }
		if (F1->RB1qim->Checked)
		{isu_akt = 1; igc_akt = igc_qim; }
		if (F1->RB1qq->Checked)
		{isu_akt = 1; igc_akt = igc_qq; }
		if (F1->RB1qa->Checked)
		{isu_akt = 1; igc_akt = igc_qa; }
		if (F1->RB1cntAt->Checked)
		{isu_akt = 1; igc_akt = igc_cntAt; }
	}
	
	int hpix, vpix;
	vmm[immin] = doublemax;
	vmm[immax] = (- doublemax);
	ixcoominmax[immin] = iycoominmax[immin] = intmax;
	ixcoominmax[immax] = iycoominmax[immax] = intmin;
	
	for (hpix = 0; hpix < hpixcount; ++hpix)
		for (vpix = 0; vpix < vpixcount; ++vpix)
			q[hpix][vpix] = 0.0;
	
	clg2_start = (clg2_max*cp.kmi("Graph2_color_white_offset"))/100;
	clg2_max_minus_start = clg2_max - clg2_start;
	g2_color_mode = cp.kmi("Graph2_color_mode");
}

//---------------------------------------------------------------------------

void G2Par::Calc_v_from_lgl()
{
	gpvalid = false;
	cnt = 0;
	hpixcount = F1->Gimage2->Width;
	vpixcount = F1->Gimage2->Height;
	F1->Label_g2_behind_Gimage2->Caption = NullString;
	
	if (hpixcount > max_hpixcount)
	{
		warn(wl_all,"Calc_v_from_lgl: hpixcount="
		+ AS(hpixcount) + " set to max_hpixcount="
		+ AS(max_hpixcount));
		hpixcount = max_hpixcount;
	}
	if (vpixcount > max_vpixcount)
	{
		warn(wl_all,"Calc_v_from_lgl: vpixcount="
		+ AS(vpixcount) + " set to max_vpixcount="
		+ AS(max_vpixcount));
		vpixcount = max_vpixcount;
	}
	
	if (!(hpixcount && vpixcount))
	{
		F1->Label_g2_behind_Gimage2->Caption = "No pixel";
		return;
	}
	
	size_type lsiz = lgl.LmapSize();
	if (!lsiz)
	{
		F1->Label_g2_behind_Gimage2->Caption = LatticesEmptyString;
		return;
	}
	
	bool div_by_cnt = cp.kmi("Graph2_divide_y_by_count");
	if (div_by_cnt)
	{
		F1->Label_g2_SR1->Caption = "SR1/cnt:";
		F1->Label_g2_SR2->Caption = "SR2/cnt:";
	}
	else
	{
		F1->Label_g2_SR1->Caption = "SR1:";
		F1->Label_g2_SR2->Caption = "SR2:";
	}
	
	InitMinMax_RB_Zero_box_til_hvpixcount();
	
	bool g2try_ok = true;
	
	try
	{
		probar pb(0, lsiz);
		int dstep = cp.kmi("Graph_EntryCountPerDisplay");
		int ecount = 0;
		int itmp;
		
		//calc ixycoominmax:
		for (Lmapi it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
		{
			if (it->first.between
			(s1p.ta[s1p.ita].range[isu_akt][immin], s1p.ta[s1p.ita].range[isu_akt][immax]))
			{
				itmp = it->first.coo[s1p.ta[s1p.ita].icoo_along_x_in_g[isu_akt]];
				if (itmp < ixcoominmax[immin])
					ixcoominmax[immin] = itmp;
				
				if (itmp > ixcoominmax[immax])
					ixcoominmax[immax] = itmp;
				
				itmp = it->first.coo[s1p.ta[s1p.ita].icoo_along_y_in_g2[isu_akt]];
				if (itmp < iycoominmax[immin])
					iycoominmax[immin] = itmp;
				
				if (itmp > iycoominmax[immax])
					iycoominmax[immax] = itmp;
			}
			if (!(++ecount%dstep))
			{
				F1->Caption = "lattice point " + AS(ecount) + " of "
				+ AS(lsiz) + " checked";
				pb.SetProgressBarPosition(ecount);
			}
		}
		//now ixycoominmax valid
		
		//border:
		iycoominmax[immax]+=ixy_minborder; iycoominmax[immin]-=ixy_minborder;
		ixcoominmax[immax]+=ixy_minborder; ixcoominmax[immin]-=ixy_minborder;
		
		ecount = 0;
		int ixcoostepcount = ixcoominmax[immax] - ixcoominmax[immin];
		int iycoostepcount = iycoominmax[immax] - iycoominmax[immin];
		if (ixcoostepcount > 0)
			xpix_per_icoo = double(hpixcount)/double(ixcoostepcount);
		else
		{
			F1->Label_g2_behind_Gimage2->Caption =
			" no different x ";
			return;
		}
		if (iycoostepcount > 0)
			ypix_per_icoo = double(vpixcount)/double(iycoostepcount);
		else
		{
			F1->Label_g2_behind_Gimage2->Caption =
			" no different y ";
			return;
		}
		
		int hpix, vpix, hsteps, vsteps;
		cotyp ctmp;
		double fcnt;
		
		double hpd,vpd;
		double hpix_double_used[max_hpixcount];//avoid overlapping summation
		double vpix_double_used[max_vpixcount];
		for (hpix=0; hpix<max_hpixcount;++hpix) hpix_double_used[hpix]=noindex;
		for (vpix=0; vpix<max_vpixcount;++vpix) vpix_double_used[vpix]=noindex;
		
		bool g2_sum_all = !cp.kmi("Graph2_AvoidOverlappingSum");
		
		//main loop
		for (Lmapi it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
		{
			ctmp = it->second;
			if (it->first.between //i.e.icoostepcount>0
			(s1p.ta[s1p.ita].range[isu_akt][immin], s1p.ta[s1p.ita].range[isu_akt][immax]))
			{
				++cnt;
				hsteps=it->first.coo[s1p.ta[s1p.ita].icoo_along_x_in_g[isu_akt]] - ixcoominmax[immin];
				
				hpd = xpix_per_icoo * hsteps;
				//hpix = int(hpd);//not sufficient because of unexpected rounding error, therefore again:
				hpix = int(xpix_per_icoo * hsteps);
				if (hpix_double_used[hpix]==noindex) hpix_double_used[hpix]=hpd;//first init
				
				vsteps=it->first.coo[s1p.ta[s1p.ita].icoo_along_y_in_g2[isu_akt]] - iycoominmax[immin];
				vpd = ypix_per_icoo * vsteps;
				vpix=int(ypix_per_icoo * vsteps);//see above
				if (vpix_double_used[vpix]==noindex) vpix_double_used[vpix]=vpd;
				
				if (g2_sum_all //if not, sum only, if identical to first, i.e. nonoverlapping
				|| (hpix_double_used[hpix]==hpd && vpix_double_used[vpix]==vpd))
				switch (igc_akt)
				{
					case igc_qre:
						q[hpix][vpix] += ctmp.real().florep();
						break;
					case igc_qim:
						q[hpix][vpix] += ctmp.imag().florep();
						break;
					case igc_qq:
						q[hpix][vpix] += abs2(ctmp).florep();
						break;
					case igc_qa:
						q[hpix][vpix] += sqrt(abs2(ctmp).florep());
						break;
					case igc_cntAt:
						++q[hpix][vpix];
						break;
					default:
						F1->Label_g2_behind_Gimage2->Caption
						= "Calc_v_from_lgl: wrong igc_akt=" + AS(igc_akt);
						return;
				}
			}
			if (!(++ecount%dstep))
			{
				F1->Caption = "lattice point " + AS(ecount) + " of "
				+ AS(lsiz) + " summed up";
				pb.SetProgressBarPosition(ecount);
			}
		}
		//the rest can be done outside of loop
		if (cnt)
		{
			fcnt = cnt;
			for (hpix = 0; hpix < hpixcount; ++hpix)
				for (vpix = 0; vpix < vpixcount; ++vpix)
				{
					if (div_by_cnt)
						q[hpix][vpix]/= fcnt;
					
					if (vmm[immin] > q[hpix][vpix])
						vmm[immin] = q[hpix][vpix];
					if (vmm[immax] < q[hpix][vpix])
						vmm[immax] = q[hpix][vpix];
				}
		}
		else
		{
			F1->Label_g2_behind_Gimage2->Caption
			= " cnt=0 ";
			return;
		}
		
		//blow up
		int ixbox, iybox, ix_in_box, iy_in_box;
		int ix_in_box_min, ix_in_box_max, iy_in_box_min, iy_in_box_max;
		int half_yb = ypix_per_icoo/2;
		int half_xb = xpix_per_icoo/2;
		double boxquantity;
		bool ixboxeven_is_zero;
		bool ixboxodd_is_zero;
		bool all_steps_are_double=true;
		iy_in_box_max=intmin;//signals empty
		for (iybox = 1; iybox < iycoostepcount; ++iybox)
		{
			vpix = int(ypix_per_icoo*iybox);
			ixboxeven_is_zero = true;
			ixboxodd_is_zero = true;
			
			if (iy_in_box_max ==intmin)
				iy_in_box_min=vpix - half_yb;
			else
				iy_in_box_min=iy_in_box_max+1;
			iy_in_box_max = vpix + half_yb;
			
			ix_in_box_max=intmin;
			for (ixbox = 1; ixbox < ixcoostepcount; ++ixbox)
			{
				hpix = int(xpix_per_icoo*ixbox);
				boxquantity = q[hpix][vpix];
				if (boxquantity != 0)
				{
					if (ixbox%2)
						ixboxodd_is_zero = false;
					else
						ixboxeven_is_zero = false;
				}
				
				if (ix_in_box_max ==intmin)
					ix_in_box_min=hpix - half_xb;
				else
					ix_in_box_min=ix_in_box_max+1;
				ix_in_box_max = hpix + half_xb;
				for(ix_in_box = ix_in_box_min; ix_in_box <= ix_in_box_max; ++ix_in_box)
					for(iy_in_box = iy_in_box_min; iy_in_box <= iy_in_box_max; ++iy_in_box)
						q[ix_in_box][iy_in_box] = boxquantity;
			}
			if (ixboxodd_is_zero == ixboxeven_is_zero)
				all_steps_are_double=false;
		}
		
		F1->Label_g2_sep->Caption = "  "; //default
		int ixcoostepcount_minus_1=ixcoostepcount-1;
		if (cp.kmi("Graph2_BoxDoubleWidth") && all_steps_are_double)
		{
			F1->Label_g2_sep->Caption = " d "; //indicate, that boxes have double width
			iy_in_box_max=intmin;
			for (iybox = 1; iybox < iycoostepcount; ++iybox)
			{
				vpix = int(ypix_per_icoo*iybox);
				
				if (iy_in_box_max ==intmin)
					iy_in_box_min=vpix - half_yb;
				else
					iy_in_box_min=iy_in_box_max+1;
				iy_in_box_max = vpix + half_yb;
				
				iy_in_box_max = vpix + half_yb;
				for (ixbox = 0; ixbox < ixcoostepcount_minus_1; ++ixbox)
				{
					hpix = int(xpix_per_icoo*ixbox);
					boxquantity = q[hpix][vpix];
					
					if (boxquantity!=0)
						for (; ixbox < ixcoostepcount; ++ixbox, ++ixbox)//double steps
					{
						hpix = int(xpix_per_icoo*ixbox);
						boxquantity = q[hpix][vpix];
						ix_in_box_max = hpix + xpix_per_icoo+1;
						if (ix_in_box_max > hpixcount-1)
							ix_in_box_max = hpixcount-1;
						
						for (ix_in_box = hpix - xpix_per_icoo+1;
						ix_in_box <= ix_in_box_max; ++ix_in_box)
						for (iy_in_box = iy_in_box_min;
						iy_in_box <= iy_in_box_max; ++iy_in_box)
						q[ix_in_box][iy_in_box] = boxquantity;
					}
				}
			}
		}
		
		if (xpix_per_icoo<1)
		{
			if (ypix_per_icoo<1)
				WarnThatNotEnoughPixelAlong("xy in Graph 2\n"
				" (xpix_per_icoo = "+FS(xpix_per_icoo)+" < 1)\n"
				" (ypix_per_icoo = "+FS(ypix_per_icoo)+" < 1)",g2_sum_all);
			else
				WarnThatNotEnoughPixelAlong("x in Graph 2\n"
				" (xpix_per_icoo = "+FS(xpix_per_icoo)+" < 1)\n",g2_sum_all);
		}
		else
			if (ypix_per_icoo<1)
				WarnThatNotEnoughPixelAlong("y in Graph 2\n"
				" (ypix_per_icoo = "+FS(ypix_per_icoo)+" < 1)",g2_sum_all);
	}
	catch (EMathError& ema)
	{
		F1->Label_g2_behind_Gimage2->Caption
		= " MathError when calculating G1Par: \n " + ema.Message;
		g2try_ok = false;
	}
	catch (...)
	{
		F1->Label_g2_behind_Gimage2->Caption
		= "Error when calculating G1Par";
		g2try_ok = false;
	}
	SetF1Caption(NullString);
	gpvalid = g2try_ok;
}
//-----------------------
void SetGraph2VisibleTo(bool vi2, bool vi2a)
	//vi2 fr 2d graph, vi2a fr multi 1d graph
{
	F1->Label_g2_color0->Visible=vi2;
	F1->Label_g2_color1->Visible=vi2;
	F1->Label_g2_color2->Visible=vi2;
	F1->Label_g2_color3->Visible=vi2;
	F1->Label_g2_color4->Visible=vi2;
	F1->Label_g2_color5->Visible=vi2;
	F1->Label_g2_color6->Visible=vi2;
	F1->Label_g2_color7->Visible=vi2;
	F1->Label_g2_color8->Visible=vi2;
	F1->Label_g2_color9->Visible=vi2;
	F1->Label_g2_color10->Visible=vi2;
	F1->Label_g2_color11->Visible=vi2;
	F1->Label_g2_color12->Visible=vi2;
	F1->Label_g2_color13->Visible=vi2;
	F1->Label_g2_color14->Visible=vi2;
	F1->Label_g2_color15->Visible=vi2;
	F1->Label_g2_color16->Visible=vi2;
	F1->Label_g2_color17->Visible=vi2;
	F1->Label_g2_color18->Visible=vi2;
	F1->Label_g2_color19->Visible=vi2;
	F1->Label_g2_color20->Visible=vi2;
	F1->Gimage2_cld->Visible=vi2;
	F1->Label_g2_distribution->Visible=vi2;
	
	bool vi2or2a=vi2 || vi2a;
	F1->Gimage2->Visible=vi2or2a;
	F1->Label_g2_cnt->Visible=vi2or2a;
	F1->Button_g2a_ny->Visible=vi2or2a;
	F1->Label_g2_behind_Gimage2->Visible = !vi2or2a;
	
	F1->Slg2a->Visible=vi2a;
}
//-----------------------

TColor G2Par::clg2_from_01(const double& fc_org)
	//return color dep. on fc=0..1: bei fc=0: black, bei fc=1: white
{
	switch (g2_color_mode)
	{
		case g2_bw: //if BlackWhite
			{
				int c = clg2_start + int(clg2_max_minus_start*fc_org);
				return c + 256*c + 256*256*c; //Order: RGB
			} break;
		case g2_red_to_white:
			{
				double fc_part = fc_org;
				if (fc_org > 2.0/3.0)
					return clg2_max*(1 + 256) //red and green maximal
					+ (clg2_start + int(clg2_max_minus_start*(3.0*fc_org - 2.0)))*(256*256);
				else
					if (fc_org > 1.0/3.0)
						return clg2_max //red maximal
						+ (clg2_start + int(clg2_max_minus_start*(3.0*fc_org - 1.0)))*(256);
					else
						return clg2_start + int(clg2_max_minus_start*(3.0*fc_org));
			} break;
		case g2_green_to_white:
			{
				double fc_part = fc_org;
				if (fc_org > 2.0/3.0)
					return clg2_max*((1 + 256)*256) //green and blue maximal
					+ (clg2_start + int(clg2_max_minus_start*(3.0*fc_org - 2.0)));
				else
					if (fc_org > 1.0/3.0)
						return clg2_max*256 //green maximal
						+ (clg2_start + int(clg2_max_minus_start*(3.0*fc_org - 1.0)))*(256*256);
					else
						return (clg2_start + int(clg2_max_minus_start*(3.0*fc_org)))*256;
			} break;
		case g2_blue_red_to_white:
			{
				double fc_part = fc_org;
				if (fc_org > 2.0/3.0)
					return clg2_max*(1 + 256*256) //red and blue maximal
					+ (clg2_start + int(clg2_max_minus_start*(3.0*fc_org - 2.0)))*256;
				else
					if (fc_org > 1.0/3.0)
						return clg2_max*256*256 //blue maximal
						+ (clg2_start + int(clg2_max_minus_start*(3.0*fc_org - 1.0)));
					else
						return (clg2_start + int(clg2_max_minus_start*(3.0*fc_org)))*256*256;
			} break;
		default: pip("clg2_from_01: invalid g2_colormode "
			+ AS(g2_color_mode)); break;
	}
	pip("clg2_from_01: invalid color");
	return clg2_start;//dummy to disable warning
}

void G2Par::SetLabelColor_1(TLabel* label, const double fcl)
{
	label->Color = clg2_from_01(fcl);
	label->Font->Color = fcl < 0.5 ? gpar.color_axes: gpar.color_grid;
}

void G2Par::SetNextLabelColorAndCaption_1(TLabel* label)
{
	int precision = cp.kmi("Graph_num_precision");
	SetLabelColor_1(label, double(i_label_g2)/double(label_g2_count - 1));
	label->Caption = FloatToStrF
	(fclimit[i_label_g2*fclimits_per_label], ffGeneral, precision, precision);
	++i_label_g2;
}
void G2Par::SetColorLabelsAndG2cld()
	//call it after DrawGrid, so that gpar.color_grid: gpar.color_axes uptodate
{
	G2Par::Zero_i_label_g2();
	
	SetNextLabelColorAndCaption_1(F1->Label_g2_color0);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color1);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color2);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color3);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color4);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color5);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color6);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color7);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color8);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color9);
	
	SetNextLabelColorAndCaption_1(F1->Label_g2_color10);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color11);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color12);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color13);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color14);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color15);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color16);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color17);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color18);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color19);
	SetNextLabelColorAndCaption_1(F1->Label_g2_color20);
	
	#if 20 != label_g2_count-1
	Error: label_g2_count passt nicht zu ob. init
	#endif
	
	//Now Set Gimage2_cld=Image, which shows colordistribution
	
	int hpcount = F1->Gimage2_cld->Width;
	int vpcount = F1->Gimage2_cld->Height;
	int iy;
	
	TImage *g2cl = F1->Gimage2_cld;
	
	for (iy = 0; iy < vpcount; ++iy)
	{
		g2cl->Canvas->Pen->Color = clg2_from_01(double(iy)/double(vpcount - 1));
		g2cl->Canvas->MoveTo(0, vpcount - 1 - iy);
		g2cl->Canvas->LineTo(hpcount - 1, vpcount - 1 - iy);
	}
	
	int hp;
	double x0, x1, x; //y along index in fclimit, x its quantity
	x0 = fclimit[0];
	x1 = fclimit[fclimit_count - 1];
	
	g2cl->Canvas->Pen->Color = gpar.color_axes;
	g2cl->Canvas->MoveTo(0, vpcount - 1);
	for (iy = 0; iy < vpcount/2; ++iy)
	{
		x = fclimit[int((fclimit_count - 1)*double(iy)/double(vpcount - 1))];
		hp = x_Screen(x, x0, x1, hpcount);
		g2cl->Canvas->LineTo(hp, vpcount - 1 - iy);
	}
	
	g2cl->Canvas->Pen->Color = gpar.color_grid;
	for (iy = vpcount/2; iy < vpcount; ++iy)
	{
		x = fclimit[int((fclimit_count - 1)*double(iy)/double(vpcount - 1))];
		hp = x_Screen(x, x0, x1, hpcount);
		g2cl->Canvas->LineTo(hp, vpcount - 1 - iy);
	}
}

//------------

void wlocate_1(int& j, const double xx[],
const int& xx_count, const double& x)
//locate in increasing table xx, return j that xx[j]< x <=xx[j+1]
{
	int ju, jm, jl;
	jl = 0;
	ju = xx_count;
	while (ju - jl > 1)
	{
		jm = (ju + jl) >> 1;
		if (x > xx[jm])
			jl = jm;
		else
			ju = jm;
	}
	j = jl;
}

TColor G2Par::color_from_fcl_table(const double& q)
{
	int i;
	if (fclimit[fclimit_count - 1] <= q)
	{
		#ifdef wdebug
		if (fclimit[fclimit_count - 1] < littlesm(q))
			warn(wl_all,"color_from_fcl_table: \n"
			+ AS(fclimit[fclimit_count - 1]) + "=fclimit[fclimit_count-1]"
			" < littlesm(q)=" + AS(littlesm(q)));
		#endif
		return clg2_from_01(1.0);//for better contrast in case of ...==q
	}
	else
		if (fclimit[0] > q)
		{
			#ifdef wdebug
			if (fclimit[0] > littlegr(q))
				warn(wl_all,"color_from_fcl_table: fclimit[0]>littlegr(q)");
			#endif
			return clg2_from_01(0.0);
		}
	
	// for (i=0; fclimit[i]<q;++i); --i;
	//faster:
	wlocate_1(i, fclimit, fclimit_count, q);
	
	return clg2_from_01(delta_fc_per_fclimit  //linear interpolation in between
	* (i + (q - fclimit[i])/(fclimit[i + 1] - fclimit[i])));
}

//---------
void G2Par::Set_linear_fclimit(const double& vmin, const double& vmax)
{
	double delta_v_per_color = (vmax - vmin)/double(fclimit_count - 1);
	for (int i = 0; i < fclimit_count; ++i)
		fclimit[i] = vmin + double(i)*delta_v_per_color;
}

void G2Par::Set_equally_distributed_fclimit()
{
	int vpix, hpix;
	Vmap vm; //sorted along q for equal greyscale per fclimit[]
	Vmapi vi;
	Vpair vp;
	int vcnt = 0;
	for (vpix = 0; vpix < vpixcount; ++vpix)
		for (hpix = 0; hpix < hpixcount; ++hpix)
		{
			vi = vm.find(q[hpix][vpix]);
			if (vi == vm.end())
			{
				vp.first = q[hpix][vpix]; //insert one item per q
				vm.insert(vp);
				++vcnt;//number of different q
			}
		}
	int i,j;
	int inext = 1;
	int vcnt_akt = 0;
	double di_per_v = double(fclimit_count - 1)/double(vcnt);
	vi = vm.begin();
	fclimit[0] = vi->first;//sure consideration of minimum
	for (; vi != vm.end(); ++vi)
	{
		++vcnt_akt;
		i = int(double(vcnt_akt)*di_per_v);
		for (j = inext; j <= i; ++j)
			fclimit[j] = vi->first;
		inext = i+1;
		
		#ifdef wdebug
		if (i >= fclimit_count)
		{
			pip("Set_equally_distributed_fclimit()\n"
			+ AS(i) + "=i >= fclimit_count=" + AS(fclimit_count));
			i = fclimit_count - 1;
		}
		#endif
	}
	for (j = inext; j < fclimit_count; ++j)
		fclimit[j] = fclimit[inext-1];
	
	--vi;//ret from end, 474 Stou
	fclimit[fclimit_count-1]=vi->first;//sure consideration of maximum
}
//-----------

void G2Par::DrawGimage2FromQuantities()
{
	F1->Label_g2_cnt->Caption = "cnt=" + AS(cnt);
	F1->Label_g2_x->Caption = "x="
	+ DimNumString(s1p.ta[s1p.ita].icoo_along_x_in_g[isu_akt]);
	F1->Label_g2_y->Caption = "y="
	+ DimNumString(s1p.ta[s1p.ita].icoo_along_y_in_g2[isu_akt]);
	F1->Button_g2a_ny->Caption = "set ny:"
	+AS(cp.kmi("Graph2a_ny"));
	
	SetGraph2VisibleTo(false,false);
	if (!gpvalid)
		return;
	ClearImage(F1->Gimage2, true);
	if (cp.kmi("Graph2a_ny")!=0)
	{
		PlotMultiple1DGraphsOnGimage2();
		return;
	}
	
	
	//world frontiers: x from x0 to x1, y from y0 to y1
	double x0, x1, y0, y1;
	x0 = double(ixcoominmax[immin]);
	x1 = double(ixcoominmax[immax]);
	y0 = double(iycoominmax[immin]);
	y1 = double(iycoominmax[immax]);
	
	probar pb(0, vpixcount);
	G2ColorDistribution g2cm = cp.kmi("Graph2_color_distribution");
	if (g2cm == g2_colors_equally_distributed)
		Set_equally_distributed_fclimit();
	else //if (g2cm == g2_colors_linear)
	Set_linear_fclimit(vmm[immin], vmm[immax]);
	
	int hpix, vpix, yscreen;
	TColor color;
	int dstep = cp.kmi("Graph2_LineCountPerDisplay");
	double v_before;
	int hpixcount_minus_1 = hpixcount - 1;
	
	for (vpix = 0; vpix < vpixcount; ++vpix)
	{
		if (!(vpix%dstep))
		{
			F1->Caption = "Plotting line "
			+ AS(vpix) + " of " + AS(vpixcount);
			pb.SetProgressBarPosition(vpix);
		}
		yscreen = vpixcount - vpix - 1;
		v_before = q[0][vpix];
		
		color = color_from_fcl_table(v_before);
		for (hpix = 1; hpix < hpixcount; ++hpix)
		{
			SetPixel(F1->Gimage2->Canvas->Handle, hpix - 1, yscreen, color);
			if (v_before != q[hpix][vpix])
			{
				v_before = q[hpix][vpix];
				color = color_from_fcl_table(v_before);
			}
		}
		SetPixel(F1->Gimage2->Canvas->Handle, hpixcount_minus_1, yscreen, color);
	}
	gpar.DrawGrid(F1->Gimage2, true, hpixcount, vpixcount, x0, x1, y0, y1);
	SetColorLabelsAndG2cld();
	SetGraph2VisibleTo(true,false);
	SetF1Caption(NullString);
}

//----------------------

bool Graph2_deviating_RB_state()
{
	bool identic;
	switch (cp.kmi("Graph2_RB_re_im_qa_qq_cntAt_12"))
	{
		case 0: identic = F1->RB0qre->Checked; break;
		case 1: identic = F1->RB0qim->Checked; break;
		case 2: identic = F1->RB0qq ->Checked; break;
		case 3: identic = F1->RB0qa ->Checked; break;
		case 4: identic = F1->RB0cntAt ->Checked; break;
		case 5: identic = F1->RB1qre->Checked; break;
		case 6: identic = F1->RB1qim->Checked; break;
		case 7: identic = F1->RB1qq ->Checked; break;
		case 8: identic = F1->RB1qa ->Checked; break;
		case 9: identic = F1->RB1cntAt ->Checked; break;
		default:
			#ifdef wdebug
			pip ("Graph2_deviating_RB_state: Invalid default index: \n"
			"kmi(\"Graph2_RB_re_im_qa_qq_cntAt_12\")="
			+ AS(cp.kmi("Graph2_RB_re_im_qa_qq_cntAt_12")));
			#endif
			identic = false;
			break;
	}
	return !identic;
}


void UpdateGraph2RB()
{
	switch (cp.kmi("Graph2_RB_re_im_qa_qq_cntAt_12"))
	{
		case 0: F1->RB0qre->Checked = true; break;
		case 1: F1->RB0qim->Checked = true; break;
		case 2: F1->RB0qq ->Checked = true; break;
		case 3: F1->RB0qa ->Checked = true; break;
		case 4: F1->RB0cntAt ->Checked = true; break;
		case 5: F1->RB1qre->Checked = true; break;
		case 6: F1->RB1qim->Checked = true; break;
		case 7: F1->RB1qq ->Checked = true; break;
		case 8: F1->RB1qa ->Checked = true; break;
		case 9: F1->RB1cntAt ->Checked = true; break;
		default:
			#ifdef wdebug
			pip ("InitPrgPar: Invalid default index: \n"
			"kmi(\"Graph2_RB_re_im_qa_qq_cntAt_12\")="
			+ AS(cp.kmi("Graph2_RB_re_im_qa_qq_cntAt_12")));
			#endif
			break;
	}
}


void CalcAndShowGraph2d(bool call_from_rb)
{
	//meld ("sizeof(G2Par) =" + AS(sizeof(G2Par)));
	
	if (call_from_rb)
		cp.UpdateConfigFromGraph2RB();
	else
		if (Graph2_deviating_RB_state())
		{
			UpdateGraph2RB();
			//because with this RB-State changes,
			//OnClick and with this CalcAndShowGraph2d(true); is executed
			//therefore, to avoid double plotting:
			return;
		}
	
	G2Par *gr2par = new(nothrow) G2Par;
	if (gr2par==NULL)
	{
		pip("Allocation of "+FS(sizeof(G2Par)/1000000)+" MB not possible,\n"
		"not enough free memory");
		return;
	}
	
	//trf:
	F1->Gimage2->Width=F1->Graph2->Width - F1->Gimage2->Left;
	F1->Gimage2->Height=F1->Graph2->Height - F1->Gimage2->Top;
	
	resize_bitmap_image(F1->Gimage2, F1->Gimage2->Width, F1->Gimage2->Height);
	
	gr2par->Calc_v_from_lgl();
	gr2par->DrawGimage2FromQuantities();
	
	delete(gr2par);
}
void __fastcall TF1::Graph2Show(TObject *Sender)
{CalcAndShowGraph2d(false); }
//---------------------------------------------------------------------------

void __fastcall TF1::FormResize(TObject *Sender)
{
	if (F1->PaCo->ActivePage == F1->Graph1)
		gr1par.UpdateAndShowGraph1(true);
	else
		if (F1->PaCo->ActivePage == F1->Graph2)
			CalcAndShowGraph2d(false);
}
//---------------------------------------------------------------------------

void __fastcall TF1::RB0qreClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB0qimClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB0qqClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB1qreClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB1qimClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB1qqClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB0qaClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB1qaClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB0cntAtClick(TObject *Sender)
{CalcAndShowGraph2d(true);}
void __fastcall TF1::RB1cntAtClick(TObject *Sender)
{CalcAndShowGraph2d(true);}

//Graph2a g2a:
//---
void __fastcall TF1::Slg2aDrawCell(TObject *Sender, int ACol, int ARow,
TRect &Rect, TGridDrawState State)
{
	SLDrawCell(Sender, ACol, ARow, Rect, State, Slg2a, false);
}
//---------------------------------------------------------------------------
void G2aTransferPar::init(int nyabs)
{
	for (int i=1;i<nyabs;++i)
		iym[i]=plot_not;
	if (nyabs)
		iym[nyabs-1]=plot_red;
	iym[0]=plot_blue;
}

void __fastcall TF1::Button_g2a_nyClick(TObject *Sender)
{
	Kmapi it = cp.kmap.find("Graph2a_ny");
	if (it == cp.kmap.end())
	{
		pip ("Button_g2a_nyClick: Key not found");
		return;
	}
	
	MMI mmi=it->second;
	Input_i_of_mmi_1(mmi,"Input ny",
	"Graph 2 mode is dependent of ny:\n"
	"ny <0: Curves along x for many y,\n  frontal curve 1 in y_min\n"
	"ny >0: Curves along x for many y,\n  frontal curve 1 in y_max\n"
	"ny==0: 2d graph along x and y\n\n"
	"To set ny to a new integer i");
	if (mmi.i==it->second.i)
		return;
	
	it->second.i=mmi.i;
	g2at.init(mmi.i);
	CalcAndShowGraph2d(false);
}
//---------------------------------------------------------------------------


void G2Par::PlotMultiple1DGraphsOnGimage2()
{
	int ny=cp.kmi("Graph2a_ny");
	int nyabs;
	int g2a_ycoo[nyabs_max];//list of ycoos for multiple 1d g2a graph
	bool upwards;
	if (ny==0)
	{
		pip("PlotMultiple1DGraphsOnGimage2: ny==0");
		return;
	}
	if (ny>0)
	{
		upwards=true;
		nyabs=ny;
	}
	else
	{
		upwards=false;
		nyabs=-ny;
	}
	
	if (nyabs>nyabs_max)
	{
		pip("PlotMultiple1DGraphsOnGimage2: nyabs>nyabs_max");
		return;
	}
	SetGraph2VisibleTo(false,true);
	
	//init stepdata along y:
	int iycoofirst=iycoominmax[immin]+ixy_minborder;
	int iycoolast=iycoominmax[immax]-ixy_minborder;
	int i;
	int dycoo=iycoolast-iycoofirst;
	if (dycoo+1<nyabs)
		nyabs=dycoo+1;
	F1->Slg2a->RowCount=nyabs+1;
	F1->Slg2a->Cells[0][0]="";
	F1->Slg2a->Cells[1][0]="y = "
	+ DimNumString(s1p.ta[s1p.ita].icoo_along_y_in_g2[isu_akt]);
	
	if (nyabs==1)
		g2a_ycoo[0]=upwards?iycoolast:iycoofirst;
	else
	{
		if (upwards)
			for (i=0;i<nyabs;++i)
				g2a_ycoo[nyabs-1-i]=iycoofirst+(i*dycoo)/(nyabs-1);
			else
				for (i=0;i<nyabs;++i)
					g2a_ycoo[i]=iycoofirst+(i*dycoo)/(nyabs-1);
	}
	
	for (i=1;i<=nyabs;++i)
	{
		F1->Slg2a->Cells[0][i]=AS(i);
		if (g2at.iym[i-1]==plot_not)
			F1->Slg2a->Cells[1][i]=AS(g2a_ycoo[i-1]);
		else
			if (g2at.iym[i-1]==plot_blue)
				F1->Slg2a->Cells[1][i]=AS(g2a_ycoo[i-1])+"b";
			else //(g2at.iym[i-1]==plot_red)
			F1->Slg2a->Cells[1][i]=AS(g2a_ycoo[i-1])+"r";
	}
	
	//graph:
	double ydiff = vmm[immax] - vmm[immin];
	double yborder = double(cp.kmi("Graph_y_border_percent"))/100.0 * ydiff;
	//world frontiers: x from x0 to x1, y from y0 to y1
	double x0, x1, y0, y1;
	//Interface:
	y1 = vmm[immax] + yborder;
	y0 = vmm[immin] - yborder;
	x0 = double(ixcoominmax[immin]);
	x1 = double(ixcoominmax[immax]);
	
	int dypixpp;
	if (nyabs>1)
	{
		int dypixppmax=cp.kmi("Graph2a_max_dypix_per_plot");
		dypixpp=(vpixcount*cp.kmi("Graph2a_max_dypix_percent")/100)/(nyabs-1);
		if  (dypixpp>dypixppmax)
			dypixpp=dypixppmax;
		y1+=(y1-y0)*(double(vpixcount)/double(vpixcount-dypixpp*(nyabs-1)) - 1);
	}
	else
		dypixpp=0;
	
	if (cp.kmi("Graph_Gridlines_Auto"))
	{
		RoundUp1Decimalp_1(y1, ydiff);
		RoundDown1Decimalp_1(y0, ydiff);
	}
	
	ClearImage(F1->Gimage2, false);
	gpar.DrawGrid(F1->Gimage2, false, hpixcount, vpixcount, x0, x1, y0, y1);
	
	int hpix, py,iy_akt,vpix;
	TColor color;
	bool barsvertical = cp.kmi("Graph_BarsEdgesVertical");
	
	//plotting loop:
	for (iy_akt = nyabs-1; iy_akt>=0;--iy_akt)
		if (g2at.iym[iy_akt]!=plot_not)
		{
			vpix = int(ypix_per_icoo * (g2a_ycoo[iy_akt] - iycoominmax[immin]));
			color=(g2at.iym[iy_akt]==plot_blue)?clBlue:clRed;
			F1->Gimage2->Canvas->Pen->Color = color;
			
			if (barsvertical)
				for (hpix = 0; hpix < hpixcount; hpix++)
				{
					py = y_Screen(q[hpix][vpix],y0, y1, vpixcount)-dypixpp*iy_akt;
					if (hpix == 0) F1->Gimage2->Canvas->MoveTo(hpix, py);
					else
					{
						F1->Gimage2->Canvas->LineTo(hpix, py);
						F1->Gimage2->Canvas->LineTo(hpix+1, py);
					}
				}
				else
					for (hpix = 0; hpix < hpixcount; hpix++)
					{
						py = y_Screen(q[hpix][vpix],y0, y1, vpixcount);
						if (hpix == 0) F1->Gimage2->Canvas->MoveTo(hpix, py);
						else         F1->Gimage2->Canvas->LineTo(hpix+1, py);
					}
		}
}

void __fastcall TF1::Slg2aClick(TObject *Sender)
	//blue coloring toggle
{
	g2at.iym[Slg2a->Row-1]= g2at.iym[Slg2a->Row-1]==plot_blue? plot_not:plot_blue;
	CalcAndShowGraph2d(false);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Slg2aDblClick(TObject *Sender)
	//red coloring on
{
	g2at.iym[Slg2a->Row-1]=plot_red;
	CalcAndShowGraph2d(false);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Slg2aMouseDown(TObject *Sender,
TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button==mbRight)
	{
		MMI mmi;
		mmi.i = plot_blue;
		mmi.min=plot_not;
		mmi.max=plot_red;
		if (Input_i_of_mmi_1(mmi,"select or unselect all",
		"Choose selection mode i:\n"
		"i="+AS(plot_not)+" will unselect all\n"
		"i="+AS(plot_blue)+" will plot all in blue\n"
		"i="+AS(plot_red)+" will plot all in red\n\n"))
		{
			int nyabs=abs(cp.kmi("Graph2a_ny"));
			for (int j=0;j<nyabs;++j) g2at.iym[j]=mmi.i;
			CalcAndShowGraph2d(false);
		}
	}
}
//---------------------------------------------------------------------------
//------- Sllist:

void SllistPar::Fill_Sllist_AfterScrollBy(int scrollrows)
{
	Lmapi it=lgl.lmap.lower_bound(lkcurrent);
	int i;
	if (scrollrows<0)
		for (i=0; i>scrollrows && it!=lgl.lmap.begin();--i)
		{ --it; --itolkcurrent; }
		else
			if (scrollrows>0)
			{
				for (i=0; i<scrollrows && it!=lgl.lmap.end();++i)
				{ ++it; ++itolkcurrent; }
				if (it==lgl.lmap.end())
				{ --it; --itolkcurrent; }
			}
	lkcurrent=it->first;
	Fill_Sllist_Ab_Lkcurrent(false);
}

void SllistPar::Fill_Sllist_Ab_Lkcurrent(bool update_itolkcurrent)
{
	F1->Sllist->RowCount=999;//much more than visible
	F1->Sllist->RowCount=1+F1->Sllist->VisibleRowCount;
	Lmapi it=lgl.lmap.lower_bound(lkcurrent);
	Lmapi itloop;
	
	if (update_itolkcurrent)//needs some time, therefore if...
	{
		itolkcurrent=1;
		for (itloop=lgl.lmap.begin(); itloop != it; ++itloop) ++itolkcurrent;
	}
	
	//avoid scrolling into empty trailing rows
	int irow;
	for (irow=2,itloop=it;irow<F1->Sllist->RowCount;++irow)
		if (itloop==lgl.lmap.end())
		{
			if (it!=lgl.lmap.begin())
			{--it;--itolkcurrent;}
		}
		else
			++itloop;
	lkcurrent=it->first;
	
	int i;
	for (irow=1; irow < F1->Sllist->RowCount; ++irow)
	{
		if (it != lgl.lmap.end())
		{
			F1->Sllist->Cells[1][irow] = AS(it->second);
			F1->Sllist->Cells[0][irow] = AS(itolkcurrent+irow-1);
			for (i = 0; i < MaxDimCount; ++i)
				F1->Sllist->Cells[2+sl_irow(i)][irow] = AS(it->first.coo[i]);
			++it;
		}
		else
			for (i = 0; i < F1->Sllist->ColCount; ++i)
				F1->Sllist->Cells[i][irow] = NullString;//necessary
	}
}

void __fastcall TF1::LatticeListShow(TObject *Sender)
{
	sllp.Fill_Sllist_Ab_Lkcurrent(true);
	Sllist->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF1::SllistDrawCell(TObject *Sender, int ACol, int ARow,
TRect &Rect, TGridDrawState State)
{
	SLDrawCell(Sender, ACol, ARow, Rect, State, Sllist, false);
}
//---------------------------------------------------------------------------

void __fastcall TF1::SllistMouseDown(TObject *Sender,
TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button == mbRight)
	{
		int a;
		if (Input_a_1(a, "New list start",
		"To display lattice listing\nbeginning with n_start = a"))
		{
			lkmin.coo[nlike] = a;
			sllp.lkcurrent=lkmin;
			sllp.Fill_Sllist_Ab_Lkcurrent(true);
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TF1::SllistKeyDown(TObject *Sender, WORD &Key,
TShiftState Shift)
{
	switch (Key)
	{
		case 33://pgup
			if (Shift.Contains(ssCtrl))
			{
				lkmin.coo[nlike] = lcoomin;
				sllp.lkcurrent=lkmin;
				sllp.Fill_Sllist_Ab_Lkcurrent(true);
			}
			else
				sllp.Fill_Sllist_AfterScrollBy(1-Sllist->VisibleRowCount);
			break;
		case 34://pgdown
			if (Shift.Contains(ssCtrl))
			{
				lkmax.coo[nlike] = lcoomax;
				sllp.lkcurrent=lkmax;
				sllp.Fill_Sllist_Ab_Lkcurrent(true);
			}
			else
				sllp.Fill_Sllist_AfterScrollBy(-1+Sllist->VisibleRowCount);
			break;
		case 38://arrow up
			sllp.Fill_Sllist_AfterScrollBy(-1);
			break;
		case 40://arrow down
			sllp.Fill_Sllist_AfterScrollBy(1);
			break;
		default:
			break;
	}
}
//---------------------------------------------------------------------------

void __fastcall TF1::LatticeListResize(TObject *Sender)
{
	sllp.Fill_Sllist_Ab_Lkcurrent(false);
}
//---------------------------------------------------------------------------
//----- Algadd Table Menu
void __fastcall TF1::Button_aat_CopyTableClick(TObject *Sender)
{
	MMI mmi;
	mmi.i = aav.aanr;
	mmi.min=0;
	mmi.max=Algadd_TableCount - 1;
	if (Input_i_of_mmi_1(mmi,"Copy Algadd Table",
	"To copy current Algadd table "+AS(aav.aanr)
		+"\nto Algadd table index i\n"
		"and then change Algadd table index to i"))
	{
		aav.CopyTable2to1(mmi.i, aav.aanr);
		aav.aanr = mmi.i;
		cp.setkmi_1("Algadd_DefaultTableIndex", aav.aanr);
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
	}
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_EraseTableClick(TObject *Sender)
{
	aav.InitEntriesOfTable(aav.aanr); //del table
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
}
//---------------------------------------------------------------------------



void __fastcall TF1::Button_aat_MultiplyAll_pClick(TObject *Sender)
{
	cotyp c;
	if (Input_cotyp_1(c, "Multiply all p",
	"To multiply all p of Algadd "+AS(aav.aanr)
		+"\n by a number c"))
	{
		for (int i = 0; i < Algadd_EntryCount; ++i) aav.ae[aav.aanr][i].p *= c;
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
	}
}

void __fastcall TF1::Button_aat_Mult_all_pabsnot1Click(TObject *Sender)
{
	cotyp c;
	if (Input_cotyp_1(c, "Multiply all p",
	"To multiply all p with |p|!=1\n of Algadd "+AS(aav.aanr)
		+"\n by a number c"))
	{
		for (int i = 0; i < Algadd_EntryCount; ++i)
			if (abs2(aav.ae[aav.aanr][i].p)!=1)
				aav.ae[aav.aanr][i].p *= c;
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
	}
}
//---------------------------------------------------------------------------
void __fastcall TF1::Button_aat_MultiplySelected_pClick(TObject *Sender)
{
	cotyp c;
	int i0=aav.imm_selected_entries[immin];
	int i1=aav.imm_selected_entries[immax];
	if (Input_cotyp_1(c, "Multiply selected p",
	"All p of entries "+AS(i0)+"..."+AS(i1)+" are selected.\n"
	"To multiply the selected p of Algadd "+AS(aav.aanr)
		+"\n by a number c"))
	{
		for (int i = i0; i <= i1; ++i) aav.ae[aav.aanr][i].p *= c;
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
	}
}


void __fastcall TF1::Button_aat_SetSelected_pClick(TObject *Sender)
{
	cotyp c;
	int i0=aav.imm_selected_entries[immin];
	int i1=aav.imm_selected_entries[immax];
	if (Input_cotyp_1(c, "Set selected p",
	"All p of entries "+AS(i0)+"..."+AS(i1)+" are selected.\n"
	"To set the selected p of Algadd "+AS(aav.aanr)
		+"\n to a number c"))
	{
		for (int i = i0; i <= i1; ++i) aav.ae[aav.aanr][i].p = c;
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
	}
}

void __fastcall TF1::Button_aat_Select_pClick(TObject *Sender)
{
	int a=aav.imm_selected_entries[immin];
	int b=aav.imm_selected_entries[immax];
	if (Input_ab_2(a, b, "Select p",
	"To select p of entries with entry number a<=n<=b"))
	SetAlgaddEntrySelection(a,b);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_ChooseNrClick(TObject *Sender)
{
	ChangeAlgaddNrClick(Sender);
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_CopyEntryClick(TObject *Sender)
{
	int i_source=SlAlgadd->Col-1;
	MMI mmi;
	mmi.i = i_source;
	mmi.min=0;
	mmi.max=Algadd_EntryCount - 1;
	if (Input_i_of_mmi_1(mmi,"Copy Algadd Entry",
	"To copy current Algadd entry "+AS(i_source)
		+"\nto Algadd entry i\n"))
	{
		aav.ae[aav.aanr][mmi.i]=aav.ae[aav.aanr][i_source];
		aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
	}
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_EraseEntryClick(TObject *Sender)
{
	aav.ae[aav.aanr][SlAlgadd->Col-1]=aav.ae_empty;
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_RemoveEntryClick(TObject *Sender)
{
	for (int i = SlAlgadd->Col; i < Algadd_EntryCount; ++i)
		aav.ae[aav.aanr][i-1] = aav.ae[aav.aanr][i];
	aav.ae[aav.aanr][Algadd_EntryCount-1] = aav.ae_empty;
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_RemoveTableClick(TObject *Sender)
{
	for (int i = aav.aanr+1; i < Algadd_TableCount; ++i)
		aav.CopyTable2to1(i-1,i);
	aav.InitEntriesOfTable(Algadd_TableCount-1);
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_InsertTableClick(TObject *Sender)
{
	bool DoInsertion=true;
	
	if (aav.UsedEntryCount(Algadd_TableCount-1))
		DoInsertion=YesToQuestion("Insertion will cause deletion\n"
		"of last nonempty table "+AS(Algadd_TableCount-1)
			+"\nDo you want to proceed?");
	
	if (DoInsertion)
	{
		for (int i = Algadd_TableCount-1; i > aav.aanr; --i)
			aav.CopyTable2to1(i,i-1);
		aav.InitEntriesOfTable(aav.aanr);
	}
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_InsertEntryClick(TObject *Sender)
{
	bool DoInsertion=true;
	
	if (!AlgaddEntriesEqual(aav.ae[aav.aanr][Algadd_EntryCount-1],aav.ae_empty))
		DoInsertion=YesToQuestion("Insertion will cause deletion\n"
		"of last nonempty entry "+AS(Algadd_EntryCount-1)
			+"\nDo you want to proceed?");
	
	if (DoInsertion)
	{
		int insertpos=SlAlgadd->Col-1;
		for (int i = Algadd_EntryCount-1; i > insertpos; --i)
			aav.ae[aav.aanr][i] = aav.ae[aav.aanr][i-1];
		aav.ae[aav.aanr][insertpos] = aav.ae_empty;
	}
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_RenumberEntriesClick(TObject *Sender)
{
	aav.CompressEntry(aav.aanr);
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_RenumberTablesClick(TObject *Sender)
{
	int i, j;
	
	for (j = 0, i = 0; i < Algadd_TableCount; ++i)
		if (aav.UsedEntryCount_After_Compression(i))
		{aav.CopyTable2to1(j,i); ++j;}
	for (; j < Algadd_TableCount; ++j)
		aav.InitEntriesOfTable(j);
	aav.IfVisibleUpdateSlAlgaddFromAlgaddVar_1 (F1->SlAlgadd);
}
//---------------------------------------------------------------------------

void __fastcall TF1::Button_aat_CloseClick(TObject *Sender)
{
	CloseGroupBox_aat();
}
//---------------------------------------------------------------------------
//----partially delete of last row:
struct Vlk //Sort along Vlk
{
	ratyp qq;//absolute square of q (or - abs in SearchComb9, sort criterium
	Lk lk;//corresponding key, less important criterium, to distinguish
};

struct Vlk1LessVlk2{
	bool::operator() (const Vlk& vlk1, const Vlk& vlk2) const;
};

bool Vlk1LessVlk2::operator() (const Vlk& vlk1, const Vlk& vlk2) const
{
	if (vlk1.qq==vlk2.qq)
	{
		int i = 0;
		while (i < MaxDimCount - 1 && vlk1.lk.coo[i] == vlk2.lk.coo[i])
		{++i; }
		return vlk1.lk.coo[i] < vlk2.lk.coo[i];
	}
	else
		return vlk1.qq<vlk2.qq;
}

typedef map < Vlk, bool, Vlk1LessVlk2 > Vlkmap;//map sorted along qq
typedef Vlkmap::iterator Vlkmapi;
typedef pair < Vlk, bool > Vlkpair;//bool=dummy


void Delete_smallest_percent_of_nlastRow_in_lmap(int delpercent)
{
	int nlast;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast, lgl.lmap)) return;
	
	const static dstep=10000;
	
	Vlkmap vlkm; //sorted along qq...
	Vlkpair vlkp;
	Lmapi lobound,it;
	lobound = LoBound(lgl.lmap, nlast);
	
	int nlastrow_size=0;
	for (it = lobound; it != lgl.lmap.end(); ++it) ++nlastrow_size;
	TColor oldcolor=F1->ShowProgressGroupbox->Color;
	F1->ShowProgressGroupbox->Color=clGray;
	probar pb(0, nlastrow_size);
	int ecount=0;
	
	for (it = lobound; it != lgl.lmap.end(); ++it)
	{
		if (!(++ecount%dstep))
		{
			F1->Caption = "n=nlast=" + AS(nlast)
				+": Sorting entry " + AS(ecount)
					+" of "+AS(nlastrow_size);
			pb.SetProgressBarPosition(ecount);
		}
		
		vlkp.first.qq=abs2(it->second);
		vlkp.first.lk=it->first;
		vlkm.insert(vlkp);
	}
	
	int delcnt=int(double(delpercent)/100.0 * double(vlkm.size()));
	Vlkmapi vlki;
	for (vlki = vlkm.begin(), ecount=0; ecount<delcnt; ++vlki)
	{
		if (!(++ecount%dstep))
		{
			F1->Caption = "n=nlast=" + AS(nlast)
				+": Deleting entry " + AS(ecount)
					+" of "+AS(delcnt);
			pb.SetProgressBarPosition(ecount);
		}
		lgl.lmap.erase(vlki->first.lk);
	}
	lgl.UpdateSlqFromLgl_1 (F1->Slq);
	
	SetF1Caption(NullString);
	F1->ShowProgressGroupbox->Color=oldcolor;
}

void __fastcall TF1::Delete_smallest_of_nlastClick(TObject *Sender)
{
	int nlast;
	if (!SizeofLm_Calc_nlast_Msg_if_Empty_1(nlast, lgl.lmap)) return;
	MMI mmi;
	mmi.i = cp.kmi("DelSmallPercent_Default");
	mmi.min=0;
	mmi.max=100;
	if (Input_i_of_mmi_1(mmi,"Partial Deletion of Row nlast="+AS(nlast),
	"To continue branching algorithms\n"
	"without too much memory consumption\n"
	"it can be necessary to delete those lattice points of the\n"
	"last row, which have the smallest absolute quantities\n\n"
	"To delete i percent of last row\n"
	"with smallest absolute quantities"))
	Delete_smallest_percent_of_nlastRow_in_lmap(mmi.i);
}
//---------------------------------------------------------------------------


void __fastcall TF1::QuickDelSmallestClick(TObject *Sender)
{
	Delete_smallest_percent_of_nlastRow_in_lmap(cp.kmi("DelSmallPercent_Default"));
}
//---------------------------------------------------------------------------

void __fastcall TF1::ConfigFileHintMenueClick(TObject *Sender)
{
	SetMainMenuCaptions();
	static AnsiString s="File for uniform configuration\n("
	+FnCfg+") ";
	if (FnCfgExists())
		meld(s+"exists.");
	else
		meld(s+"is not existent.");
}

//---------------------------------------------------------------------------
const AnsiString s_declaration_for_uniform_configuration_file=
"The filename\n   "
+FnCfg+
"\nis reserved as uniform default configuration.\n\n"
"If this file exists in the current directory,\n"
"configuration entries marked by \"u\"\n"
"will be read automatically\n"
"from it after after every input of another file\n"
"as uniform default.\n\n";


void __fastcall TF1::SaveCfgClick(TObject *Sender)
{
	if (YesToQuestion(
	s_declaration_for_uniform_configuration_file+
	"Do you want to save current configuration as\n"
	"uniform default in   "
	+FnCfg+"?"))
	cp.SaveDataToFile(FnCfg, false);
	SetMainMenuCaptions();
}

void __fastcall TF1::SaveCfgQuicklyClick(TObject *Sender)
{
	cp.SaveDataToFile(FnCfg, false);
	SetMainMenuCaptions();
}
//---------------------------------------------------------------------------

void __fastcall TF1::DelCfgFileClick(TObject *Sender)
{
	if (YesToQuestion(
	s_declaration_for_uniform_configuration_file+
	"Do you want to delete this file, so that complete\n"
	"configuration saved in individual files is used?"))
	if (remove(FnCfg.c_str()) != 0 && errno==EACCES)//if not existent, ignore it
	pip(FnCfg + " not removed, access forbidden.");
	SetMainMenuCaptions();
}
//---------------------------------------------------------------------------
void __fastcall TF1::CmdClick(TObject *Sender)
{
	QuickDelSmallest->Caption="dto for "
	+AS(cp.kmi("DelSmallPercent_Default"))+" percent";
}
//---------------------------------------------------------------------------


//----- begin of combsearch= search of fitting combinations with sum=1

const int cnummax=70000;//i_numsearcharr_max, optimized for speed
const int cdenmax=100;
typedef int_cden[cdenmax+1];

class SumNoteClass
{
	int_cden j_near[combtest_nscntmax];
	int_cden sign_near[combtest_nscntmax];
	int_cden sign_plus;
	double fabsdev[combtest_nscntmax];//fabs of last deviation, greater deviations have greater indices
	int iup_of_comb;
	bool cp_show_only_incdev;
	double count_of_comparisons_with_one;
	int nscnt;
	
	public:
	
	SumNoteClass();
	void init(const int iup_in_comb_org);
	void NoteSumAndSignIfNearestOne
	(const double &csum,int_cden& j, int_cden& sign);
	void SumNoteClass::NoteSumIfNearestOne (const double &csum, int_cden& j)
	{NoteSumAndSignIfNearestOne(csum,j,sign_plus);}
	void WriteNearestCombTo_ofstream_1(
	ofstream& out, Lk ns_lmfirst[cnummax], bool squared_sum);
};

void SumNoteClass::init(const int iup_in_comb_org)
{
	nscnt=cp.kmi("Combtest1_nscnt");
	cp_show_only_incdev=cp.kmi("Combtest1_ShowOnlyIncDev");
	
	count_of_comparisons_with_one=0;
	for (int i=0; i<nscnt; ++i) fabsdev[i]=doublemax;
	iup_of_comb=iup_in_comb_org;
}

SumNoteClass::SumNoteClass()
{for (int iden=0;iden<cdenmax+1;++iden) sign_plus[iden]=1.0;}

void SumNoteClass::NoteSumAndSignIfNearestOne
(const double &csum,int_cden& j, int_cden& sign)
{
	++count_of_comparisons_with_one;
	if (fabsdev[nscnt-1]<=fabs(csum-1.0)) return;//usual case: quick return
	
	double fabsdev_current=fabs(csum-1.0);
	int i;
	for (i=nscnt-2; fabsdev[i]>fabsdev_current && i>=0; --i);//nscnt_1 already checked
	if (cp_show_only_incdev) if (fabsdev[i]==fabsdev_current)
		return; //if exactly the same, show no redundant (symmetric) alternatives
	
	++i;//restore to last pos with fabsdev[i]>fabsdev_current
	int isd, isd_, iden;//isd=i_scrolldestination
	for (isd=nscnt-1, isd_=nscnt-2; isd>i; --isd,--isd_)
	{
		fabsdev[isd]=fabsdev[isd_];//scroll up, forget last with greatest index=greatest deviation
		for (iden=0;iden<iup_of_comb;++iden)
		{
			j_near[isd][iden]=j_near[isd_][iden];
			sign_near[isd][iden]=sign_near[isd_][iden];
		}
	}
	
	fabsdev[i]=fabsdev_current;
	for (iden=0;iden<iup_of_comb;++iden)//insert new position and sign
	{
		j_near[i][iden]=j[iden];
		sign_near[i][iden]=sign[iden];
	}
}


void WriteLkShortenedToOut(ofstream& out, const Lk& lk)
{
	int j;
	for (j=MaxDimCount-1;j>6; --j)
		if ((lk.coo[sl_icoo(j)])!=0) break;
	
	int i_zeroes_follow=j;
	for (j = 0; j <=  i_zeroes_follow; ++j)
		out << lk.coo[sl_icoo(j)] << aspace;
	if (i_zeroes_follow<MaxDimCount-1) out << "0...";
}

void SumNoteClass::WriteNearestCombTo_ofstream_1(
ofstream& out, Lk ns_lmfirst[cnummax], bool squared_sum)
{
	const int swidth=9;
	bool only_positively_added_sums=true;
	int iden, isc;
	
	for (isc=0;isc<nscnt;++isc)
		if (fabsdev[isc]!=doublemax)
			for (iden=0;iden<iup_of_comb;++iden)
				if (sign_near[isc][iden]!=1) {only_positively_added_sums=false; break;}
	
	//if (squared_sum && !only_positively_added_sums) {pip("Nonsens add of +- squared quantities"); return;}
	
	AS splusminus=only_positively_added_sums? "positive " : "pm-";
	
	out  <<"\n*******\n\n"<< count_of_comparisons_with_one <<
	" tests of "<<splusminus<<"combinations of order "
	<<iup_of_comb<<"."<<endl;
	
	if (squared_sum) out<<"Sums of squares:\n";
	
	if (only_positively_added_sums)
		out<<"All nearest sums have positive sign pattern.\n\n"; else
		out<<"pm-combinations: plus-minus sign pattern "
		<<"of summation\n\n";
	
	for (isc=0;isc<nscnt;++isc)
		if (fabsdev[isc]!=doublemax)
		{
			out << isc <<": absdiff to 1.0 = "<<fabsdev[isc]<<endl;
			
			double sum=0, summand, sq;
			Lmapi it;
			for (iden=0;iden<iup_of_comb;++iden)
			{
				it = lgl.lmap.find(ns_lmfirst[j_near[isc][iden]]);
				//if (it == lgl.lmap.end()) {pip("key in ns_lmfirst not found!?"); return;}
				summand=it->second.real().florep();
				
				out<<(sign_near[isc][iden]==1? "+ ":"- ");
				
				if (squared_sum)
				{
					sq=summand*summand;
					out << FSS(sq) << "     (is sqr of " << FSS(summand);
					summand=sq;
				}
				else out <<FSS(summand) << "    (";
				
				out <<" = lmap[";
				WriteLkShortenedToOut(out, ns_lmfirst[j_near[isc][iden]]);
				out<<"])"<<endl;
				
				sum+=sign_near[isc][iden]*summand;
			}
			out<<"= " << FSS(sum)<<endl<<endl;
		}
}

void __fastcall TF1::SearchComb1Click(TObject *Sender)
{
	int cden, cnum;//comb_denominator, comb_numerator
	int ita=s1p.ita;
	const AS fncomb="wqpcomb.aa2";
	SumNoteClass snc, sncq;
	
	
	bool cp_show_sq=cp.kmi("Combtest1_ShowSquaredDev");
	int cp_warnmillions=cp.kmi("Combtest1_WarnMillions");
	
	if (!Input_ab_2(cnum, cden, "Search Combination",
	"Search combinations whose realpart sum is "
	"as near as possible to 1.0 and write results to\n"
	+fncomb+"\n\n"
	"To search those combinations up to order b<="+AS(cdenmax)+"\n"
	"within the a largest cden real parts of the\n"
	"quantities of subspace defined by\n"
	"Sums1 table "+AS(ita)+" (first ranges) \n"))
	return;
	
	if (cden<1||cnum<1){pip("cden and cnum should be positive"); return;}
	
	Vlkmap vm; //sorted along q for equal greyscale per fclimit[]
	Vlkmapi vi;
	Vlkpair vp;
	Lmapi it;
	
	int isu=0;
	for (it = lgl.lmap.begin(); it != lgl.lmap.end(); ++it)
	{
		//sums betweeen ta[ita].range[isu]:
		if (it->first.between(s1p.ta[ita].range[isu][immin], s1p.ta[ita].range[isu][immax]))
		{
			vp.first.qq=-fabs(it->second.real().florep());//reverse sort: lower indices have largest abs
			vp.first.lk=it->first;
			vm.insert(vp);
		}
	}
	
	bool check_all_of_s1=false;
	if (cnum>=vm.size()) {cnum=vm.size();//(*cnum_truncated*)
		check_all_of_s1=true;}
	
	if (cnum>cnummax)
	{cnum=cnummax; pip("Only "+AS(cnum)+" largest realparts can be considered");}
	if (cden>cnum) cden=cnum;
	if (cden==0) {pip("No combinations to test"); return;}
	if (cden>cdenmax){cden=cdenmax;
		pip("Only combinations up to order "+AS(cden)+" will be tested");}
	
	double ccsum=0, combcount;//ccsum=total count of pm-combinations (squared comb here not relevant)
	int i, cdtmp;
	try {
		for (cdtmp=1;cdtmp<=cden;++cdtmp)
			//for (cdtmp=cden;cdtmp<=cden;++cdtmp)//debug instead of above line
		{
			combcount=1;
			for (i=cnum-cdtmp+1; i<=cnum; ++i) combcount*=i;
			for (i=1; i<=cdtmp; ++i) combcount*=2.0/i;//*2 because of pm-combinations
			ccsum+=combcount;
	}}
	catch (...) {pip("Computer cannot handle so many combinations"); return;}
	
	F1->Caption = AS(cnum)+" over 1.."+AS(cden)+": "+FS(ccsum)+" pm-comb. to test";
	
	if (ccsum>cp_warnmillions*1.0e6)
		if (!YesToQuestion("Do you really want to test\n"
		+FS(ccsum)+" pm-combinations?")) return;
	
	double ns[cnummax];//for max computation speed
	double nsq[cnummax];
	Lk ns_lmfirst[cnummax];//adresses for backreference to lmap
	
	for (i=0, vi=vm.begin(); i<cnum; ++vi,++i)//vi!=vm.end() because of (*cnum_truncated*)
	{it = lgl.lmap.find(vi->first.lk);
		//if (it == lgl.lmap.end()) {pip("key in vi->first.lk not found!?"); return;}
		ns[i]=it->second.real().florep();
		nsq[i]=ns[i]*ns[i];
		ns_lmfirst[i]=it->first;
	}
	
	const double PbarResolution=1e6;
	int PbarMax=ccsum/PbarResolution;
	int PbarAct=0, PbarTestpos;
	probar pb(0, PbarMax);
	
	//write header:
	ofstream out;
	out.open(fncomb.c_str());
	
	AS sdate = DateTimeToStr(Now());
	out << sdate << " = T.M.J h:m:s\n" << fn << " = source, ";
	out << "lattice_point_count = "<<IntToStr(lgl.LmapSize()) << endl<<endl;
	out << "Searching for realpart-combinations whose sum is nearest to 1.0\n";
	out << "Testing sums of squared realparts and pm-sums of realparts\n";
	out << "scope: Sums1 Range1 table "<< ita <<" of "<< fn << "\n\n";
	out << "output: Respectively the "<<cp.kmi("Combtest1_nscnt")
		<<" best matches of the sums with 1.0\n";
	
	
	if (check_all_of_s1)
		out <<"Testing combinations up to order "+AS(cden)
			+" within all "<< cnum <<" Elements of S1" << endl;
		else
			out <<"Testing combinations up to order "+AS(cden)
				+" within the largest "<< cnum
				<<"\nelements of altogether "<< vm.size() << " elements of S1 Range1." << endl;
	
	out<< endl<< AS(cnum)+" over 1.."+AS(cden)
		+": "+FS(ccsum)+" pm-combinations to test\n";
	
	//now append sequentially results of search combinations 1..cden
	//consider also negative sign combinations of ns (not nsq)
	int_cden j;//arrax of indices of current combination, +1 because of (*cdakt*)
	int_cden sign_of_realpart;
	int cdakt, ij, iinc, isign, isigninc;
	bool further_comb_exist;
	double pmtestcount=0;
	bkc bk;
	bool breaksignaled=false;
	
	for (cdakt=1; cdakt<=cden && !breaksignaled; ++cdakt)
		//cdakt=cden;//only for debug
	{
		further_comb_exist=true;
		j[cdakt]=cnum;//jrightmax    (*cdakt*)
		iinc=cdakt;//for first overall restore to left comb
		sncq.init(cdakt); snc.init(cdakt);
		
		double cqsum, csum;
		while (further_comb_exist) //Algorithm tested and ok
		{
			for (ij=0; ij<iinc; ++ij) j[ij]=ij;//restore left comb part
			
			if (cp_show_sq)
			{
				for (cqsum=0.0,ij=0;ij<cdakt;++ij) cqsum+=nsq[j[ij]];
				sncq.NoteSumIfNearestOne(cqsum,j);
			}
			
			isigninc=cdakt+1;
			do {
				for (isign=0; isign<isigninc;++isign) sign_of_realpart[isign]=-1;
				
				for (csum=0.0,ij=0;ij<cdakt;++ij)
					csum+=ns[j[ij]]*sign_of_realpart[ij];
				
				snc.NoteSumAndSignIfNearestOne(csum,j,sign_of_realpart);
				++pmtestcount;
				
				for (isigninc=0; sign_of_realpart[isigninc]==1;) ++isigninc;
				sign_of_realpart[isigninc]+=2;
			} while (isigninc<cdakt);
			
			for (iinc=0; j[iinc]+1==j[iinc+1]; ++iinc)
				if (iinc+1==cdakt) {further_comb_exist=false; break;}
			
			++j[iinc];//increment comb
			
			PbarTestpos=pmtestcount/PbarResolution;
			if (!further_comb_exist || PbarAct<PbarTestpos)
			{
				PbarAct=PbarTestpos;
				F1->Caption = FSS(pmtestcount) +
				" of "+FS(ccsum)+" (of "+AS(cnum)+" over 1.."
				+AS(cden)+" pm-comb.) tested";
				pb.SetProgressBarPosition(PbarAct);
				if (bk.breaksignaled()) {breaksignaled=true;further_comb_exist=false; break;}
			}
		}
		out <<"\n###### Results of combinations of order "+AS(cdakt)+":\n";
		snc.WriteNearestCombTo_ofstream_1(out, ns_lmfirst, false);
		if (cp_show_sq) sncq.WriteNearestCombTo_ofstream_1(out, ns_lmfirst, true);
	}//inc cdakt
	
	if (breaksignaled) 	out<< " user break ! \n";
	out<< FS(pmtestcount)+" pm-combinations tested\n";
	
	#if 0
	pb.SetProgressBarPosition(PbarMax); out.close();
	meld ("Results written to file\n"+fncomb);
	#endif
	
	SetF1Caption(NullString);
}
//---------------------------------------------------------------------------
//begin cross product
void __fastcall TF1::CrossProductClick(TObject *Sender)
{
	int a, b, c;
	if (Input_abc_3(a, b, c,"Cross product",
	"Cross product calculation:\n"
	" w[coo] := u[coo]    X    v[coo+offset]\n"
	"coo are the location coordinates\n"
	"lattices 0,1,2 contain the components of vector u\n"
	"lattices 3,4,5 contain the components of vector v\n"
	"lattices 6,7,8 contain the components of vector w\n"
	" For calculation of the crossproducts of all \n"
	"coordinates using offset (a,b,c,0,0,0,...))","0,0,0"))
	lgl.CalcCrossProduct(a,b,c);
}

void Lgl::CalcCrossProduct(int k1offset, int k2offset, int k3offset)
{
	Lmap lm;
	Lpair lpu,lpv,lpw;// u=012, v=345, w=678
	Lmapi it;
	int latticenumber;
	int ecount, dstep = cp.kmi("Sums_EntryCountPerDisplay");
	probar pb(0, lmap.size(), "deleting lattices 6,7,8");
	
	//delete 6,7,8:
	for (ecount=0, it = lmap.begin(); it != lmap.end(); ++it)
	{
		if (!(++ecount%dstep)) pb.SetProgressBarPosition(ecount);
		latticenumber=it->first.coo[llike];
		//copy all except 6,7,8 which will contain result of crossproduct
		if (latticenumber<6 || latticenumber>8) lm.insert(*it);
	}
	//lmap.clear();//not necessary
	lmap=lm;
	
	int prev_lmapsize=lmap.size();
	pb.init(0, prev_lmapsize, "calculating cross products");
	
	//calc crossproduct, number after l.. represent lattice numbers:
	//cross([l0,l1,l2],[l3,l4,l5])
	//=[l1l5 - l2l4, l2l3 - l0l5, l0l4 - l1l3]
	// [      l6     ,       l7     ,       l8     ]
	for (ecount=0, it = lm.begin(); it != lm.end(); ++it)
		//use index of lm, because consideration
		//of new inserted values (of l6,l7,l8) not necessary
	{
		if (!(++ecount%dstep)) pb.SetProgressBarPosition(ecount);
		
		latticenumber=it->first.coo[llike];
		if (latticenumber>=0 && latticenumber<=2)
		{
			lpu.first = lpv.first = lpw.first = it->first;
			lpv.first.coo[1]+=k1offset;
			lpv.first.coo[2]+=k2offset;
			lpv.first.coo[3]+=k3offset;
			
			GetLpairQuantity_1 (lpu);
			
			if (latticenumber==0)
			{//l7-=l0l5
				lpv.first.coo[llike]=5;	GetLpairQuantity_1 (lpv);
				lpw.first.coo[llike]=7;	GetLpairQuantity_1 (lpw);
				lpw.second -= lpu.second * lpv.second;
				SetLpair (lpw);
				//l8+=l0l4
				lpv.first.coo[llike]=4;	GetLpairQuantity_1 (lpv);
				lpw.first.coo[llike]=8;	GetLpairQuantity_1 (lpw);
				lpw.second += lpu.second * lpv.second;
				SetLpair (lpw);
			}
			if (latticenumber==1)
			{//l6+=l1l5
				lpv.first.coo[llike]=5;	GetLpairQuantity_1 (lpv);
				lpw.first.coo[llike]=6;	GetLpairQuantity_1 (lpw);
				lpw.second += lpu.second * lpv.second;
				SetLpair (lpw);
				//l8-=l1l3
				lpv.first.coo[llike]=3;	GetLpairQuantity_1 (lpv);
				lpw.first.coo[llike]=8;	GetLpairQuantity_1 (lpw);
				lpw.second -= lpu.second * lpv.second;
				SetLpair (lpw);
			}
			if (latticenumber==2)
			{//l6-=l2l4
				lpv.first.coo[llike]=4;	GetLpairQuantity_1 (lpv);
				lpw.first.coo[llike]=6;	GetLpairQuantity_1 (lpw);
				lpw.second -= lpu.second * lpv.second;
				SetLpair (lpw);
				//l7+=l2l3
				lpv.first.coo[llike]=3;	GetLpairQuantity_1 (lpv);
				lpw.first.coo[llike]=7;	GetLpairQuantity_1 (lpw);
				lpw.second += lpu.second * lpv.second;
				SetLpair (lpw);
			}
		}
	}
	pb.RemoveProgressBar();
	UpdateSlqFromLgl_1 (F1->Slq);
	meld(AS(lmap.size()-prev_lmapsize)+" non-zero\n"
	"cross products calculated");
}
//end cross product

//---------------------------------------------------------------------------
void __fastcall TF1::USClick(TObject *Sender)
{
	UF1->Show();
}
//-------------------------------------------------------------------------

void __fastcall TF1::ChooseActivePageClick(TObject *Sender)
{
	MMI mmi;
	mmi.i = PaCo->ActivePageIndex;
	mmi.min=0;
	mmi.max=PaCo->PageCount-1;
	if (Input_i_of_mmi_1(mmi,"Page hotkey","To quickly select active page"))
		PaCo->ActivePageIndex = mmi.i;
}
//---------------------------------------------------------------------------

void Lgl::InitAreaRoundZeroWithPm1()
{
	int border_maxcoo=cp.kmi("N0iniarea_maxcoo");
	int border_round=cp.kmi("N0iniarea_square_round");
	int n0dimcount=cp.kmi("N0iniarea_dimcount");
	int kdelta=cp.kmi("N0iniarea_stepdist");
	int sign_alternation=cp.kmi("N0iniarea_sign_alternation");
	
	int k1max,k2max,k3max;
	k1max=border_maxcoo;
	k2max=k3max=0;
	AS sdim;
	switch (n0dimcount) {
		case 1:sdim="along coordinate k1 (resp x)"; break;
		case 2:sdim="along coordinates k1,k2 (resp x,y)"; k2max=border_maxcoo; break;
		case 3:sdim="along coordinates k1,k2,k3 (resp x,y,z)"; k2max=k3max=border_maxcoo; break;
	}
	AS salt;
	switch (sign_alternation) {
		case 0:salt="1"; break;
		case 1:salt="+-1 (sign alternation when crossing k1 = x = 0)"; break;
		case 2:salt="+-1 (sign alternation when crossing k1,k2 = x,y = 0)"; break;
		case 3:salt="+-1 (sign alternation when crossing k1,k2,k3 = x,y,z = 0)"; break;
		case 4:salt="-1 when k1+k2+k3 = x+y+z is odd, else with +1"; break;
	}
	AS srq=border_round?"round":"square";
	
	if (!YesToQuestion("According to the options N0iniarea_... a "
	+srq+" area with max. border distance "
	+AS(border_maxcoo)+" from zero will be initializated "
	+sdim+" with "+salt+". The stepping distance is "+AS(kdelta)+
	".\n\nDo you want this?")) return;
	
	int k1,k2,k3,inicount=0;
	size_type lsiz;
	double mem_break, mem_occupied;
	mem_break = 1000.0*cp.kmi("MaxAllowedMemOccupationInKB");
	
	lmap.clear();
	cp.InitPrgParAndSlconfig(false);
	Lpair lpair;
	lpair.first = lkzero;
	double k1d,k2d,k3d,boraq;//double for preventing overflow
	boraq=double(border_maxcoo)*double(border_maxcoo);
	
	
	for (k3=-k3max; k3<=k3max; k3+=kdelta){lpair.first.coo[3] = k3;
		for (k2=-k2max; k2<=k2max; k2+=kdelta){lpair.first.coo[2] = k2;
			for (k1=-k1max; k1<=k1max; k1+=kdelta)
			{lpair.first.coo[1] = k1; k1d=k1; k2d=k2; k3d=k3;
				
				switch (sign_alternation)
				{
					case 0:
						lpair.second = 1;
						break;
						
					case 1:
						if (k1==0) lpair.second = 0; else lpair.second = k1>0?1:-1;
						break;
					case 2:
						if (k1==0 || k2==0) lpair.second = 0;
						else lpair.second = k1d*k2d>0 ? 1 : -1;
						break;
					case 3:
						if (k1==0 || k2==0 || k3==0) lpair.second = 0;
						else lpair.second = k1d*k2d*k3d>0 ? 1 : -1;
						break;
					case 4: lpair.second = (k1+k2+k3) % (2*kdelta) ? 1 : -1;
						break;
				}
				
				if (!border_round) SetLpair (lpair); else
					if (k1d*k1d + k2d*k2d + k3d*k3d <= boraq)
						SetLpair (lpair);
				
				if (++inicount % 100)
				{
					lsiz = lgl.LmapSize();
					mem_occupied = double(lsiz)*LpairSize;
					if (mem_occupied > mem_break)  //if round border and great border_maxcoo, mem_occupied can grow slowly
					{
						SignalExceedingOf_MaxAllowedMemOccupationInKB();
						UpdateSldimSlqFromLgl ();
						return;
					}
	}}}}
	UpdateSldimSlqFromLgl ();
}

void __fastcall TF1::Initn0areaClick(TObject *Sender)
{
	lgl.InitAreaRoundZeroWithPm1();
}
//---------------------------------------------------------------------------

